/*
	memo
	pile bunker/missile launcher ˎ͌ɉ𐁂
	L[zuύXo悤ɂH

*/
#include <HPLDXLib.h>

#include "GStaticData.h"
#include "GGameScene.h"
#include <hpllib/system/HPLLogger.h>
#include <hpllib/general/HPLString.h>
#include <hpllib/system/HPLFile.h>
#include "GSelectStageScene.h"

#include "shlwapi.h"
#pragma comment(lib, "shlwapi.lib")
using namespace std;

using namespace GEnum;

string createNewCaptureFileName() {
	int nIndex = 0;
	string str; 
	while( true ) {
		str = HPLString::chrToStr( "Screen%05d.bmp", 
			nIndex );
		if( PathFileExists( str.c_str() ) ) {
			// exists
			nIndex ++;
			// continue
		} else {
			break;
		}
	}
	return str;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow )
{

	if( ChangeWindowMode( TRUE ) != DX_CHANGESCREEN_OK ) {
		// do nothing
	}
	getStaticData()->m_Save.setAsDefault();

	if( SetGraphMode( getStaticData()->getSetting()->windowWidth, 
		getStaticData()->getSetting()->windowHeight, 
		getStaticData()->getSetting()->bitPerPixel) != DX_CHANGESCREEN_OK )
	{
		// do nothing
	}

	if( DxLib_Init() == -1 ) {
		return -1;
	}
	if( SetWindowText("Evigen2 - Escape from Evil -") == FALSE ) {
		// do nothing
	}

	// 摜ǂݍ
	int nHandle = LoadGraph( "data/image/Loading-HowToPlay.PNG" );
	DrawGraph( 0,0,nHandle,FALSE );

	// Strings
	DrawString( getStaticData()->m_Setting.windowWidth - 150, getStaticData()->m_Setting.windowHeight - 100,
		"Loading...", 1);
	// `
	ScreenFlip();

	// ZbgAbv
	staticData.loadTexture();
	
	// wiւ̕`փZbg
	SetDrawScreen( DX_SCREEN_BACK );

	getStaticData()->m_TimeRecorder.start();

	// V[ݒ
	{
		getStaticData()->m_SceneManager.setScene( SceneType::TITLE );
//		getStaticData()->m_nPlayerPlaceIndex = 1;
		getStaticData()->startFadeOutDX( SceneType::GAME, 79 );
		// Z[uǂݍ
	}
	
	// ǂݍ񂾃[fBO摜j
	DeleteGraph( nHandle );


	int nTime = 0;						// EGCg^C}[

	while( staticData.m_bIsRunning ) {

		// ݂̃JEg
		nTime = GetNowCount();

		// L[͍XV
		getStaticData()->getInputManager()->update();
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::H ) ) {
			// the world
			getStaticData()->m_Game.setTheWorld( 
				!getStaticData()->m_Game.isTheWorld() );
		}
		ClearDrawScreen();

		// game range update
		getStaticData()->updateGameRange();

		// 
		getStaticData()->m_SceneManager.processScene();


		// ؂ւ
		if( getStaticData()->isFadingOutDX() ) {	//! ؂ւ
			getStaticData()->drawFadeOutDX();
		

			if( getStaticData()->processFadeOutDX( true ) == false) {	// tF[hAEg
				// tF[hAEg(傤ǍFɂȂu)


				GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
				// d
				switch( getStaticData()->getAfterFadeOutDXProcessType() ) {
				case AfterFadeOutDXProcessType::RESPAWN:

					{
						// hp 
						lpPlayer->setHP( lpPlayer->getHPMax() );

						// F߂
						lpPlayer->setPaletteIndex( 0 );
						// ߂
						lpPlayer->m_nWearState = WearStateType::NORMAL;

					}
					break;
				}
			}
		}


		ScreenFlip();

		if( ProcessMessage() != 0 || CheckHitKey( KEY_INPUT_LALT ) != 0 && CheckHitKey( KEY_INPUT_F4 ) != 0 ) {
			break;
		}

		static int nPreviousF2 = 0;
		int nCurrentF2 = CheckHitKey( KEY_INPUT_F2 );
		if( 0 != nCurrentF2 && 0 == nPreviousF2) {
			// ^Cg
			getStaticData()->m_SceneManager.setScene( SceneType::TITLE );

			// vC[^Cv
			GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
			lpPlayer->changeType( PlayerType::EVIGEN, NULL );

			// select stagẽCxgp
			GSelectStageScene* lpScene = ((GSelectStageScene*)getStaticData()->m_SceneManager.getScene( SceneType::SELECT_STAGE ));
			lpScene->setEffectType( SelectStarSceneEffectType::NONE );
		}
		nPreviousF2 = nCurrentF2;

		static int nPreviousScreen = 0;
		int nCurrentScreen = CheckHitKey( KEY_INPUT_F11 );
		if( 0 != nCurrentScreen && 0 == nPreviousScreen ) {
			// screen capture
			SaveDrawScreen(0,0,getStaticData()->m_Setting.windowWidth,getStaticData()->m_Setting.windowHeight,
				createNewCaptureFileName().c_str() );
		}
		nPreviousScreen = nCurrentScreen;


		while( GetNowCount() - nTime < 30 ) {
			Sleep(1);
		}

	}
	getStaticData()->m_TimeRecorder.stop();
	// save
	getStaticData()->m_OptionData.setPlayTime(
		getStaticData()->m_OptionData.getPlayTime() + getStaticData()->m_TimeRecorder.getElapseTime(false) );
	getStaticData()->m_OptionData.save();

	// achievement
	GAchievementItem* lpItem = getStaticData()->m_AchievementSave.getAchievementItem( AchievementType::PLAY_LONG );
	lpItem->setCounter( getStaticData()->m_TimeRecorder.getElapseTime(false) );
	getStaticData()->m_MixerManager.stopMusic();
	DxLib_End();

	return 0;
}
