#ifndef _G_ACHIEVEMENT_MANAGER_
#define _G_ACHIEVEMENT_MANAGER_

#include <hpllib/cycle/HPLObjectManager.h>
#include "GAchievement.h"

#include <vector>

/**
  */ 
class GAchievementData {
public:
	std::vector<std::string> m_vecDescriotions;	//! 
	int m_nMaxNum;								//! Max
	bool m_bIsResetOnStartStage;				//! Xe[WJnɃZbgiBj
	std::string m_strLabel;
	//std::vector<std::string> m_strComments
	int m_nCommentScenarioItemID;				//! Rg\p̃ViIID
												//! 	uRg͂܂v̌ŒViI\
public:
	GAchievementData() {
		this->clear();
	}
	~GAchievementData(){}
	void clear() {
		this->m_vecDescriotions.clear();
		this->m_nMaxNum = 0;
		this->m_bIsResetOnStartStage = false;
		this->m_nCommentScenarioItemID = -1;
		m_strLabel = std::string();
		
	}

};

/** уf[^Xg
  */
class GAchievementDataSet {
private:
	std::vector<GAchievementData> m_vecAchievementDatas;

public:
	GAchievementDataSet();
	~GAchievementDataSet(){}
public:
	std::vector<GAchievementData>& getAchievementDatas() {
		return (std::vector<GAchievementData>&)this->m_vecAchievementDatas;
	}
	GAchievementData& getAchievementData( int nIndex ) {
		return (GAchievementData&)this->m_vecAchievementDatas[nIndex];
	}

public:
	void load();
};

/** у}l[W
  */
class GAchievementManager : public HPLObjectManager<GAchievement> {
public:
	GAchievementDataSet m_AchievementDataSet;
	int m_nStackNumber;		//! ݂̐ςݏグ
public:
	GAchievementManager();
	virtual ~GAchievementManager(){}

public:

	/** 삳
	  */
	void process(bool bIsMove, bool bIsAI );
	void algorithm( GAchievement* lpAchievement );

	GAchievement* create( int nType );
};

#endif
