#include "GBGManager.h"

#include "GStaticData.h"

using namespace std;
using namespace GEnum;

static int MAPPING[][2] = {
	{Sequence::Common::SELECT_UNIVERSE_SPACE, Sequence::Common::SELECT_UNIVERSE_SPACE},
	{Sequence::Common::FOREST_BACK, Sequence::Common::FOREST_BACK},
	{Sequence::Common::BG_SEA, Sequence::Common::BG_SEA},
	{Sequence::Common::BG_VOLCANO, Sequence::Common::BG_VOLCANO},
	{Sequence::Common::BG_CLOUD, Sequence::Common::BG_CLOUD},
};

GBGManager::GBGManager(){
	//resetBGImage();
	getFadeOut()->stop();
}


GBGManager::~GBGManager(){
}

int GBGManager::getBGImage(){
	return bgImageNormal;

}
int GBGManager::getBGImageMini(){
	return bgImageMini;
}

void GBGManager::drawBG(){
	int seqID = this->getBGImage();//staticData->bgImageNormal;
	if(seqID < 0){
		// wi摜Ȃ
		//staticData->bgR = 0;
		//staticData->bgG = 0;
		//staticData->bgB = 0;
		/////
		//
		//staticData->clearScreen(staticData->bgR, staticData->bgG, staticData->bgB);
		return;
	}


/*		HPLVector leftTop = staticData->getObjectManager()->getPlayer()->getCenter();
	leftTop.set(leftTop.getX() + scroller->getVirtualRect().getX(),
		leftTop.getY() + scroller->getVirtualRect().getY());

	/////
	// ʏ̃vC[W

	
	HPLVector scrollPoint(
		scroller->getVirtualRect().getX(),
		scroller->getVirtualRect().getY());

	HPLVector scrPoint(
		0,
		0);

	bool isAdjust = true;

	// tag
	scroller->matchPoint(
		scrPoint, leftTop,
		isAdjust);*/

	// BG̃XN[
	HPLScroller* lpBGScroller = getStaticData()->getScrollManager()->getScroller(1);
	//getStaticData()->adjustScroll( scroller );

/*
	bool isAdjust = true;

	float pX = staticData->getObjectManager()->getPlayer()->getCenter().getX();
	float pY = staticData->getObjectManager()->getPlayer()->getCenter().getY();
	*/
	/*
	pX *= virtualSizeW / tileSizeW;
	pY *= virtualSizeH / tileSizeH;



	float winWidth = (float)staticData->getSetting()->windowWidth;
	float winHeight = (float)staticData->getSetting()->windowHeight;
	//float deltaX = imageWidth - staticData->getSetting()->windowWidth;
	//float deltaY = imageHeight - staticData->getSetting()->windowHeight;

*/
	// BG̑傫
	HPLRect rBGVirtualRect = lpBGScroller->getVirtualRect();// - ;

	// ^CXN[
	HPLScroller* lpTileScroller = getStaticData()->getScrollManager()->getScroller(0);
	// ^C͈̔
	HPLRect rTileRect = lpTileScroller->getVirtualRect();

	float fRateX = rBGVirtualRect.getWidth() / rTileRect.getWidth();
	float fRateY = rBGVirtualRect.getHeight() / rTileRect.getHeight();

	HPLVector vTargetCenter = lpTileScroller->m_CurrentVirtualCenter;

	HPLVector vBGTargetCenter(
		vTargetCenter.getX() * fRateX,
		vTargetCenter.getY() * fRateY );

	HPLVector scrPoint(
		getStaticData()->getSetting()->windowWidth / 2.f / lpTileScroller->m_fZoomRate,
		getStaticData()->getSetting()->windowHeight / 2.f / lpTileScroller->m_fZoomRate);

	// tag
	lpBGScroller->matchPoint(
		scrPoint, vBGTargetCenter,
		true);

	//float scrX = lpTileScroller->getVirtualRect().getX();
	//float scrY = lpTileScroller->getVirtualRect().getY();
	HPLRect rBGRect = lpBGScroller->getVirtualRect();
	//float left = ;
	float left = rBGRect.getX();
	float top = rBGRect.getY();
	
	
	/*if(virtualSizeW != imageWidth){
		left = scrX * (imageWidth - winWidth) / (virtualSizeW - winWidth);
		float pl = pX;
		if(pl >= winWidth
	}*/
		 
	//float top = scrY * (float)rBGVirtualRect.getHeight() / (float)rTileRect.getHeight();
	/*if(virtualSizeH != imageWidth){
		top = scrY * (imageWidth - winHeight) / (virtualSizeH - winHeight);
	}*/


	bool bIsSmaller = false;
	// 摜菬}bvł͌Œ肷
	if( rTileRect.getWidth() <= rBGVirtualRect.getWidth() ||
		rTileRect.getHeight() <= rBGVirtualRect.getHeight())
	{
		left = 0;
		top = 0;
		bIsSmaller = true;
		//seqID = this->getBGImageMini();
	}


	if( bIsSmaller ) {
		// k\
		int nHandle = getStaticData()->getImageHandle( 
			SpriteType::COMMON, seqID );
		DrawExtendGraph(0,0,
			getStaticData()->m_Setting.windowWidth,
			getStaticData()->m_Setting.windowHeight,
			nHandle, TRUE );
	} else {
		getStaticData()->m_Basic.m_Graphics.draw(
			left, top, 
			getStaticData()->getSequence(SpriteType::COMMON,
				seqID));
	}

}

void GBGManager::resetBGImage(){
	setBGImage(BGType::EVIL_STAR);
}
void GBGManager::setBGImage(int type){
	
	if(type == -1){
		bgImageNormal = -1;
		bgImageMini = -1;
		return;
	}
	bgImageNormal = MAPPING[type][0];
	bgImageMini = MAPPING[type][1];

	
	////
	// 傫̃TCY擾
	HPLSequence* seq = getStaticData()->getSequence(SpriteType::COMMON,
		bgImageNormal);
	HPLImageInformation* info = seq->getImageInformation(0);

	float w = info->srcRect.getWidth();
	float h = info->srcRect.getHeight();


	/////
	// w/hݒ
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(1);
	HPLRect vir = scroller->getVirtualRect();
	vir.setWidth(w);
	vir.setHeight(h);

	scroller->setVirtualRect(vir);


}


/** tF[hAEg`ʁXebvis
  */
void GBGManager::drawFadeOut(bool bIsStep) {
	if( this->m_FadeOut.isFading() ) {
		// alpha
		int nAlpha = this->m_FadeOut.getCurrentAlpha();

		// draw blend
		//getStaticData
		// color
		HPLColor col;
		this->m_FadeOut.getColor( col );

		// change color
		// \
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, nAlpha );
		DrawFillBox( 0,0,getStaticData()->m_Setting.windowWidth, getStaticData()->m_Setting.windowHeight,
			GetColor(col.r,col.g,col.b) );

		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );

		if( bIsStep ) {
			if( this->m_FadeOut.step() ) {	// step finished
				if( this->m_FadeOut.getEnd() == 0 ) {	// lighten
					this->m_FadeOut.stop();
				}
			}
		}
	}
}
