#include "GEventCheckScene.h"

#include "GStaticData.h"

#include "GEnum.h"
#include <hpllib/general/HPLString.h>

using namespace GEnum;
using namespace std;

GEventCheckScene::GEventCheckScene():AbstractScene() {
	this->m_nScenarioArrayIndex = 0;
}

GEventCheckScene::~GEventCheckScene() {
}
void GEventCheckScene::init() {
	if( this->m_vecScenarioIndexes.size() == 0 ) {
		// o^
		getStaticData()->m_EventPackManager.getIndexList( this->m_vecScenarioIndexes );
	}

}
void GEventCheckScene::quit() {
}
void GEventCheckScene::process() {
	// NA

	const int TEXT_TOP = 50;	// eLXggbv
	const int TEXT_INTERVAL_Y = 20;	// eLXgs
	// \
	const int HELP_LEFT = getStaticData()->m_Setting.windowWidth - 200;
	const int HELP_TOP = TEXT_TOP;
	DrawString( HELP_LEFT, HELP_TOP,
		"Ctrl + Left/Right\t:Change Scenario ID", GetColor(255,255,255));
	DrawString( HELP_LEFT, HELP_TOP + TEXT_INTERVAL_Y,
		"Left/Right\t:Change Item Index", GetColor(255,255,255));

	const int TEXT_LEFT = 50;
	// ݂̃ViIID\
	DrawString(
		TEXT_LEFT, TEXT_TOP, 
		HPLString::chrToStr("Scenario ID:[%d]", this->m_vecScenarioIndexes[this->m_nScenarioArrayIndex] ).c_str(),
		GetColor(255,255,255));

	if( getStaticData()->isFadingOutDX() ) {
		int nCtrl = (CheckHitKey( KEY_INPUT_LCONTROL ) || CheckHitKey( KEY_INPUT_RCONTROL ) ) ? 
			1: 0;
		int nDX = 0;
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::RIGHT ) ) {
			nDX = 1;
		} else if( getStaticData()->getInputManager()->isPressedNow( KeyMap::LEFT ) ) {
			nDX = -1;
		}

		if( nCtrl != 0 ) {
			// step scenario id
			this->m_nScenarioArrayIndex += nDX;
			int nMax = (int)this->m_vecScenarioIndexes.size();
			if( this->m_nScenarioArrayIndex < 0 ) {
				this->m_nScenarioArrayIndex = nMax - 1;
			}
			if( this->m_nScenarioArrayIndex >= nMax ) {
				this->m_nScenarioArrayIndex = 0;
			}
		} else {
		}
	}

	// Cxg̊mFƎsE\
	getStaticData()->checkEvent(false, EventStepType::MANUAL, false,
		false);
	// step item index
	bool bIsStep = getStaticData()->doEventSkip( 
		getStaticData()->getInputManager()->isPressedNow( KeyMap::A ),
		false, false);

	int nESC = CheckHitKey( KEY_INPUT_ESCAPE );
	if( nESC != 0 || getStaticData()->getInputManager()->isPressedNow( KeyMap::B ) ) {
		// ߂
		getStaticData()->startFadeOutDX(SceneType::TITLE, -1);
	}

}
