#include "GGame.h"

#include <hpllib/system/HPLError.h>
#include <hpllib/math/HPLMath.h>

/*
int GReminder::get( int nIndex ) {
	HPLError::checkBounds( nIndex, 0, ReminderType::MAX_NUM );
	return this->getNoCheck( nIndex );
}
void GReminder::set( int nIndex, int nParam ) {
	HPLError::checkBounds( nIndex, 0, ReminderType::MAX_NUM );
	this->setNoCheck( nIndex, nParam );
}
*/

void GReminder::reset() {
	// set as default
	memset( this->m_aryReminders, 0, sizeof( this->m_aryReminders ) );
	this->setNoCheck( ReminderType::LYING_DAMAGE_ENEMY_ID, -1 );
}

void GGame::setTempFlagBit( int nIndex, int nBitIndex, bool bIsTrue ) {
	
	int nFlag = this->getTempFlag( nIndex );
	this->setTempFlag( nIndex, HPLMath::setFlagByIndexInt( nFlag, nBitIndex, bIsTrue ) );
}
bool GGame::getTempFlagBit( int nIndex, int nBitIndex ) {
	return HPLMath::getFlagByIndexInt( this->getTempFlag( nIndex ), nBitIndex );
}
