#include "GGameOverScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace std;

GGameOverScene::GGameOverScene() {
}
GGameOverScene::~GGameOverScene() {
}

void GGameOverScene::init() {
	//this->m_MixerManager.stopMusic();
	getStaticData()->m_MixerManager.playMusic(Music::BAD_END, true );

	// ENDINGtO
	getStaticData()->m_Save.setFlag( FlagType::ENDING,
		HPLMath::setFlagByIndexInt(getStaticData()->m_Save.getFlag( FlagType::ENDING),
			SaveEndingType::NORMAL_GAME_OVER, true ) );
}
void GGameOverScene::quit() {
}
void GGameOverScene::process() {

	// test
	// 
	getStaticData()->m_Basic.m_Graphics.draw(
		0,0,getStaticData()->getSequence( SpriteType::COMMON,
		Sequence::Common::GAME_OVER_COMMON_01 ) );

	DrawString( 100,100, "Game Over...", GetColor(0,0,0 ) );

	if( getStaticData()->getInputManager()->isPressedNow( KeyMap::A ) ) {
		// L[Ŏ

		// sound
		getStaticData()->m_MixerManager.play( 
			SE::KETTEI,
			false );

		
		// ContinueSceneցB
		getStaticData()->startFadeOutDX( SceneType::CONTINUE, -1 );
	}
}
