#ifndef _G_OBJECT_PLACER_
#define _G_OBJECT_PLACER_

#include <hpllib/game/map/AbstractAllInOnePlacer.h>


class GObjectPlacer : public AbstractAllInOnePlacer {
public:
	GObjectPlacer();
	virtual ~GObjectPlacer();

	void placePlayer();
	void placeEnemy(HPLShootingObject* obj, HPLVector center,
							   int nGenerateType);
	void placeNeutral(HPLShootingObject* obj, HPLVector center,
		int scene, int mapIndex, std::vector<int>& vecParameters = std::vector<int>());
	void placeEffect(HPLShootingObject* obj, HPLVector center);
	void placeItem(HPLShootingObject* obj, HPLVector center);
};


#endif
