#include "GPausePlayer.h"

#include "GStaticData.h"

using namespace std;
using namespace GEnum;
// *********************************************** GPauseScript ********
/*GPauseScript::GPauseScript() {
	this->m_nIndex = 0;
}*/

// *********************************************** GPausePlayer ********

void GPausePlayer::setup() {
	this->setSprite( getStaticData()->getSprite( SpriteType::EVIGEN )->clone() );

	this->m_lpWeaponSprite = getStaticData()->getSprite( SpriteType::EVIGEN_WEAPON )->clone();

	this->changeState( StateType::BORING_CROUCH );
	this->setSize( 96,96 );
	
}
GPausePlayer::~GPausePlayer() {
	delete this->m_lpWeaponSprite;
}
HPLSequence* GPausePlayer::getSequence() {
	HPLSprite* lpSprite = this->getSprite();

/*	if( this->getType() == PlayerType::PESERU &&
		this->m_bIsNaked )
	{
		lpSprite = this->m_lpNakedPeseruSprite;
	}*/
	HPLSequence* seq = 
		lpSprite->getPair(getSequenceID())->left;
	return seq;
}

int GPausePlayer::getSequenceID() {
	int id = Sequence::Player::NERU;
	return id;
}

void GPausePlayer::draw() {
	HPLScroller* scroller = getStaticData()->getScrollManager()->getScroller(0);
	float left = this->getArea().getX() + scroller->getVirtualRect().getX();
	float top = this->getArea().getY() + scroller->getVirtualRect().getY();
	float fCenterX = this->getCenter().getX();// + scroller->getVirtualRect().getX();
	float fCenterY = this->getCenter().getY();// + scroller->getVirtualRect().getY();
//	float fZoom = scroller->m_fZoomRate;
//	fCenterX *= fZoom;
//	fCenterY *= fZoom;
	float fZoom = 1;
	if(this->getSprite() != NULL){
		HPLSequence* seq = this->getSequence();

		float rotate = 0;
		int alpha = 255;
		getStaticData()->m_Basic.m_Graphics.draw(
			(int)fCenterX, (int)fCenterY, seq,
			this->getFaceDirection(), rotate, fZoom,
			alpha, alpha < 255 ? DX_BLENDMODE_ALPHA : DX_BLENDMODE_NOBLEND);

		if( false == getStaticData()->m_Game.isTheWorld() ) {
			seq->step();
		}
	}
}
