#ifndef _G_PLACE_INFO_
#define _G_PLACE_INFO_

#include <map>
#include <vector>
#include <string>

#include <hpllib/math/HPLVectorInt.h>

/** PlaceIʂPlacezu
  */
class GPlaceInfo {
private:
	std::vector< std::vector< HPLVectorInt > > m_vecPositions;	//! vCX̍Wf[^
	std::vector< std::vector< std::string > > m_vecDescriptions;	//! vCX̐f[^
public:
	GPlaceInfo(){}
	~GPlaceInfo(){}

	void load();

	std::string getDescription( int nStar, int nPlace ) {
		return this->m_vecDescriptions[nStar][nPlace];
	}
	HPLVectorInt getPosition( int nStar, int nPlace ) {
		return this->m_vecPositions[nStar][nPlace];
	}
};

#endif
