#include "GPlayerManager.h"

#include "GStaticData.h"
#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace std;

///////
// ㉺50sNZȏ㗣Ă̂ɂĂ͖
const float INSIGHT_THRESHOLD_Y = 60;
const float FAR_INSIGHT_THRESHOLD_Y = 200;

// ߋ
const float NEAR_ENEMY_THRESHOLD = 40;
/////
// G܂ŋ߂ÂGɋ߂Â

// ̋
const float FAR_ENEMY_THRESHOLD = 80;

// O
const float TOO_FAR_ENEMY_THRESHOLD = 120;


float getDX(float aiboCenter, float enemyCenter, float enemyLeft, float enemyRight){
	if(aiboCenter > enemyRight){
		return enemyRight - aiboCenter;
	}else if(aiboCenter < enemyLeft){
		return enemyLeft - aiboCenter;
	}else{
		return enemyCenter - aiboCenter;
	}
}
/**
	_AI
	@param player vC[
	@param aibo _
*/
void GPlayerManager::moveAI( GPlayer* lpPlayer ){

	
	GPlayer*	lpTarget	 =	NULL;					// ڕW

	GPlayer*	lpParent	 = &getStaticData()->m_ObjectManager.m_Player;
	
	int			st			 = lpPlayer->getState()->getState();	// 

	/////////////
	// 
	lpPlayer->resetKeyState(GEnum::KeyMap::MAX_KEY);

//	int mapIndex = getSetting()->getMapManager()->getSelectedMap();
//	bool isChasePlayer = mapIndex == 14;


	//////
	// ^[Qbg̑I

	bool isDone = false;
	{
		// ߐڎ
		if( true ) {//lpPlayer->m_bIsHasMeleeShot ){
			////
			// ㉺ׂȂ
			// ߐڂ̂
			bool isCheckOnlyNearY = true;
			bool isCheckMeleeThreshold = true;
			isDone = this->searchFarEnemy(lpPlayer, isCheckOnlyNearY, isCheckMeleeThreshold);

		}

/*		if(isDone == false){
			/////
			// ㉺ׂȂ
			// ߐڈȊO
			bool isCheckOnlyNearY = true;
			bool isCheckMeleeThreshold = false;
			isDone = this->searchFarEnemy(lpPlayer, isCheckOnlyNearY, isCheckMeleeThreshold);
		}

		if(isDone == false){
			/////
			// ㉺ׂ
			bool isCheckOnlyNearY = false;
			bool isCheckMeleeThreshold = true;
			isDone = this->searchFarEnemy(lpPlayer, isCheckOnlyNearY, isCheckMeleeThreshold);
		}
		if(isDone == false){
			////
			// ㉺ׂ
			// ߐڈȊOmF
			bool isCheckOnlyNearY = false;
			bool isCheckMeleeThreshold = true;
			isDone = this->searchFarEnemy(lpPlayer, isCheckOnlyNearY, isCheckMeleeThreshold);
		}*/

	}


	if(isDone == false &&
		lpPlayer->getState()->isAttackState() == false &&
		lpPlayer->getState()->isDamageState() == false &&
		lpPlayer->getState()->isDeadState() == false)
	{

		////////
		// Ȃ
		//  vC[֓̕

		// vC[Ƃ̋𒴂߂Âitɂȏ߂ÂȂj
		const float FAR_PLAYER_THRESHOLD = 90;

		/*
		if(player->getType() == PlayerType::Undelsen){
			/////
			// x^Ȃ̂łƗ
		//	FAR_PLAYER_THRESHOLD = 150;
		}*/

		// CvC[ւ̕
		HPLVector vParentCenter = lpParent->getCenter();
		HPLVector vCenter = lpPlayer->getCenter();
		HPLVector pdir( vParentCenter.getX() - vCenter.getX(), vParentCenter.getY() - vCenter.getY() );
		if(pdir.getLength() >= FAR_PLAYER_THRESHOLD){
			moveOverObject(lpPlayer, (int)HPLMath::getSgn(pdir.getX()));
		}
		/*
			// ̃vC[ȕ֐i
			float fDirection = 0;

			int nFirstDirection = 0;
			for( int i = 0; i < PLAYER_MAX_NUM; i ++ ) {
				GPlayer* lpEnemy = &getStaticData()->m_ObjectManager.m_aryPlayerList[i];
				if( lpEnemy == lpPlayer || lpEnemy->isAlive() == false) {
					continue;
				}

				
				//////
				// cȏ㗣Ăꍇ͖
				if(fabs( lpEnemy->getCenter().getY() - lpPlayer->getCenter().getY() ) >= FAR_INSIGHT_THRESHOLD_Y){
					continue;
				}
				fDirection += getDX( lpPlayer->getCenter().getX(), lpEnemy->getCenter().getX(),
					lpEnemy->getHitArea().getX(),
					lpEnemy->getHitArea().getRight() ) > 0 ? FaceDirection::LEFT : FaceDirection::RIGHT;
				if( nFirstDirection == 0 ) {
					nFirstDirection = HPLMath::getSgn<int>( static_cast<int>( fDirection ) );
				}
				
			}
			int nFaceDirection = 0;

			if( fDirection == 0 ) {
				// _
				nFaceDirection = nFirstDirection;
				if( nFaceDirection == 0 ) {

				}
			} else {
				nFaceDirection = HPLMath::getSgn<int>( static_cast<int>( fDirection ) );
			}
			moveOverObject(lpPlayer, -nFaceDirection);
		//}*/
	}
}

bool GPlayerManager::isSkipToSearch( GPlayer* lpPlayer, HPLShootingObject* lpTarget ) {
	if( lpPlayer == lpTarget ) {
		return true;
	}
	if( lpTarget->isAlive() == false ) {
		// ł
		return true;
	}

	return false;
}

/** P̂̓Gɑ΂čUΏۂƂ邩ǂf
  * @retval		true		
  * @retval		false		Ȃ
  */
bool GPlayerManager::checkEnemy( GPlayer* lpPlayer, bool isCheckOnlyNearY,
								bool isCheckMeleeThreshold, HPLShootingObject* lpEnemy )
{
	if( this->isSkipToSearch( lpPlayer, lpEnemy ) ) {
		return false;
	}
	HPLRect gameRange = getStaticData()->getMerginedGameRange();
	//////
	// ʊO̓G͖
	if(gameRange.isShare(lpEnemy->getHitArea()) == false){
		return false;
	}

	/////
	// FDȓG͖
	if(lpEnemy->getObjectAttribute(ObjectAttribute::HIT_TO_PLAYER) == false){
		return false;
	}

	
	if(isCheckOnlyNearY == true){
		float dy = lpEnemy->getCenter().getY() - lpPlayer->getCenter().getY();

		//////
		// cȏ㗣Ăꍇ͖
		if(fabs(dy) >= INSIGHT_THRESHOLD_Y){
			return false;
		}
	}

	if(isCheckMeleeThreshold == true){
		float dx = getDX(lpPlayer->getCenter().getX(),
			lpEnemy->getCenter().getX(),
			lpEnemy->getHitArea().getX(),
			lpEnemy->getHitArea().getRight());
		float dy = lpEnemy->getCenter().getY() - lpPlayer->getCenter().getY();


		HPLVector dir(dx,dy);
		float distance = NEAR_ENEMY_THRESHOLD;

		if(dir.getLength() > distance){
			return false;
		}
	}

	if(this->actionAgainstEnemy(lpPlayer, lpEnemy) == true){
		return true;
	}
	return false;
}

/**
	@param isCheckFarY ㉺̍傫mF邩ǂ
*/
bool GPlayerManager::searchFarEnemy(GPlayer* lpPlayer, bool isCheckOnlyNearY,
									 bool isCheckMeleeThreshold)
{
	////
	// ʔ͈
	HPLRect gameRange = getStaticData()->getGameRange();

	/////
	// ߐږY
	for(std::list<GEnemy*>::iterator eit = getStaticData()->m_ObjectManager.m_EnemyManager.getList()->begin();
		eit != getStaticData()->m_ObjectManager.m_EnemyManager.getList()->end();
		eit ++
		//int i = 0; i < PLAYER_MAX_NUM; i ++ 
		)
	{
		GEnemy* lpEnemy = *eit;//&getStaticData()->m_ObjectManager.m_aryPlayerList[i];
		if( this->checkEnemy( lpPlayer, isCheckOnlyNearY,
			isCheckMeleeThreshold, lpEnemy ) )
		{
			return true;
		}
	}

	// ΏۂɂĂ
/*	for( list<GPlayer*>::iterator it = getStaticData()->m_ObjectManager.m_EnemyManager.getList()->begin();
		it != getStaticData()->m_ObjectManager.m_EnemyManager.getList()->end();
		it ++ )
	{
		GPlayer* lpEnemy = *it;
		if( this->checkEnemy( lpPlayer, isCheckOnlyNearY,
			isCheckMeleeThreshold, lpEnemy ) )
		{
			return true;
		}
	}*/
	return false;
}



/**
	Gɑ΂s
*/
bool GPlayerManager::actionAgainstEnemy(GPlayer* lpPlayer,HPLShootingObject* lpEnemy)
{
	float dx = getDX(lpPlayer->getCenter().getX(),
		lpEnemy->getCenter().getX(),
		lpEnemy->getHitArea().getX(),
		lpEnemy->getHitArea().getRight());
	float dy = lpEnemy->getCenter().getY() - lpPlayer->getCenter().getY();


	HPLVector dir(dx,dy);
	HPLVector aim = dir;
	aim.normalize();

	//int targetDirection = HPLMath::getSgn(-dx);

	//bool isEnemyInAiboSight = (dx * aibo->getFaceDirection()) > 0;

	bool isDone = false;

	int st = lpPlayer->getState()->getState();
	// U\ȏ
	bool bIsReadyToAttack = st == StateType::STAND ||
				st == StateType::WALK ||
				lpPlayer->getState()->isFlyingState();
				//st == StateType::FLYDOWN ||
				//st == StateType::FLYUP;
	if( bIsReadyToAttack == false ) {
		return false;
	}

	//int st = player->getState()->getState();
	//int aiboSt = aibo->getState()->getState();

	HPLSequence* lpSequence = lpPlayer->getSequence();


//	if(lpPlayer->getType() == PlayerType::DURANDANA){
		
		/////

		if(dir.getLength() <= NEAR_ENEMY_THRESHOLD){
			/////
			// U
			//lpPlayer->setFaceDirection((int)HPLMath::getSgn(dx));


			//bool prevA = aibo->isPressedPrevious(GEnum::KeyMap::A);

			/////
			// AŁI
			lpPlayer->setKeyState(GEnum::KeyMap::A, true);
				
			isDone = true;

		}/*else if(dir.getLength() <= FAR_ENEMY_THRESHOLD){
			// Ɨ
			//lpPlayer->setFaceDirection((int)HPLMath::getSgn(dx));

			// 
			lpPlayer->setKeyState(GEnum::KeyMap::B, true);
			isDone = true;
		} else if (dir.getLength() <= TOO_FAR_ENEMY_THRESHOLD){
			// Oh^Cp[
			lpPlayer->setKeyState(GEnum::KeyMap::C, true);
			isDone = true;
		}*/

		

/*	}else if(lpPlayer->getType() == PlayerType::UNDELSEN){
		/////
		// ĂUI
		float FAR_ENEMY_THRESHOLD = 250;
		float X_AXIS_ENEMY_THRESHOLD = 20;

		if(fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD){

			int nKey = KeyMap::A;
			if( fabs( dx ) <= NEAR_ENEMY_THRESHOLD ) {
				// ߋ
				// ODORO
				nKey = KeyMap::C;
			} else if( fabs( dx ) <= FAR_ENEMY_THRESHOLD ) {
				// Ɨ
				// 
				nKey = KeyMap::B;
			} else if( dy > X_AXIS_ENEMY_THRESHOLD ) {
				// Ă{ɂ
				//ODORO
				nKey = KeyMap::C;
			}


			//lpPlayer->setFaceDirection((int)HPLMath::getSgn(dx));
			/////
			// Ex߂ɋ
			// E
			// E_̎ɓG
			//  UI
			lpPlayer->setKeyState( nKey, true);
			isDone = true;
		}
	} else if( lpPlayer->getType() == PlayerType::EVIGEN ) {
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// ~jK
			lpPlayer->setKeyState( KeyMap::A, true);
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
			//pCibv
			lpPlayer->setKeyState( KeyMap::B, true);
			isDone = true;
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {
			// 낯
			lpPlayer->setKeyState( KeyMap::C, true);
			isDone = true;
		}
	} else if( lpPlayer->getType() == PlayerType::TANYA ) {
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// ӂӂ
			lpPlayer->setKeyState( KeyMap::A, true);
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {
		}
	} else if( lpPlayer->getType() == PlayerType::TRELLAMA ) {
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// ōU
			lpPlayer->setKeyState( KeyMap::A, true);
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
			// IveBJ
			lpPlayer->setKeyState( KeyMap::C, true);
			isDone = true;
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {

			// C
			lpPlayer->setKeyState( KeyMap::B, true);
			isDone = true;
		}
	} else if( lpPlayer->getType() == PlayerType::PESERU ) {
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// ōU
			lpPlayer->setKeyState( KeyMap::A, true);
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
			// XCfBO
			lpPlayer->setKeyState( KeyMap::B, true);
			// _ŒE
			if( HPLMath::nextDouble(0,100) < 0.5) {
				lpPlayer->setKeyState( KeyMap::C, true);
			}
			isDone = true;
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {
			// ߂Â
			this->moveOverObject( lpPlayer, HPLMath::getSgn<int>( static_cast<int>(dx)) );
			isDone = true;

		}
	} else if( lpPlayer->getType() == PlayerType::GARDA ) {
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// C ]
			lpPlayer->setKeyState( KeyMap::C, true);
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
			// X 
			lpPlayer->setKeyState( KeyMap::B, true);
			isDone = true;
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {
			// Z 
			lpPlayer->setKeyState( KeyMap::A, true);
			isDone = true;

		}*/
/*	} else if( true) {//lpPlayer->getType() == PlayerType::TANYA_YOUJO ) {
		// A^[jcAӂڂAɁAEƁE
		// ̑
		if( fabs(dx ) <= NEAR_ENEMY_THRESHOLD ) {
			// Z ΂₭U
			lpPlayer->setKeyState( KeyMap::A, true);
			// eXg
//			lpPlayer->changeState( StateType::ATTACK );
			isDone = true;
		} else if( fabs(dx) <= FAR_ENEMY_THRESHOLD ) {
			// X ͂߂
			lpPlayer->setKeyState( KeyMap::B, true);
			// eXg
//			lpPlayer->changeState( StateType::ATTACK_2 );
			isDone = true;
		} else if( fabs(dx) <= TOO_FAR_ENEMY_THRESHOLD ) {
			// C ͂ɍ߂H
			lpPlayer->setKeyState( KeyMap::C, true);
			// eXg
//			lpPlayer->changeState( StateType::ATTACK_GUN );
			isDone = true;

		}
	}*/
	if( isDone ) {
		// Ώۂ̕
		lpPlayer->setFaceDirection((int)HPLMath::getSgn(dx));
	}
	return isDone;
}


/******
	ړiQΔщz)
*/
void GPlayerManager::moveOverObject(GPlayer* lpPlayer, int direction){
	if(direction > 0){
		lpPlayer->setKeyState(GEnum::KeyMap::RIGHT, true);
		if(lpPlayer->getTrigger()->getTrigger(TriggerType::HIT_TO_THE_RIGHT) ||
			lpPlayer->getTrigger()->getTrigger( TriggerType::NO_GROUND_AT_THE_FACE_DIRECTION ))
		{
			lpPlayer->setKeyState(GEnum::KeyMap::B, true);
		}
		
	}else if(direction < 0){
		lpPlayer->setKeyState(GEnum::KeyMap::LEFT, true);
		if(lpPlayer->getTrigger()->getTrigger(TriggerType::HIT_TO_THE_LEFT) ||
			lpPlayer->getTrigger()->getTrigger( TriggerType::NO_GROUND_AT_THE_FACE_DIRECTION )){
			lpPlayer->setKeyState(GEnum::KeyMap::B, true);
		}
	}
}

