#include "GSelectPlaceScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace std;

GSelectPlaceScene::GSelectPlaceScene() {
	// 360x񂷂܂ł̃t[
	this->m_Fuyu.m_YuraYuraCounter.setWaitFrameNum( 50 );

	// load
	this->m_PlaceInfo.load();

	// L[ςȂňړł܂ł̃JE^
	this->m_KeepCounter.setWaitFrameNum( 10 );
}
void GSelectPlaceScene::init() {
	getStaticData()->m_MixerManager.playMusic(Music::SPACE, true );
	// XN[
	HPLScroller* lpScroll = getStaticData()->getScrollManager()->getScroller(0);
	lpScroll->setVirtualRect( getStaticData()->m_Setting.gameRange );

	// TODO:IĂ鐯̃}bvf[^ǂݍ

	// TODO:ɂ킹Placezu

	// ݂̈ʒuɂ킹
	this->m_nPlaceIndex = getStaticData()->m_nSelectedPlace;
	// test
	/*static int SEQUENCES[] = {
		Sequence::Common::PLACE_COMPLETED,
		Sequence::Common::PLACE_CLEARED,
		Sequence::Common::PLACE_REVEALED,
		Sequence::Common::PLACE_SEALED,
	};*/
	/*static int TYPES[] = {
		PlaceType::COMPLETED,
		PlaceType::CLEARED,
		PlaceType::REVEALED,
		PlaceType::SEALED,
	};*/
	// YW
	/*static const int PLACE_DELTA_Y_LIST[ StageType::MAX_NUM ][10] = {
		{0,0,0,0,0,0,0,0,0,0},//evil star
		{0,0,0,0,0,0,0,0,0,0},//rock
		{0,0,0,0,0,0,0,0,0,0},//
		{0,0,0,0,0,0,0,0,0,0},//
		{0,0,0,0,0,0,0,0,0,0},//
		{0,0,0,0,0,0,0,0,0,0},//
		{0,0,0,0,0,0,0,0,0,0},//
		{0,0,0,0,0,0,0,0,0,0},//tozico
	};*/
	const int DELTA_Y = 200;
	const int INTERVAL_X = 100;
	for( int i = 0; i < getStaticData()->m_Save.getStarPlaceNum( getStaticData()->m_nSelectedStar ) ; i ++ ) {
		HPLVectorInt v = this->m_PlaceInfo.getPosition( getStaticData()->m_nSelectedStar, i );
		int x = v.x;
		int y = v.y;
		//int x = 150 + i * INTERVAL_X;
		//int y = 250 + PLACE_DELTA_Y_LIST[ getStaticData()->m_nSelectedStar ][i] ;
		GPlace* place = new GPlace();

		// 
		int nType = getStaticData()->m_Save.getPlaceState( getStaticData()->m_nSelectedStar, i );
		place->setup( nType );
		place->lpSequence = getStaticData()->getSequence(
			SpriteType::COMMON, Sequence::Common::PLACE_COMPLETED + nType )->clone();

		// ʒu
		place->setCenter( (float)x, (float)y );

		this->m_vecPlaces.push_back( place );

	}

	// Vт
	{
		this->m_Fuyu.m_Center = this->m_vecPlaces[0]->getCenter();
		this->m_Fuyu.m_Center.add( - INTERVAL_X * 0.8f, 0 );
		this->m_Fuyu.setCenter( this->m_Fuyu.m_Center );
		this->m_Fuyu.m_YuraYuraCounter.setLoop( true );
		this->m_Fuyu.m_YuraYuraCounter.reset();
	}
	this->m_nPlaceIndex = getStaticData()->m_nSelectedPlace;

	// IvC[ZbgAbv
	{
		// ŏ̏ꏊ
		GPlace* lpFirstPlace = this->m_vecPlaces[this->m_nPlaceIndex];

		// vC[̏ʒuɂ
		this->m_SelectPlayer.setCenter( lpFirstPlace->getCenter() );

		// S[ꏊ
		this->m_SelectPlayer.m_vGoalPosition = this->m_SelectPlayer.getCenter();

		// stayԂɂ
		this->m_SelectPlayer.m_bIsStay = true;
	}

}

void GSelectPlaceScene::quit() {
	// 
	for( vector<GPlace*>::iterator it = this->m_vecPlaces.begin();
		it != this->m_vecPlaces.end();
		it ++ ) 
	{
		delete *it;
	}
	this->m_vecPlaces.clear();
}

void GSelectPlaceScene::process() {
	//static int nMiniEvigenCenterX = 100;
	//static int nMiniEvigenCenterY = 100;

	// wi
	//drawUniverseSpace();
	getStaticData()->commonBackgroundProcess();

	// Draw Star
	{
		HPLSequence* lpSeq = getStaticData()->getSequence( SpriteType::COMMON, 
			getStaticData()->getStarSequenceID( getStaticData()->m_nSelectedStar ) );
		
		static int nCenterX = getStaticData()->m_Setting.windowWidth / 2;
		static int nCenterY = getStaticData()->m_Setting.windowHeight / 2;


		getStaticData()->m_Basic.m_Graphics.draw( nCenterX, nCenterY, lpSeq, FaceDirection::LEFT,
			0, 3);//static_cast<double>(getStaticData()->m_Setting.windowWidth) / lpSeq->getImageInformation(0)->srcRect.getHeight() );
	}

	{
		// ACR\

		// V[PX
		HPLSequence* lpRoadSeq = getStaticData()->getSequence(
			SpriteType::COMMON, Sequence::Common::PLACE_ROAD );

		// ̌̒
		//int fRoadWidth = lpSeq->getImageInformation(0)->srcRect.getWidth();
		float fRoadHeight = lpRoadSeq->getImageInformation(0)->srcRect.getHeight();

		int nRoadImageHandle = getStaticData()->m_Basic.m_Graphics.m_ImageManager.get( 
			lpRoadSeq->getImageInformation()->imageTag );

		for( int i = 0; i < (int)this->m_vecPlaces.size(); i ++ ) {
			GPlace* lpPlace = this->m_vecPlaces[i];

			if( i < (int)this->m_vecPlaces.size() - 1 ) {
				// ̃ACeƂ̊Ԃɋn
				HPLVector vCenter = lpPlace->getCenter();
				HPLVector vNextCenter = this->m_vecPlaces[i+1]->getCenter();

				// Xɑ΂钼p
				HPLVector vSub( (vNextCenter.getX() - vCenter.getX() ),
					(vNextCenter.getY() - vCenter.getY()) );
				float fDegree = vSub.getDegree() + 90;

				HPLVector vDelta;
				vDelta.setByDegree( fDegree );

				// draw
				DrawModiGraph(
					static_cast<int>( vCenter.getX() + vDelta.getX() * fRoadHeight / 2 ),
					static_cast<int>( vCenter.getY() + vDelta.getY() * fRoadHeight / 2 ),
					static_cast<int>( vCenter.getX() - vDelta.getX() * fRoadHeight / 2 ),
					static_cast<int>( vCenter.getY() - vDelta.getY() * fRoadHeight / 2 ),
					static_cast<int>( vNextCenter.getX() - vDelta.getX() * fRoadHeight / 2 ),
					static_cast<int>( vNextCenter.getY() - vDelta.getY() * fRoadHeight / 2 ),
					static_cast<int>( vNextCenter.getX() + vDelta.getX() * fRoadHeight / 2 ),
					static_cast<int>( vNextCenter.getY() + vDelta.getY() * fRoadHeight / 2 ),
					nRoadImageHandle, TRUE );
			}

			// place
			getStaticData()->m_Basic.m_Graphics.draw(
				(int)lpPlace->getCenter().getX(), (int)lpPlace->getCenter().getY(),
				lpPlace->lpSequence,
				FaceDirection::LEFT, 0, 1 );

			if( lpPlace->getType() == PlaceType::REVEALED ) {
				// 
				getStaticData()->m_ObjectManager.m_EffectManager.createCure( lpPlace->getCenter(),
					lpPlace->getID(), true );
			}
		}
	}

	
	bool bIsFuyuEnabled = getStaticData()->m_Save.getFlag( FlagType::START ) >= StartType::STARS;

	// Vт
	if( bIsFuyuEnabled ) {
		// Sʒuݒ
		HPLVector vCenter = this->m_Fuyu.m_Center;

		// get current center
		vCenter.add( 0, FUYU_MAX_LENGTH * sin( HPLMath::getRadianFromDegree(
			HPLMathConsts::DEGREE_FULL_ROUND * this->m_Fuyu.m_YuraYuraCounter.getStepCounter() / this->m_Fuyu.m_YuraYuraCounter.getWaitFrameNum() ) ) );

		// set center
		this->m_Fuyu.setCenter( vCenter );
		
		// step degree counter
		this->m_Fuyu.m_YuraYuraCounter.step();
		
		HPLSequence* lpSeq = getStaticData()->getSequence( 
			SpriteType::COMMON, Sequence::Common::SELECT_FUYU_KURAGE );

		getStaticData()->m_Basic.m_Graphics.draw(
			(int)this->m_Fuyu.getCenter().getX(), (int)this->m_Fuyu.getCenter().getY(),
			lpSeq, FaceDirection::LEFT, 0, 1 );
	}
	getStaticData()->commonForegroundProcess();

	{
		// Mini-gen\
		/*HPLSequence* lpSeq = getStaticData()->getSequence( SpriteType::COMMON, 
			Sequence::Common::SELECT_MINI_EVIGEN );
		
		getStaticData()->m_Basic.m_Graphics.draw( nMiniEvigenCenterX, nMiniEvigenCenterY, lpSeq, FaceDirection::LEFT,
			0, 1 );
		lpSeq->step();
		*/
		this->m_SelectPlayer.draw();

		if( this->m_SelectPlayer.m_bIsStay ) {
		} else {
			// ړ
			HPLVector vCenter = this->m_SelectPlayer.getCenter();
			vCenter.add( this->m_SelectPlayer.getVelocityAngle());

			// ʒuXV
			this->m_SelectPlayer.setCenter( vCenter );

			HPLVector vSubToGoal(
				this->m_SelectPlayer.m_vGoalPosition.getX() - vCenter.getX(),
				this->m_SelectPlayer.m_vGoalPosition.getY() - vCenter.getY() );

			if( vSubToGoal.getLength() <= SELECT_PLAYER_GOAL_THRESHOLD ) {
				// S[B
				this->m_SelectPlayer.m_bIsStay = true;

				// ʒu킹 (svH)
				//GPlace* lpGoalPlace = 

				// ~߂
				this->m_SelectPlayer.setVelocityAngle(0,0);

				// JE^X^[g
				this->m_KeepCounter.reset();
			}

		}
	}

	// bEBhEiPlace̐j
	{
		if( this->m_nPlaceIndex < 0 ) {
			getStaticData()->drawDescription( "Vт", true, 0 );
		} else {
			getStaticData()->drawDescription( this->m_PlaceInfo.getDescription( getStaticData()->m_nSelectedStar, this->m_nPlaceIndex ).c_str(), true, 0  );
		}

	}

	if( getStaticData()->isFadingOutDX() == false ) {
		// tF[hAEgĂȂ
		// L[\

		static int nKey = 0;

		int nLeft = getStaticData()->getInputManager()->isPressed( KeyMap::LEFT );
		int nRight = getStaticData()->getInputManager()->isPressed( KeyMap::RIGHT );
		if( this->m_SelectPlayer.m_bIsStay ) {
			// XeCԂ͉L삪\
			// -ړ
			// -

			/*
			const int PLACE_CURSOR_SPEED = 5;

			int nDY = 0;

			if( getStaticData()->getInputManager()->isPressed( KeyMap::UP ) ) {
				nDY = -1;
			}
			if( getStaticData()->getInputManager()->isPressed( KeyMap::DOWN ) ) {
				nDY = 1;
			}
			if( nDY != 0 ) {
				nMiniEvigenCenterY += nDY * PLACE_CURSOR_SPEED;
			}
			if( nDX != 0 ) {
				nMiniEvigenCenterX += nDX * PLACE_CURSOR_SPEED;
			}*/


			int nDX = 0;
			
			if( getStaticData()->getInputManager()->isPressedNow( KeyMap::LEFT ) ||
				(nLeft != 0 && nKey == FaceDirection::LEFT && this->m_KeepCounter.getState().isFinishAnimation))
			{
				
				nDX = -1;
				if( bIsFuyuEnabled ) {
					if( m_nPlaceIndex <= -1 ) {
						// [

						// ړȂ
						nDX = 0;
						m_nPlaceIndex = -1;
					}
				} else {
					if( m_nPlaceIndex <= 0 ) {
						nDX = 0;
						m_nPlaceIndex = 0;
					}
				}
			}
			if( getStaticData()->getInputManager()->isPressedNow( KeyMap::RIGHT ) ||
				(nRight != 0 && nKey == FaceDirection::RIGHT && this->m_KeepCounter.getState().isFinishAnimation))
			{
				nDX = 1;
				if( m_nPlaceIndex >= (int)(this->m_vecPlaces.size() - 1) ) {
					// [ɂǂ蒅
					nDX = 0;
				} else if( m_nPlaceIndex == -1 ) {
					// [
					// ړł
					// do nothing
				} else if( getStaticData()->m_Save.getPlaceState(
					getStaticData()->m_nSelectedStar,
					this->m_nPlaceIndex + 1)  == PlaceType::SEALED ) 
				{
					// V[h
					nDX = 0;
				}
			}




			if( nDX != 0 ) {
				// ړ
				this->m_SelectPlayer.m_bIsStay = false;

				// S[ݒ
				m_nPlaceIndex += nDX;
				HPLVector vGoalPosition;
				if( m_nPlaceIndex >= 0 ) {

					vGoalPosition = this->m_vecPlaces[ this->m_nPlaceIndex ]->getCenter();



				} else if( m_nPlaceIndex < 0 ) {
					// Vт
					vGoalPosition = this->m_Fuyu.getCenter();
				}
				
				this->m_SelectPlayer.m_vGoalPosition = vGoalPosition;
				
				HPLVector vSub(
					vGoalPosition.getX() - this->m_SelectPlayer.getCenter().getX(),
					vGoalPosition.getY() - this->m_SelectPlayer.getCenter().getY() );

				vSub.normalize();
				vSub.multiple( SELECT_PLAYER_WALK_SPEED );

				this->m_SelectPlayer.setVelocityAngle( vSub );


			} else if( getStaticData()->getInputManager()->isPressedNow( KeyMap::A ) ) {		/////////////////////////
				// {^

				// sound
				getStaticData()->m_MixerManager.play( 
					SE::KETTEI,
					false );

				if( this->m_nPlaceIndex >= 0 ) {
					// placeIĂ

					// Im
					getStaticData()->m_nSelectedPlace = this->m_nPlaceIndex;

					// Z[u
					getStaticData()->m_Save.setFlag( FlagType::PLACE, this->m_nPlaceIndex );
					getStaticData()->m_Save.save();

					int nMapIndex = getStaticData()->getMapIndexFromStarAndPlace();
					// I񂾃Xe[WŊJnʒuقȂ
					int nNextPlayerPlaceIndex = -1;
					// ̃Xe[Wł̓vC[̏ʒuς
					switch( nMapIndex ) {
					case SpecialMapIndex::EVIL_HOUSE_FRONT:
					case SpecialMapIndex::FOREST_START:
					case SpecialMapIndex::THREE_WAY:
					case SpecialMapIndex::BEE_HOUSE:
					case SpecialMapIndex::BAVEL:
					case SpecialMapIndex::FIRE_ENTRANCE:
					case SpecialMapIndex::WIND_ENTRANCE:
					case SpecialMapIndex::RESORT_ISLAND:
						getStaticData()->m_nPlayerPlaceIndex = 1;
						break;
					case SpecialMapIndex::WIND_KAZE:
						getStaticData()->m_nPlayerPlaceIndex = 2;
					}
					if( nNextPlayerPlaceIndex >= 0 ) {
						getStaticData()->m_nPlayerPlaceIndex = nNextPlayerPlaceIndex;
					}

					// start!Lɂ
					getStaticData()->m_lpReadyGoSequence->resetCounter();
					
					// Q[ʂֈړ
					getStaticData()->startFadeOutDX(SceneType::GAME, nMapIndex);

				} else if( this->m_nPlaceIndex < 0 ) {
					// I֖߂
					getStaticData()->startFadeOutDX( SceneType::SELECT_STAGE, -1 );
				}

			}
		}// end of bIsStay : ړ͑łȂ

		if( nLeft == 0 && nRight == 0 ) {
			// Ƃ
			// reset
			this->m_KeepCounter.end();
		} else if( (nLeft && nKey == FaceDirection::LEFT) || (nRight && nKey == FaceDirection::RIGHT ) ) {
			// Ă
			this->m_KeepCounter.step();
		}
		if( nRight ) {
			nKey = FaceDirection::RIGHT;
		} else if( nLeft ) {
			nKey = FaceDirection::LEFT;
		} else {
			nKey = FaceDirection::CENTER;
		}


		/*if( getStaticData()->getInputManager()->isPressedNow( KeyMap::B ) ) {
			// I0ɖ߂
			getStaticData()->m_nSelectedPlace = 0;
			getStaticData()->m_Save.setFlag( FlagType::PLACE, 0 );
			getStaticData()->m_Save.save();

			// Iɖ߂
			getStaticData()->startFadeOutDX(SceneType::SELECT_STAGE, -1 );
			//getStaticData()->m_SceneManager.setScene( SceneType::GAME );
		}*/
	}
}
