#ifndef _G_SELECT_PLACE_SCENE_
#define _G_SELECT_PLACE_SCENE_

#include <hpllib/scene/AbstractScene.h>
#include <hpllib/object/HPLShootingObject.h>

#include <vector>

#include "GSelectPlayer.h"
#include "GPlaceInfo.h"

/* }bvݒɎ
EvC[̏
EƂ̑Jڐ
Ewi
E
*/

/** type = NA󋵕\
  */
class GPlace : public HPLShootingObject{
public:
	int		m_nMapIndex;		//! Jڐ}bv
	int		m_nElementMax;		//! Bvf
	int		m_nElementCount;	//! 
	int		m_nClearCount;		//! NA
	HPLSequence* lpSequence;	//! \pV[PX
public:
	GPlace():HPLShootingObject(0){
		this->m_nMapIndex = 0;
		this->m_nElementMax = 1;
		this->m_nElementCount = 0;
		this->m_nClearCount = 0;
		lpSequence = NULL;
	}
	void setup( int nType ) {
		this->setType( nType );
	}

	virtual ~GPlace(){
		if( lpSequence != NULL ) {
			delete lpSequence;
		}
	}
public:
	void changeState( int nState ) {
		HPLShootingObject::changeStateCommon(this,nState);
	}
	int getSequenceID(){
		return HPLShootingObject::getSequenceIDCommon(this);
	}
	HPLSequence* getSequence() {
		return HPLShootingObject::getSequenceCommon(this);
	}
};

class FuyuEvil : public HPLShootingObject {
public:
	int m_nSequenceID;
	HPLCounter m_YuraYuraCounter;	//! JE^[
	HPLVector 	m_Center;			//! 璆SW
public:
	FuyuEvil():HPLShootingObject(0) {}
	virtual ~FuyuEvil(){}
public:
	void changeState( int nState ) {
		HPLShootingObject::changeStateCommon(this,nState);
	}
	int getSequenceID(){
		return HPLShootingObject::getSequenceIDCommon(this);
	}
	HPLSequence* getSequence() {
		return HPLShootingObject::getSequenceCommon(this);
	}
};

class GSelectPlaceScene : public AbstractScene {
private:
	GPlaceInfo		m_PlaceInfo;				//! Placezu
	GSelectPlayer	m_SelectPlayer;				//! IpvC[ACR
	int m_nPlaceIndex;	//! Iłv[X

	std::vector<GPlace*>		m_vecPlaces;	//! v[XꗗBIɌĂ΂邽߁A}bvf[^ɃZbgAbv

	FuyuEvil	m_Fuyu;	//! Vтij
	HPLCounter		m_KeepCounter;				//! L[̉ςȂŎֈړł܂ł̃JE^
public:
	GSelectPlaceScene();
	virtual ~GSelectPlaceScene(){}

public:
	void init();
	void quit();
	void process();
};

#endif
