#ifndef _G_SELECT_STAGE_
#define _G_SELECT_STAGE_

#include <hpllib/scene/AbstractScene.h>
#include <hpllib/general/HPLCounter.h>

#include "GEnum.h"
#include "GStar.h"
#include "GSelectPlayer.h"

/** Select Star Scene
  * I
  */
class GSelectStageScene : public AbstractScene {
public:
	GSelectPlayer	m_VTOL;								//! xł
	GSelectPlayer	m_SelectPlayer;						//! IpvC[ACR
	GStar m_Stars[GEnum::StageType::MAX_NUM];			//! 
	int m_aryDrawOrder[GEnum::StageType::MAX_NUM];		//! \鏇iYW̍j
	int m_nSelectedStar;								//! I𒆂̐
	float m_fRotateDegree;									//! ]px
	HPLSprite* m_lpEffectSprite;			//! opXvCg
	
	/** JnɃGtFNg
	  * -1	Ȃi~j
	  */
	void setEffectType( int nType );
	
private:
	HPLCounter	m_ShotEvilBeamCounter;	//! Gт鉻VbgJE^
	
	int m_nFullDestroyShield;	//! Sf̃V[huj󂵂Ƃ̃tOl
	int m_nEffectType;		//! 
							//! -1	Ȃ
	int getEffectType() {
		return this->m_nEffectType;
	}

public:
	GSelectStageScene();
	virtual ~GSelectStageScene();

private:
	/** ݈̌ʒuvZ
	  * @param[in]	nIndex		Index
	  */
	HPLVector getCenter( int nIndex );
	/** ݂̌̊px擾
	  * @param[in]	nIndex		Index
	  */
	float getDegree( int nIndex );
public:
	void init();
	void quit();
	void process();
public:
	/** ʒuZbg
	  */
	void resetVTOL();
};

#endif
