#ifndef _G_SHOT_FACTORY_
#define _G_SHOT_FACTORY_

#include <hpllib/object/HPLShootingObject.h>

#include "GEnum.h"

#include "GShot.h"

/** VbgǗ
  */
class GShotFactory {
private:
	HPLShootingObject*	m_lpParent;		//! Owner
	int				 	m_nWeaponType;	//! /U^Cv
	int 				m_nWeaponDirection;	//! ̕
	int					m_nWayShotNum;	//! NWay̐oĂBSVbgn菬ƏdȂ댯
	int					m_nShotIndex;
	bool m_bIsReduceAccel;	//! ~邩ǂ
	float m_fReduceAccel;
public:
	void setReduceAccel( float fAccel ) {
		this->m_bIsReduceAccel = true;
		this->m_fReduceAccel = fAccel;
	}
	GShotFactory(){
		this->m_lpParent = NULL;
		this->m_nWeaponType = 0;
		this->m_nWeaponDirection = GEnum::WeaponDirection::FRONT;
		this->m_nWayShotNum = 1;
		this->m_nShotIndex = 0;

		this->resetParams();
	}
	~GShotFactory(){}

	/**
	  * 񓯂p[^͂ɂ܂Ƃ߂
	  */
	void resetParams() {
		this->m_bIsReduceAccel = false;
		this->m_fReduceAccel = 0;
	}
public:
	/**
	  * @param[in,out]	lpParent		˂IuWFNg
	  * @param[in]		nWeaponType		U
	  * @param[in]		nWeaponDirection	WeapongpAςꍇɎgp
	  *	@param[in]		nShotIndex		Ԗڂ̃VbgH(gpȂꍇ-1łĂ)
	  *									WeaponDirectionőpĂ
	  *									Chaser,
	  * @retval			n				˂e̐B0肤B͂Ȃ
	  */
	int shot( HPLShootingObject* lpParent, int nWeaponType, int nWeaponDirection,
		int nShotIndex = 0);
private:
	/**
	  * @retval		Vbg^Cv
	  */
	int getShotType( );
	/**
	  * @retval		Vbg̒SW
	  */
	HPLVector getCenter( int nIndex, int nAllNum );
	/**
	  * @retval		Vbg̈ړ
	  */
	HPLVector getVelocityAngle( HPLVector vShotCenter, int nIndex, int nMax );

	/**
	  * l̐ݒ
	  */
	void setupShot( GShot* lpShot);

	/** ʏ̃VbgiLeft:180,Right:0jɉāA㉺˕␳B
	  */
	int getShotDegreeDelta();

	/** vC[̕픭ˈʒu
	  */
	static void getPlayerWeaponShotCenterFromDelta( HPLVector& vResultCenter,
		HPLShootingObject* lpParent, int dx, int dy, int nWeaponType );

	/** vC[̕픭ˈʒũYvZ
	  */
	static void getPlayerWeaponShotCenterDelta( int& dx, int& dy, HPLShootingObject* lpParent, int nWeaponType,
		int nWeaponDirection);

public:
	/** vC[̕픭ˈʒu
	  */
	static void getPlayerWeaponShotCenter( HPLVector& vResultCenter, HPLShootingObject* lpParent, int nWeaponType,
		int nWeaponDirection);
};

#endif
