#ifndef _G_STAR_
#define _G_STAR_

#include <hpllib/object/HPLShootingObject.h>

class GStar: public HPLShootingObject {
public:
	int		m_nSequenceID;
	HPLVector	m_vHomePosition;
public:
	GStar();
	virtual ~GStar(){}

public:
	void changeState( int nState ) {
		HPLShootingObject::changeStateCommon(this,nState);
	}
	int getSequenceID(){
		return HPLShootingObject::getSequenceIDCommon(this);
	}
	HPLSequence* getSequence() {
		return HPLShootingObject::getSequenceCommon(this);
	}
};

#endif
