#ifndef _G_TITLE_SCENE_
#define _G_TITLE_SCENE_

#include <hpllib/scene/AbstractScene.h>
#include <hpllib/general/HPLCounter.h>


class GTitleScene : public AbstractScene {
private:
//	int m_nUseSubTitleID;		//! Tu^CgID
	int m_nIndex;				//! IʒuCfbNX
	int m_nSaveIndex;			//! Z[uICfbNX
	int m_nTitleType;			//! ݂̕\^Cv
	int m_nConfirmIndex;		//! 0=delete,1=cancel
public:
	int getSaveIndex() {
		return this->m_nSaveIndex;
	}
public:
	GTitleScene();
	virtual ~GTitleScene();
public:
	void init();
	void quit();
	void process();

private:
	void procMain();
	void procMainOnArrow();
	bool procMainOnA();

	void procSelectSave();
	void procSelectSaveOnArrow();
	bool procSelectSaveOnA();
	void procSelectSaveOnB();

	void procDeleteSave();
	void procDeleteSaveOnArrow();
	bool procDeleteSaveOnA();
	void procDeleteSaveOnB();

	void procConfirm();
	void procConfirmOnArrow();
	bool procConfirmOnA();
	void procConfirmOnB();

	/** 
	  * @param[in,out]	nIndex
	  * @param[in]		nMin,nMax	őŏ
	  * @param[out]		bIsWrap		true	:ő𒴂ŏɖ߂
									false	:ő𒴂őlɖ߂
	  */
	void commononArrow( int& nIndex, int nMin, int nMax );//, bool bIsWrap );
};

#endif
