#ifndef _SHOW_COUNTER_
#define _SHOW_COUNTER_

#include <hpllib/object/HPLSequence.h>

namespace GEnum {
	namespace ShowType {
		enum {
			ENEMY_NAME,
			ITEM_NAME,
		};
	}
}


/** Q[ԕ\XvCg
  */
class ShowCounter {
private:
	// int m_nLeft;
	// int m_nTop;
	int m_nObjectID;				//! Object-ID (IDɂ͉x\Ȃj
	int m_nNameType;		//! \閼O^CvBۂɕ\镶Ƃ͕ʂŗp
	//HPLCounter m_Counter;	//! \
	HPLSequence* m_lpSequence;	//! \ԁ{Aj[V
	int m_nType;			//! 
public:
	HPLSequence* getSequence() {
		return this->m_lpSequence;
	}
	int getNameType() {
		return this->m_nNameType;
	}

	int getType() {
		return this->m_nType;
	}
public:
	ShowCounter(){
		this->m_nType = -1;
		this->m_nObjectID = -1;
		this->m_nNameType = -1;
		this->m_lpSequence = NULL;
	}
	~ShowCounter() {
		if( this->m_lpSequence ) {
			delete this->m_lpSequence;
			this->m_lpSequence = NULL;
		}
	}
	/**
	  * @param[in]	
	  */
	void setup( int nType, HPLSequence* lpSeq );

	/**
	  * @param[in]	nObjectID	HPLShootingObject::getID()̌ʁBIDɂĂ͉x\ȂifalseԂj
	  * @param[in]	nNameType	\閼OCfbNX
	  * @retval	true	Jnꂽ
	  * @retval	false	JnȂiObjectIDɑ΂ČĂ΂ꂽj
	  */ 
	bool start( int nObjectID, int nNameType );
	bool isAlive();
	bool step();
	void reset();
};


#endif
