#ifndef _G_ARM_MANAGER_
#define _G_ARM_MANAGER_

//#include "GEnemy.h"
#include <hpllib/object/HPLShootingObject.h>

#include <vector>

/** G}l[W
  */
class GArmManager {
private:
	HPLShootingObject* m_lpParent;	//! e

	std::vector<HPLShootingObject*> m_vecArms;	//! Gf[^Bŏ̗vf(0)BŌ(n-1)擪(\)

	float m_fMaxRadius;		//! rbg̓ۂɁAőǂ܂ŗ邩
	float m_fRadiusSpeed;		//! L鑬
	float m_fRadius;			//! ݂̔a
	float m_fRotateSpeed;		//! rbg]鑬
	float m_fRotateDegree;		//! ]p
	float m_fArmLength;		//! ԐڊԂ̒
	// Getter Setter
private:
	HPLShootingObject* get(int nIndex ) {
		return this->m_vecArms[nIndex];
	}
public:
	int getArmNum() {
		return (int)this->m_vecArms.size();
	}

	HPLShootingObject* getHead();

	/** \쁕ڐG邩ǂ
	  */
	bool isEnable();

	// Constructor
public:
	GArmManager() {
		this->m_fMaxRadius = 0;
		this->m_fRadiusSpeed = 0;
		this->m_fRadius = 0;
		this->m_fRotateSpeed = 0;
		this->m_fRotateDegree = 0;
	}
	~GArmManager();

	// Operations
public:
	/** 
	  */
	void algorithm();

	/** G蕗ɓ
	  * ԐڃASYgp
	  */
	void moveArmTentacle( HPLVector vTargetCenter );

	/** Ȃ񂿂ĐG
	  * XCNB[̂
	  */
	void moveArm( HPLVector vTargetCenter );

	/** {̂̎𓮂rbgƂē
	  */
	void moveArmCircle( HPLVector vTargetCenter );

	/** Ԃɍsʏ
	  */
	void moveArmCommon();

	/** ZbgAbv
	  */
	void setup(HPLShootingObject* lpParent);

	/** vC[Ƃ̂蔻
	  * ڐG1݂̂Ƃ
	  * @retval	NULL		ڐGĂȂ
	  * @retval	NOT NULL	ڐGIuWFNgBDxARM_HEAD>ARM(n-1)>...>ARM(0):nARM̐+ARM_HEAD
	  */ 
	HPLShootingObject* checkHitToTarget( );

	/** VbgƂ̂蔻
	  * @param[out]	vecHitArms		qbgArm̃XgiƂ̏X͖̏{֐ōsĂBj
	  */
	void checkHitToShot( std::vector<HPLShootingObject*>& vecHitArms );

	void draw();

	/** e
	  * ̓Iɂ͈ʒüʒuɖ߂
	  */
	void reset();

	/** ̔򖗃GtFNg𔭐iEɃGtFNgoj
	  */
	void createBloodEffect();

	/** armSEi{̂łƂȂǗpj
	  * 
	  */
	void killAllArms( );
	

private:
	/** ΍Wۂ̍W擾
	  */
	HPLVector getCenter( HPLShootingObject* lpArm );

	/** ʒu擾
	  */
	HPLVector getDefaultPosition();
};

#endif
