#ifndef _G_ENUM_
#define _G_ENUM_

#include <hpllib/general/HPLColor.h>
#include <hpllib/math/HPLRect.h>

namespace GEnum {
	namespace KeyMap{
        enum{
            UP,
            DOWN,
            LEFT,
            RIGHT,
           
            A,
            B,
            C,

            D,
			E,
			F,

			G,
			H,
			I,

			J,
			//K,
			//L,

			MAX_KEY
        };
    };

	namespace SpriteType{
		enum SpriteType_{
			//  0
			COMMON,
			EVIGEN,
			EVIGEN_WEAPON,
			SHOT,
			NEUTRAL,

			//  5
			EFFECT,
			TANYA,
			TANYA_YOUJO,
			ITEM,
			ACHIEVEMENT,

			// 10
			ENEMY_SPRITE_START,
			NAMAKO = ENEMY_SPRITE_START,
			SLIME,
			EVI_HIME,
			MUNIERU,
			MAZER,	//mazer

			// 15
			BLUE_SLIME,
			GREEN_SLIME,
			YELLOW_SLIME,
			ARYONA,
			TOZICO,

			// 20
			ELLIN,
			SLIME_QUEEN,
			SHIHAN,
			ARM,
			ARAKHNE,

			// 25
			IVY,
			IVY_2,
			LAMIA,
			ROPER,
			SUCCUBUS,

			// 30
			SUCCUBUS_MISAGO,
			ZOMBIE,
			ROCK,
			BEE,
			QBEE,

			// 35
			FLOWER,
			ALRAUNE,
			TANK,
			VTOL_NYA,
			CAR,

			// 40,
			ROBOGEN,
			FUUN,
			RAI,
			WIND_BIT,
			ELEC_BIT,

			// 45
			EVIL_GATE,
			GHOST,
			MERAKO,
			CONDOR,
			CHASER,
			//FIRE_PARTICLE,

			// 50
			WORM,
			MEDOUSA,
			FIRE_ELEMENTAL,
			FROG,
			ROBOT,
			// 55
			GOKI,
			PIRANHA,	// sjA
			JET_PORT,	//! ΎRo
			CYCLON,		//! ނ
			ISO,		//! C\M`N

			// 60
			SUN,
			ROCK_2,
			ROCK_2_SMALL,
			SHARK,
			MUTANT_GEL,

			// 65
			UNI,
			DIRTY_CLOUD,
			FAN_BIRD,
			JEALOUSYGHOST,
			SORROW_CLOUDS,

			// 70
			SHABONER,
			//SHABON,
			BEE_HIVE,		//! Ȋ
			JACKPOT,		//! oI

			LAVA,
			LAVA_UNDER,

			// 75
			LAVA_BALL,
			ELEMENTAL_MONSTER,
			ELEMENTCO,
			ICICLE,		//! 炳
			GHOST_PAIR_SHIELD,	//! 

			// 80

			///// ͂ɒǉ
		};
	}
	

	namespace WeaponType{
		enum WeaponType_ {
			//  0
			GATLING,				//! ~jK/ʏ̒e
			CHAIN_SAW,
			HOMING_LASER,
			ELECTRIC_HOMING_LASER,
			MISSILE_LAUNCHER,

			//  5
			PUNCH,
			PINE_APPLE,
			SHOT_GUN,
			RAIL_GUN,
			FRAME_THROWER,

			// 10
			WATER_GUN,
			SATELITE_GUN,
			HOMING_MISSILE_LAUNCHER,
			TOMAHAWK,
			SNIPER_RIFLE,
			
			// 15
			DRILL,
			LASER_GUN,
			MAYO_GUN,
			HAND_GUN,
			CRYOLATOR,

			// 20
			SLIME_GUN,					//! super power #0	XCe	XCNB[iт鐯j
			SEED,						//! super power #1	킥c		AEliXj
			PILE_BUNKER,
			NIKITA_MISSILE,
			CAR_BALL,

			// 25
			SPREAD_MISSILE_LAUNCHER,
			MULTI_MISSILE_LAUNCHER,				//! èЯ
			WIND_WIZARD,				//! super power #2	create fan

			MAX_WEAPON_NUM
		};
	};

	namespace Sequence{
		//////
		// ݂Ȃ̂ɂĂ͑ւ̂̂Ă
		// т
		namespace Player {
			enum{
				STAND,
				WALK,
				DASH,
				FLYDOWN,
				FLYUP,
				CROUCH,
				ATTACK,
				ATTACK_2,
				ATTACK_GUN,
				DEAD,
				DEAD_FLYDOWN,
				DEAD_FLYUP,
				DAMAGE,
				DAMAGE_FLYDOWN,
				DAMAGE_FLYDOWN_REVERSE,
				DAMAGE_ELEC,
				DAMAGE_HOLD,						//! ͂ݍU
				DAMAGE_HOLD_DOWN,
				BIND,
				BIND_DAMAGE,						//! 
				BIND_DAMAGE_ELEC,
				BROKEN,
				EATENING,
				EATEN,
				JATTACK,			//! WvU

				SWIM,

				WALK_GUN,
				JUMP_GUN,

				DAMAGE_FIRE,		//! _[W
				CHECK,
				DADAKKO,
				STAND_BORED,
				NERU,
				CHONPA_STAND,
				CHONPA_FALL,
				CHONPA_DEAD,
				
				DOUBLE_JUMP,

				STAND_NAKED,
				WALK_NAKED,
				DAMAGE_FLYDOWN_NAKED,
				DAMAGE_FLYDOWN_REVERSE_NAKED,
				FLYDOWN_NAKED,
				FLYUP_NAKED,

				DAMAGE_NAKED,
				DEAD_NAKED,
				ATTACK_GUN_NAKED,
				HOLD_DOWN_NAKED,
				ATTACK_PUNCH_NAKED,
				SWIM_NAKED,

				EATENING_2,

				STONE,	//! Ή

				CROUCH_NAKED,
				DAMAGE_HOLD_NAKED,
				BIND_NAKED,
				BIND_DAMAGE_NAKED,
				BIND_DAMAGE_ELEC_NAKED,
				MAX_NUM

			};
		}	// evigen

		namespace EvigenWeapon {
			enum {
				MINIGUN_1,
				MINIGUN_2,			//! up
				MINIGUN_3,			//! down
				CHAIN_SAW,
				SUIT_CASE,			//! Homing laser gun
				ELECTRIC_SUIT_CASE,	//! Electrical homing laser
				MISSILE_LAUNCHER,
				MISSILE_LAUNCHER_FU,
				MISSILE_LAUNCHER_FD,
				SHOT_GUN,
				SHOT_GUN_FU,
				SHOT_GUN_FD,
				RAIL_GUN,
				RAIL_GUN_FU,
				RAIL_GUN_FD,
				FRAME_THROWER,
				FRAME_THROWER_FU,
				FRAME_THROWER_FD,
				DRILL,
				WATER_GUN,
				WATER_GUN_FU,
				WATER_GUN_FD,
				HAND_GUN,
				HAND_GUN_FU,
				HAND_GUN_FD,
				CRYOLATOR,
				CRYOLATOR_FU,
				CRYOLATOR_FD,
				SLIME_GUN,
				SLIME_GUN_FU,
				SLIME_GUN_FD,
				PILE_BUNKER,
				MULTI_MISSILE_LAUNCHER,
			};
		}
		namespace Arm {
			enum {
				ARM,
				ARM_HEAD,
			};
		}
		namespace Succubus {
			enum {
				STAND,
				WALK,
				HOLD_EVIGEN,
			};
		}
		namespace EviHime{
			enum{
				STAND,
				ATTACK_PUNCH,

				WARP,
				UNKO,

				/////
				// not yet
				DAMAGE,
			};
		};

		namespace DanimothRobo{
			enum{
				STAND,
				LEG_FRONT,
				LEG_BACK,
			};
		};

		/**
			OԂ܂ł^Cv
		*/
		namespace Simple{
			enum{
				STAND,
				HOLD,
			};
		};
		namespace GateFlower{
			enum{
				STAND,
				HOLD,
				EATING,
			};
		};
		namespace EnergyBall{
			enum{
				STAND,
			};

		};

		namespace Tanya{
			enum{
				STAND,
				WALK,
				DAMAGE,

				FLYDOWN,

				/// 
				DAMAGE_FLYDOWN,
				DAMAGE_FLYDOWN_REVERSE,
				DEAD,

				ATTACK_PUNCH,
				ATTACK_PUNCH_FAST,

				EATEN,

				HOLD_DOWN,
			};
		};
		namespace Common {
			enum{
				TILE,
				TITLE,
				TITLE_2,
				TITLE_ESCAPE,
				TITLE_DR_TANYA,
				TITLE_MINIGUN,
				TITLE_LIGHT,
				TITLE_BUTTON_START,
				SELECT_MINI_EVIGEN,
				SELECT_MINI_EVIGEN_BACK,
				SELECT_MINI_EVIGEN_LEFT,	//10

				SELECT_EVIL_STAR,
				SELECT_ROCK,
				SELECT_WATER,
				SELECT_FIRE,
				SELECT_FOREST,
				SELECT_WIND,
				SELECT_ELECTRIC,
				SELECT_TOZI_STAR,

				SELECT_CLOUD,
				SELECT_UNIVERSE_SPACE,		//20

				SELECT_FUYU,

				PLACE_COMPLETED,
				PLACE_CLEARED,
				PLACE_REVEALED,
				PLACE_SEALED,
				PLACE_ROAD,

				TALK_FRAME,
				TALK_NEXT,

				HP_METER_FRAME,
				HP_METER,					//30
				HP_METER_BLACK,

				WEAPON_ICONS,
				MENU_BACK,
				MENU_FRAME,

				TALK_EVIGEN_DAMEGEN,		//35		// ߂
				TALK_EVIGEN_NORMAL,						// ʏ
				TALK_EVIGEN_LOUGH,						// Ί
				TALK_EVIGEN_SURPRISED,					// 
				TALK_EVIGEN_SURPRISED_HAND,
				TALK_EVIGEN_SHAMED,			//40		// p
				TALK_EVIGEN_NAKED_NORMAL,				// 
				TALK_EVIGEN_NAKED_LOUGH,
				TALK_EVIGEN_NAKED_SURPRISED,
				TALK_EVIGEN_NAKED_SURPRISED_HAND,
				TALK_EVIGEN_NAKED_SHAMED,	//45
				TALK_EVIL2_1,
				TALK_EVIL2_2,
				TALK_EVIL2_3,
				TALK_EVIL2_4,
				TALK_EVIHIME_ANGRY,		//50			// PF{
				TALK_EVIHIME_CRY,						// 
				TALK_EVIHIME_DOYA,						// ǂ₟EEE
				TALK_EVIHIME_GUNUNU,					// ʂ
				TALK_EVIHIME_IJIKE,						// 
				TALK_EVIHIME_IYAN,		//55			// 
				TALK_EVIHIME_KYOUGAKU,					// 
				TALK_EVIHIME_SMILE_1,					// Ί
				TALK_EVIHIME_SMILE_2,					// Ί
				TALK_EVIHIME_SUNERU,					// ˂
				TALK_EVIHIME_TENTENTEN,	//60			// EEE
				TALK_EVIHIME_THINKING,					// l
				TALK_MUNIERU_NORMAL,
				TALK_TANYA_NORMAL,
				TALK_TANYA_2_NORMAL,
				TALK_EVIGEN_CONFUSE,	//65			// iڂ_
				TALK_EVIGEN_CRY,						// ij
				TALK_EVIGEN_CRY_2,
				TALK_EVIGEN_DESPAIR,					// |ij
				TALK_EVIGEN_DESPAIR_2,					// |i
				GAME_OVER_SLIME_QUEEN01,	//70
				GAME_OVER_SLIME_QUEEN02,
				GAME_OVER_SLIME_QUEEN03,
				GAME_OVER_SLIME_QUEEN04,
				GAME_OVER_SLIME_QUEEN05,
				GAME_OVER_SLIME_QUEEN06,	//75
				GAME_OVER_SLIME_QUEEN07,
				GAME_OVER_BEE,
				GAME_OVER_ALRAUNE,	
				TALK_MERC_NORMAL,

				// 80
				TALK_TANYA_SMILE,
				TALK_TANYA_KOWAI,
				TALK_TANYA_EVIL,
				GAME_OVER_CHASER,


				// R̉摜͂ǉĂ

				SELECT_FUYU_KURAGE,
//				EVIL_GAGE_FRAME,
//				EVIL_GAGE,
				EVIL_ORB_FRAME,
				EVIL_ORB,
				SELECT_VTOL,
				TALK_ITEM,
				TITLE_BUTTON_OPTION,
				TITLE_BUTTON_ACHIEVEMENT,
				EVI_HEAD,
				MENU_SELECT_FRAME,
				MENU_EVIL_FRAME_BACK,
				MENU_EVIL_FRAME_GLASS,
				CURSOR,
				ACHIEVEMENT_FRAME,
				ENEMY_HP_FRAME,
				ENEMY_HP,
				CLEARED,				// achievement(or other) cleared
				ACHIEVEMENT_SELECT_FRAME,

				GAME_OVER_COMMON_01,
				BOSS_HP_FRAME,
				BOSS_HP,

				SUPER_POWER_BACK,
				SUPER_POWER_FRAME,
				SUPER_POWER_SELECT,
				SUPER_POWER_00,		//! SlimeQueen
				SUPER_POWER_04,		//! Alraune
				SUPER_POWER_05,

				// SuperPowern͂ɒǉĂ

				BACK_TO_THE_STAGE_SELECT,
				FOREST_BACK,
				SELECT_REST_STAR,
				SHORT_CUT,
				SNIPER,

				MENU_ON,
				MENU_OFF,
				SELECT_EVIL_TOWER,
				SELECT_BARRIER_BEAM,
				SELECT_EVIL_TOWER_SHIELD,	//! V[h
				BACK_TO_THE_STAGE_SELECT_LOCK,
				START,
				STAGE_CLEAR,
				CRYO,	// X
				
				BG_SEA,
				BG_VOLCANO,
				BG_CLOUD,
				CHARGE_METER,
				CHARGE_METER_BAR,
				HOLD_METER,
				HOLD_METER_BAR,
				CHARGE_METER_BAR_BACK,
				GUIDED,
				ENEMY_NAME,
				TITLE_BUTTON_LIBRARY,
				NUMBER_FRAME,
				SELECT_FRAME,
				LAVA_SHIELD,
				WIND_SHIELD,
				LOADING,
				ITEM_NAME,
			};
		};

		namespace Roper{
			enum{
				STAND,
				HOLD_SIDE,
				HOLD_UPPER,
				ATTACK_TANYA,
			};
		};

		namespace Human{
			enum{
				STAND,
	//				STAND_R,
				
			};

		};

		namespace Eater{
			enum{
				STAND,
	//				STAND_R,
				WALK,
				ATTACK,
				HOLD,
				EATING,
				ATE_00,
				ATE_01,
				ATE_02,

	//				WALK_R,
			};

		};

		namespace FuunAndRai {
			enum {
				HIDDEN,
				DETECTED,
			};
		}
		namespace Slime00{
			enum{
				STAND,
				JUMP_READY,
				FLYDOWN,
			};
		};
		namespace Zombie00{
			enum{
				STAND,
				HOLD,
				ATTACK_00,
				DASH,
				FLYDOWN,

			};
		};
		namespace Slime01{
			enum{
				STAND,
	//				STAND_00_R,

			};
		};
		namespace Effect {
			enum Effect_ {
				// 0
				HIT,
				WIND,
				BLOOD_TINY,
				BLOOD_SMALL,
				BLOOD_BIG,

				// 5
				LADER,		//! ^[QbeBO
				TARGETTING,	//! ^[QbeBO
				//  7
				EI_START,
				EI_HATENA = EI_START,	//! G[VACR
				EI_SNAKE,	//! "!"
				EI_HEART,

				// 10
				EI_ASE,
				EI_HAZUKASHI,
				EI_ANGRY,
				GENERATOR,
				BACK_CLOUD,

				// 15
				BU_CLOUD,
				LAVA,
				LAVA_UNDER,
				// EIn͂ǉ
				// IDŒ肷ׂΏۂ͂ǉĂ

				EI_MAX_NUM,
				// ̑̃GtFNg͂ǉĂ
				CURE = EI_MAX_NUM,	//! 񕜃ACe擾̃GtFNg
				CURE_STAR,
				MISSILE_CONTRAIL,
				EXPLOSION_SMOKE,
				ZANZO,
				SLIME_CHIP,
				SLIME_CHIP_2,
				VACUUM,
				ROCK,
				WOOD,
				LEAF,
				WARP,
				FIRE,	//! ܂Ƃt
				ICE_CONTRAIL,
				JUMP_EFFECT,
				WIND_RAIL,	//! CKp[eBN
				NUMBER,
				CLOUD,		//! W܂W܂
				CURE_CHARGE,
				FREE_CLOUD,	//! 邾̉_
				HEAD_SHOT,
				SNOW_BALL,
			};
		};
		namespace Shot {
			enum Shot_ {
				// 0
				FIRE_TRAP,
				NATO_BULLET,
				HOMING_LASER,		//! xWFz[~O
				ELECTRIC_HOMING_LASER,
				MISSILE,

				//  5
				BEAM_1,
				PINE_APPLE_0,
				EXPLOSION,
				NEN_EKI,
				FIRE_BALL,	//! t@CA{g

				// 10
				FIRE,		//! Ήˊp
				DUMMY,		//! \
				SLIME_CLIP,	//! XC̔j
				RAIL,		//! CK
				WATER,	//!

				// 15
				MAGNUM,		//! nhKAVbgKp
				SATELITE_UNDER,	//! TeCg̍
				HOMING_MISSILE,	//! z[~O~TC
				TOMAHAWK,		//! Hawk
				KOGUMO_1,

				// 20
				KOGUMO_2,
				NEEDLE,
				LASER,
				MAYO,
				LEAF,			//! tσJb^[

				// 25
				TENTACLE,		//! ˂h
				KAHUN,			//! ԕ
				SPIDER_NET,		//! w偂̎
				ONPA,			//! ElecWave gB
				SNIPER,			//! XiCp[p.308

				// 30
				NATO_10MM,		//! 10mm
				ELEC,
				WIND,
				ICE,
				SEED,			//! 炤˓\͎

				// 35
				SKYTHE,
				FALL_ICE,
				NIKITA_MISSILE,
				SNAKE,
				ROBOT_BEAM,

				// 40
				ROBOT_MISSILE,
				LAVA_BALL,
				FIRE_PARTICLE,
				SHABON,
				STONE_CURSE,	//! Ή

				// 45
				EVIL_BEAM,		//! Select StarʂVTOL֌т鉻r[
				CHARGE_BOLT,	//! `[WI
				RUNNER_BOLT,
				THUNDER_BOLT,
				CAR_BALL,		//! ԂŔ˂e

				// 50
				SPREAD_MISSILE,		//! U~TCivC[Ƃj
				SPREADED_MISSILE,	//! Ũ~TC
				DIRTY_DROP,
				DIRTY_WIND,
				THUNDER_BALL,	//! 

				// 55
				MULTI_MISSILE_MOTHER,	//! èЯ
				MULTI_MISSILE_CHILD,	//! 
				WIND_EGG,		//! ability of wind boss
				ICE_SPIKE,
				SNOW_BALL,

				// 60
				SOWRD,			//! ice/fire/rock sowrd
				PON,
				BOUNCE_PON,		//! oEVO
				SURIKEN,		//! SURIKEN!
				HUGE_SURIKEN,	//! HUGE-SURIKEN!

				MAX_NUM,

				// ԕωp
				// +0
				BEAM_2 = MAX_NUM,
				PINE_APPLE_1,
				SATELITE,
				SPIDER_NET_BIG,
				ROBOT_BEAM_2,

				// +5

				ALL_MAX_NUM


//				HOMING_LASER,		//! z[~O[U[
//				HOMING_LASER_TAIL,	//! 
//				LASER,			//! [U[iHj
			};
		};


/*		namespace Talk{
			enum{
				CianKomari00,		//0
				ClanNormal00,
				ClanSmile00,

				EviGen00Normal00,
				
				CianNyoatsu00,
				EviNagashime00,		//5

				Danimoth,
				Fobos,

				TanyaMusuu,

				EviHimeNiyari,
				EviHimeHonki,		//10
				////////////////			
				// not yet
			};
		};*/
		namespace Neutral {
			enum Neutral_{
				//  0
				FAN,
				BURNER,
				MOVER,
				KILLER_FAN,	//! ݌^
				BED,

				//  5
				TANSU,
				DOOR_IDLE,
				TAKARA_BAKO,
				KILLER_TANSU,
				HELP,

				// 10
				NEXT,
				FUYU,
				EVIGEN_PARTS_ARM,
				EVIGEN_PARTS_LEG,
				EVIGEN_PARTS_BODY,

				// 15
				ROCK,
				TREE,
				EVIGEN_PARTS_HEAD,
				SWITCH_OFF,				// FƃtOrbgԍ11Ή
				LOCK_BLOCK,

				// 20
				CHECK_POINT,
				GENERATOR,				// neutral generator
				BARRIER,					//! oA(fтX^[)
				TANK,
				VTOL,					//! p

				// 25
				CAR,
				ROBOGEN,
				RIDE_CLOUD,
				WATER_FALL,
				ROUND_TRUNK,

				// 30
				DISPENSER_EVI,
				DISPENSER_AKU,
				DISPENSER_SIRU,
				DISPENSER_BU,
				DISPENSER_CA,

				// 35
				ICE,
				ALLY_FLOWER,
				MERC,			//! ܁[
				JAMMING,			//! 1/3
				SLIDE_CLOUD,	//! SlideCloud

				// 40
				BACK_CLOUD,
				BU_CLOUD,		//! 傢_o
				EFFECT_GENERATOR,	//! GtFNgiWFl[^ju
				
				MAX_NUM,

				//v
				//EVIL_TOWER,
				//BATTERY,

				// 
				// 0
				BROKEN_BED = MAX_NUM,
				OPEN_TANSU,
				DOOR_OPEN,
				TAKARA_BAKO_OPEN,
				OPEN_TANSU_MUSHA,	//! ނ
				// 5
				TANSU_MUSHAED,		//! ނ
				FUYU_EVI,
				SWICH_ON,
				BARRIER_EFFECT,
				BARRIER_DEAD,
				// 10
				ICE_DEAD,
				JAMMING_DEAD,

				ALL_MAX_NUM
				
			};
		};
		namespace Item {
			enum Item_ {
				//  0
				KOKEMOMO,
				MEAT,
				EVIL_DRINK,
				BATTERY,
				GATRING_GUN,
				//  5
				KAPIBARA,		
				ALPACA,
				DELTA,
				LAMDA,
				KAPPA,

				// 10
				COIN,
				BLUE_COIN,
				PINE_APPLE,
				MISSILE_LAUNCHER,
				SHOT_GUN,

				// 15
				RAIL_GUN,
				FRAME_THROWER,
				EVI_FLY,
				ANTI_POISON,
				CHAIN_SAW,
				//20
				PUNCH,
				DRILL,
				ELECTRIC_HOMING_LASER,
				HOMING_LASER,
				HOMING_MISSILE_LAUNCHER,
				// 25
				SATELITE_GUN,
				SNIPER_RIFLE,
				TOMAHAWK,
				WATER_GUN,
				MAYO_GUN,
				// 30
				LASER_GUN,
				MISSILE,
				HAND_GUN,
				CRYOLATOR,
				PILE_BUNKER,

				// 35
				NIKITA_MISSILE,
				EVI,
				AJI,
				STEAK,
				QUEEN_AUTHORITY,

				// 40
				SEED,
				BOSS_ABILITY,		//! \
				CAR_BALL_DUMMY,
				SPREAD_MISSILE_LAUNCHER,
				MULTI_MISSILE_LAUNCHER,
				
				// 45
				FLYING_COIN,	//! 1
				FLYING_COIN_10,
				FLYING_COIN_50,
				FLYING_COIN_100,
				FLYING_COIN_500,

				// 50
				FLYING_COIN_1000,
				FLYING_COIN_5000,
				FLYING_COIN_10000,
				
				COIN_10,
				COIN_50,

				// 55
				COIN_100,
				COIN_500,
				COIN_1000,
				COIN_5000,
				COIN_10000,

				// 45
				WIND_WIZARD,	//! chaser̓\͗p
				MAX_NUM
			};
		}

		namespace Alraune {
			enum {
				STAND_1,
				STAND_2,
				STAND_3,
				ATTACK,
				DAMAGED_1,
				DAMAGED_2,
				DAMAGED_3,
				ATTACK_DAMAGED_1,
				DEAD_1,
				DEAD_2,
				DEAD_3,
			};
		}

		namespace VTOLnya {
			enum {
				STAND,
				WALK,
				ATTACK_GATLING,
				ATTACK_MISSILE,
			};
		}
		namespace Robogen {
			enum {
				STAND,
				WALK,
				FLYDOWN,
				FLYUP,
				WALK_READY,
				GATLING,
				RAIL,
				MISSILE,
			};
		}
		namespace Car {
			enum Car_ {
				STAND,
				FLYUP,
				GALLON,
			};
		}

		namespace Merako {
			enum {
				STAND,
				WALK,
				FLYDOWN,
				ATTACK_SHOT,		//! shot
				ATTACK_EXPLOSION,	//! explosion
			};
		}
		namespace Medousa {
			enum {
				STAND,
				WALK,
				ATTACK,
			};
		}

		namespace Robot {
			enum {
				STAND,
				WALK,
				READY_TO_JUMP,
				FLYDOWN,
				LAND,
				MISSILE,
				BEAM,

			};
		}

		namespace Chaser {
			enum Chaser_ {
				STAND,
				ATTACK_1,
				ATTACK_2,
				DEAD,
				READY_TO_WALK,
				ARM,
				BORN,
			};
		}

		namespace GhostPair {
			enum GhostPair_ {
				STAND,
				ATTACK,
				ATTACK_2,
			};
		}
	}
	/*namespace Event{
		enum{
			DAMAGED,
			NEAR_DEATH,
			ABOUT_EVENT_OPTION,
		};
	};*/

	namespace SE {
		enum SE_ {
			// 0
			MINIGUN_STARTUP,		//! ]Jn
			MINIGUN_SHOT,			//! Vbg
			KETTEI,					//! 

			VOICE_START,
			// 4
			EVIGEN_DAMAGES = VOICE_START,			//! т_[W
			MAX_EVIGEN_DAMAGES = EVIGEN_DAMAGES + 7,
			// 10
			VOICE_END = MAX_EVIGEN_DAMAGES,
			EVIGEN_FINISH = MAX_EVIGEN_DAMAGES,

			EVIGEN_JIGO,
			EVIGEN_DEAD,
			CANCEL,		//! LZ
			BUZZ,		//! ubu[igpłȂj

			// 15
			BOSS_JUMP,		// {XbiWvj
			EXPLOSION,
			FALL_DEATH,
			EAT_0,
			EAT_1,

			// 20
			KUTYA_0,
			KUTYA_1,
			KUTYA_2,
			GIRI,		//! グ
			START_CHARGE,

			// 25
			CHARGE_END,
			JUMP,
			GET_ITEM,

			FRAME_THROWER,
			MISSILE_LAUNCHER,

			// 30
			SHOT_GUN,
			SAKU,			//! IHOLD
			CHAIN_SAW,		//! `F[\[qbg
			ALRAUNE_SCREAM,	//! AEl
			QBEE_WHISLE,	//! QBEÊadd
			//  35
			WOOD_BREAK,		//! ؔj
			CRYO,
			UNBREAKABLE,	//! 󂹂Ȃ
			SNIPER,			//! YL[zQ
			EVIL_GAGE_UP,

			// 40
			CHAIN_SAW_KEEP,	//! `F[\[̑ҋ@
			ELECTRIC,

			MAX_NUM
		};
	};
	/*
	namespace SEChannel{
		enum{
			// Gɓ鉹
			Slash,

			// ǂɓ鉹
			Hit,

			// eo鉹
			BulletFire,

			// ~jK̉
			MiniGun,

			Voice,
		};
	};
	*/
	namespace Music {
		enum Music_ {
			DOTYU,
			BOSS,
			STAGE_NORMAL,
			BAD_END,
			TITLE,
			SPACE,
			FOREST,
			FIRE,
			CLOUD,
			MAX_NUM
		};
	};

	namespace SceneType{
		enum {
			TITLE,				//!  0:
			SELECT_STAGE,		//!  1:
			SELECT_PLACE,		//!  2:
			GAME,				//!  3:
			STORY,				//!  4:
			ACHIEVEMENT,		//!  5:
			OPTION,				//!  6:
			CONTINUE,			//!  7:
			GAME_OVER,			//!  8:
			SPECIAL_DEAD,		//!  9:
			LIBRARY,			//! 10:
			EVENT_CHECK,		//! 11:
		};
	};

	/**
		Փx
	*/
	namespace Difficulty{
		enum{
			EASY,
			NORMAL,
			HARD,
			NIGHTMARE,

			MAX_NUM
		};
	};

	namespace PlayerType {
		enum {
			EVIGEN,
			TANYA,
			TANK,
			VTOL_NYA,
			CAR,
			ROBOGEN,
			ENEMY,
			MAX_NUM,
		};
	}
	namespace PlayerClassType {
		enum PlayerClassType_ {
			HUMAN,					//! lԁB蕨ɏ
			UNKNOWN,
		};
	}
	// TODO color palette
	namespace EnemyType {
		enum EnemyType_{
			//   0
			NAMAKO,						
			SLIME,
			EVI_HIME,
			MUNIERU,
			TANYA,		//! ڂ΂ցI

			//   5
			TANYA_YOUJO,	//! ڂ΂ցI
			HIDE_ENEMY_GENERATOR,	//! G(Ȃ)	generator
			MAZER,
			BLUE_SLIME,
			GREEN_SLIME,

			//  10
			YELLOW_SLIME,
			ARYONA,			//! A[i
			TOZICO,				//! Ƃ
			ELLIN,
			SLIME_QUEEN,
			
			//  15
			SHIHAN,
			SLIME_BABY,
			BLUE_SLIME_BABY,
			GREEN_SLIME_BABY,
			YELLOW_SLIME_BABY,
			
			//  20
			ARM,
			ARM_HEAD,
			ARAKHNE,
			IVY,
			IVY_2,

			//  25
			LAMIA,
			ROPER,
			SUCCUBUS,
			SUCCUBUS_MISAGO,
			ZOMBIE,

			//  30
			ROCK,
			BEE,
			QBEE,
			FLOWER,
			KUKI,

			//  35
			ALRAUNE,
			FUUN,
			RAI,
			WIND_BIT,
			ELEC_BIT,

			//  40
			EVIL_GATE,
			GHOST,
			MERAKO,
			CONDOR,
			//FIRE_PARTICLE,		// TODO ʂ̂̂ŒuI
			CHASER,

			// 45
			WORM,
			MEDOUSA,
			FIRE_ELEMENTAL,
			FROG,
			ROBOT,
			// 50
			GOKI,
			PIRANHA,	// sjA
			JET_PORT,	//! ΎRo
			CYCLON,		//! ނ
			ISO,		//! C\M`N

			// 55
			SUN,
			ROCK_2,
			ROCK_2_SMALL,
			SHARK,
			MUTANT_GEL,

			// 60
			UNI,
			DIRTY_CLOUD,
			FAN_BIRD,
			JEALOUS_GHOST,
			SORROW_CLOUDS,

			// 65
			SHABONER,
			//SHABON,
			MINI_BEE,
			BEE_HIVE,
			JACKPOT,

			LAVA,
			// 70
			LAVA_UNDER,
			LAVA_BALL,
			LAVA_ELEMENTAL_MONSTER,	//! [oE[o
			LAVA_ELEMENCO,			//! Mh
			ICE_ELEMENTAL_MONSTER,	//! 

			// 75
			ICE_ELEMENCO,	//! ߂񂱂Fbt[
			ICICLE,
			GHOST_PAIR,
			AIKO,		//! /Cj[rainy
			GHOST_PAIR_SHIELD,	//! ̕

			// 80
//			LAVA_HOUSE_CARL,

			MAX_NUM
			// SENTRY
			
		};
	};
	namespace GeneratorType {
		enum {
			SLIMES,			//! ԃXC
			TANYAS,			//! ^[j
			ROCKS,			//! 
			YELLOW_BEES,	//! Fijj
			RED_BEES,		//! ԁi͂݁j
			ALL_BEES,		//! 
			LAVA_BALLS,		//! Lava_Ball
			LAVA_UNDER,		//! LavaUnder
			
		};
	}

	static const int TALK_FRAME_LEFT = 0;		//! bEChE̍
	static const int TALK_FRAME_TOP = 240;		//! bEChȄ

	extern const float SCROLL_LENGTH_TO_SPEED_RATE;	//! XN[̈ړxɂ銄
	extern const float SCROLL_LENGTH_LIMIT;			//! EBȏ㗣ꂽŐɖ߂
	extern const float UNDER_PLAYER;
	extern const float FOOT_PLAYER;
	extern const float IN_WATER_RESIST_RATE;	//! ł
	extern const float IN_WATER_GRAVITY_RATE;	//! ł̏d͔䗦
	extern const float JUMP_FIRST_SPEED_RATE;	//! x
	extern const float SELECT_PLAYER_WALK_SPEED;	//! Iʂł̃vC[ړx
	extern const float SELECT_PLAYER_GOAL_THRESHOLD;	//! IʂŁAڕWn_ɓBǂ臒l
	extern const float MOVER_SPEED_X;			//! Mover̈ړx(X)
	extern const float MOVER_SPEED_Y;			//! (Y)
	extern const int MOVER_WAIT_FRAME;			//! ڐG̃EGCg
	extern const float LEVEL_EPSILON;			//! x0̏ꍇ0-division 𐔒l
	extern const float WIND_SPEED_Y;
	extern const float WIND_SPEED_DELTA_Y;
	extern const float WIND_SPEED_X;
	extern const float WIND_SPEED_DELTA_X;
	extern const float GATLING_SPD;
	extern const float GATLING_ERR;
	extern const float BLOCK_BITE_DAMAGE;		//! ubNɂԂꂽƂ̃_[W
	extern const int BLOOD_RND_MIN;				//! 򖗃GtFNgMIN
	extern const int BLOOD_RND_MAX;
	extern const float BLOOD_ERR_DEGREE;		//! 򖗂̔Ԋpx̌덷
	extern const float BLOOD_SPEED_RND_MIN;		//! 򖗂̑xMIN
	extern const float BLOOD_SPEED_RND_MAX;
	extern const int BLOOD_DELTA_MAX_X;
	extern const int BLOOD_DELTA_MAX_Y;
	extern const int BLOOD_DELTA_Y_BASE;
//	extern const int COLLISION_OBJECT_HIT_AREA_DELTA;	//! IuWFNgm̓蔻ɂ锻{
	extern const int COLLISION_OBJECT_HIT_AREA_DELTA_BOTTOM;	//! ̍
	extern const float MAX_BRUST_ACCEL_Y;
	extern const float MAX_BRUST_ACCEL_X;
	extern const int FAN_BRUST_LENGTH;			//! t@̉e͈
	extern const float SELECT_STAR_THRESHOLD;	//! I臒l
	extern const float SELECT_STAR_MOVE_SPEED;
	extern const float SELECT_STAR_MOVE_ACCEL;
	extern const int HP_METER_LEFT;						//! HP[^[̕\ʒu
	extern const int HP_METER_TOP;
	extern const float PLAYER_LADER_DX;					//! [_[̑΍W
	extern const float PLAYER_LADER_DY;
	extern const int HOMING_LASER_2_DEACCEL_FRAMES;		//! t[
	extern const float HOMING_LASER_ACCEL;				//! x
	extern const float HOMING_MISSILE_ACCEL;
	extern const int TARGETTING_REMAIN_COUNT;			//! ^[QbeBO݂鎞
	extern const float HOVER_WEAPON_GRAVITY_RATE;		//! ꕐ픭˒̏d͊
	extern const float BED_JUMP_VELOCITY_Y;				//! xbh̃Wv
	extern const float KILLER_FAN_DAMAGE;
	extern const float KILLER_FAN_BRUST_SPEED_RATE;		//! ݂̗
	extern const int PLAYER_INVINSIBLE_FRAMES;		//! G
	extern const float ENEMY_NEAR_THRESHOLD;		//! G߂Â߂Ȃ悤ɂ邽߂臒l
	extern const int EMOTION_ICON_DELTA_X;			//! G[VACȒΈʒu
	extern const int EMOTION_ICON_DELTA_Y;
	extern const float BOUNCE_DAMAGE_TO_BED;
	extern const char* const SE_LIST_FILE_PATH;
	extern const char* const MUSIC_LIST_FILE_PATH;
	extern const float ITEM_NEAR_DISAPPEAR_RATE_THRESHOLD;	//! ACe銄
	static const int MAX_FLAGS = 100;	//! ftHgŊmۂtO
	static const int MAX_OPTION_FLAGS = 100;
	extern const int ITEMS_PER_ROW_IN_MENU;
	extern const int ITEM_LEFT_IN_MENU;
	extern const int ITEM_TOP_IN_MENU;
	extern const int ITEM_WIDTH_IN_MENU;
	extern const int ITEM_HEIGHT_IN_MENU;
	extern const int ITEM_INTERVAL_X_IN_MENU;
	extern const int ITEM_INTERVAL_Y_IN_MENU;
	extern const int ENEMY_GENERATE_INTERVAL_BASE;	//! G
	extern const int ENEMY_GENERATE_INTERVAL_ERROR;

	extern const float KOKEMOMO_CURE;				//! 񕜗
	extern const float MEAT_CURE;
	extern const float EVIL_DRINK_CURE;
	extern const float EVIL_DRINK_GAGE_ADD;			//! т鉻Q[W
	extern const float EVIL_DRINK_ORB_GET;			//! I[u炦邩
	extern const int EVIL_BEAM_GAGE_ADD;			//! тr[ő
	extern const float MAZER_DISTANCE;
	extern const float MAZER_ACCEL;
	extern const float MAZER_MAX_SPEED;
	extern const float ENEMY_MOVE_ACCEL;
	extern const float ENEMY_JUMP_SPEED;
	extern const int PLAYER_HP_MAX;	//! ftHgHP
	extern const float PLAYER_HALF_HP_THRESHOLD_RATE;	//! p̃Cxg
	extern const float PLAYER_QUARTER_HP_THRESHOLD_RATE;	//! p̃Cxg
	extern const int MAX_EVIL_GAGE;
	extern const int DEFAULT_MAX_EVIL_ORB_NUM;				//! ftHgŎĂI[u̐
	extern const int MAX_ORB_CARRIABLE_NUM;				//! łő吔
	extern const float CURE_EFFECT_CREATE_RADIUS_MIN;	//! ڐG_ǂꂾ炷
	extern const float CURE_EFFECT_CREATE_RADIUS_MAX;
	extern const float CURE_EFFECT_CREATE_VELOCITY_MIN;	//! 
	extern const float CURE_EFFECT_CREATE_VELOCITY_MAX;
	extern const int CREATE_CURE_EFFECT_NUM_MIN;		//! 쐬CUREGtFNg̐
	extern const int CREATE_CURE_EFFECT_NUM_MAX;
	extern const float CURE_FLOW_UP_SPEED_MIN;
	extern const float CURE_FLOW_UP_SPEED_MAX;
	extern const float RESIST_IN_THE_AIR_RATE;		//! 󒆂ł̌(m_Setting.resistɊ|)
	extern const float SELECT_VTOL_THRESHOLD;
	extern const float SELECT_VTOL_SPEED;
	extern const int DEFAULT_REMAIN_NUM;		//! Q[𗧂グƂ̍ŏ̎c@
	extern const int MAX_REMAIN_NUM;			//! ݒ\ȍőc@
	extern const float CURE_STAR_SIZE_RATE_MIN;	//! ^Cg̔wiɔ΂
	extern const float CURE_STAR_SIZE_RATE_MAX;
	extern const float CURE_STAR_DEFAULT_SPEED;
	extern const int CURE_STAR_NUM_MIN;
	extern const int CURE_STAR_NUM_MAX;
	extern const int CONTINUE_CURSOR_X;
	extern const int CONTINUE_CURSOR_Y;
	extern const int PUSH_R_LEFT;
	extern const int PUSH_R_TOP;
	extern const char* const ACHIEVEMENT_FILE_PATH;
	extern const float ACHIEVEMENT_FLOW_UP_SPEED;		//! achievement̂オXs[h
	extern const float ACHIEVEMENT_FLOW_DOWN_SPEED;		//! achievement̉Xs[h
	static const int MAX_LEVEL_LABEL_STRING_LENGTH = 30;
	static const char LEVEL_LABELS[][MAX_LEVEL_LABEL_STRING_LENGTH] = {
		"YUTORI",
		"EASY",
		"NORMAL",
		"HARD",
		"NIGHTMAREEEEEEEEEEEEEEEE!!!"
	};
	extern const float TAKARABAKO_ENEMY_JUMP_SPEED_Y;	//! 󔠂oĂGWv鑬x
	extern const float TAKARABAKO_ENEMY_JUMP_SPEED_X;
	extern const int MISSILE_CONTRAIL_CREATE_INTERVAL;	//! ~TC̐KԊu
	extern const float EXPLOSION_SMOKE_SPEED_MIN;
	extern const float EXPLOSION_SMOKE_SPEED_MAX;
	extern const int ACHIEVEMENT_X;
	extern const int OPTION_OK_CANCEL_INTERVAL_X;
	extern const int ENEMY_HP_METER_DELTA_Y;
	extern const float ENEMY_POWER_BASE;	//! ڐGU
	extern const float ENEMY_BLOW_BASE;		//! ёx
	extern const float ENEMY_HP_BASE;
	extern const float CONTINUE_CURSOR_INTERVAL_X;	//! ReBj[ʂ̃J[\̈ړ
	extern const int START_WAIT_COUNT;	//! ŏ͑łȂ
	extern const int ACHIEVEMENT_ICON_DELTA_X;
	extern const int ACHIEVEMENT_ICON_DELTA_Y;
	extern const int ACHIEVEMENT_TEXT_DELTA_X;
	extern const int ACHIEVEMENT_LABEL_DELTA_Y;
	extern const int ACHIEVEMENT_DESCRIPTION_START_DELTA_Y;
	extern const int ACHIEVEMENT_DESCRIPTION_INTERVAL_Y;
	extern const int ACHIEVEMENT_COUNT_DELTA_X;
	extern const int ACHIEVEMENT_COUNT_DELTA_Y;
	extern const int ACHIEVEMENT_SCROLL_ACCEL;
	extern const int ACHIEVEMENT_SCROLL_MAX_SPEED;
	extern const float FUYU_RIDING_SPEED_Y;
	extern const float FUYU_AFTER_RIDE_SPEED;
	extern const float FUYU_AFTER_RIDE_FLOW_UP_SPEED;
	extern const int PUNCH_HIT_RECT_SIZE;
	extern const int PUNCH_HIT_RECT_SIZE_Y;
	extern const float FUYU_MAX_ACCEL;
	extern const char* const COMMON_EVENET_PACK_FILE_PATH;
	extern const float MISSILE_FIRST_SPEED;
	extern const float MISSILE_ACCEL;
	extern const float MISSILE_MAX_SPEED;
	extern const float BLUE_SLIME_JUMP_SPEED;
	extern const float BLUE_SLIME_JUMP_DISTANCE_THRESHOLD;
	extern const int SLIME_CLIP_DAMAGE_INTERVAL_MIN;			//! `bv^Ԋu
	extern const int SLIME_CLIP_DAMAGE_INTERVAL_MAX;
	extern const float SLIME_CLIP_SPEED_X;
	extern const float SLIME_CLIP_SPEED_Y;
	extern const float FUYU_MAX_LENGTH;		//! PlaceI𕂗Vт̏㉺ړ
	extern const int SLIME_QUEEN_WAIT_FOR_START;
	extern const int SLIME_QUEEN_WAIT_FOR_NEXT;
	extern const int SLIME_QUEEN_SHOT_INTERVAL;
	extern const float SLIME_QUEEN_RED_ACCEL;
	extern const float SLIME_QUEEN_MAX_SPEED;
//	extern const float SLIME_QUEEN_JUMP_SPEED_X;
	extern const float SLIME_QUEEN_JUMP_SPEED_Y;
//	extern const int SHOT_GUN_BULLET_NUM_MAX;		//! VbgK1x̔ː
//	extern const int SHOT_GUN_BULLET_NUM_MIN;
	extern const float SMOKE_SPEED_Y;				//! ̈ړx(Y)
	extern const float SLIME_QUEEN_SMOKE_DELTA_X;	//! 𐶐Ԋu
	extern const float SLIME_QUEEN_GENERATE_VEL_ERR_X;	//! XCNB[REDSLIME𔭐鎞X덷
	extern const float SLIME_QUEEN_GENERATE_VEL_Y_MIN;	//! 
	extern const float SLIME_QUEEN_GENERATE_VEL_Y_MAX;
	extern const int SLIME_QUEEN_SMOKE_INTERVAL;
	extern const float SLIME_QUEEN_SMOKE_ERR;
	extern const int SLIME_QUEEN_SMOKE_MIN;	//! 
	extern const int SLIME_QUEEN_SMOKE_MAX;
	extern const int INVINSIBLE_ALPHA;		//! GԒAlpha
	extern const float EFFECT_HIT_ERR;		//! qbgGtFNg̃_
	extern const int ACHIEVEMENT_STAY_FRAME;	//! ACHIEVEMENT[ő҂
	extern const int ENEMY_BOSS_LIFE_BAR_MERGINE;
	extern const int ENEMY_BOSS_LIFE_BAR_INTERVAL_X;
	extern const int ENEMY_BOSS_LIFE_BAR_Y_FROM_BOTTOM;	//! o[̉FromWindow̉[
	extern const int SELECT_CURSOR_LEFT;
	extern const int SELECT_CURSOR_TOP;
	extern const float BLUE_SLIME_JUMP_SPEED_X;
//	extern const int CURSOR_DELTA_Y;
	extern const int ZANZO_CREATE_INTERVAL;
	extern const int PLAYER_POISON_REMAIN;
	extern const float POISON_DAMAGE;
	extern const int POISON_DAMAGE_INTERVAL;
	extern const int DEFAULT_SUPER_POWER_REMAIN;		//! SuperPower̍őliŒj
	extern const int DEFAULT_SUPER_POWER_DECREASE;
	extern const int SLIME_QUEEN_JUMP_NUM;				//! ł̃Wv
	extern const float SLIME_QUEEN_SHOT_SPEED_Y;
	extern const float HOLD_DAMAGE_RATE;
	extern const int MENU_SUPER_POWER_LEFT;
	//extern const int MENU_SUPER_POWER_TOP;
	extern const int MENU_SUPER_POWER_INTERVAL_X;
	extern const float SLIME_QUEEN_YELLOW_CREATE_PROBABILITY;
	extern const float SLIME_QUEEN_SHOT_ERR;
	extern const int SLIME_QUEEN_ARM_NUM;
	extern const float SLIME_QUEEN_FLYING_DAMAGE_RAGE;
	extern const float SLIME_QUEEN_ARM_SPEED;
	extern const float SLIME_QUEEN_BERSERK_RATE;
	extern const float SLIME_CLIP_CLEAR_PROBABILITY;		//! Uقǂm
	extern const int SLIME_QUEEN_RED_CREATE_WAIT;	//! \ɂȂ܂ł̃t[B
													//! AŃqbgꍇAȏo߂ȂƐȂ
	extern const int CREATE_SLIME_CHIP_MIN;
	extern const int CREATE_SLIME_CHIP_MAX;
	extern const float SLIME_QUEEN_ARM_DELTA_MAX_LENGTH;
	extern const float SLIME_QUEEN_GREEN_ARM_UP_X;
	extern const float SLIME_QUEEN_GREEN_ARM_UP_Y;
	extern const float SLIME_QUEEN_GREEN_DISON_ACCEL;
	extern const float SLIME_CHIP_ERR_X;
	extern const float SLIME_CHIP_ERR_Y_MIN;
	extern const float SLIME_CHIP_ERR_Y_MAX;
	extern const float GREEN_SLIME_CLIP_DOWN_RATE;		//! ΃XCőx̊
	extern const float HOLD_CLEAR_PROBABILITY;			//! Sӂقǂm
	extern const float SLIME_QUEEN_SMOKE_ERR_Y;
	extern const float EVIGEN_LIMIT_AREA_UNDER_BOTTOM_MERGINE;	//! [ǂꂾz玀ʂ
	extern const float VACUUM_ALL_FRAMES;
	extern const float SLIME_QUEEN_VACUUM_DEGREE_ERR;
	extern const float SLIME_QUEEN_VACUUM_LENGTH_MIN;
	extern const float SLIME_QUEEN_VACUUM_LENGTH_MAX;
	extern const int BUTTON_BRINK_SPEEDUP_NUM;			//! {^_łƂ̑x
	extern const int GAME_SUPER_POWER_LEFT;
	extern const int GAME_SUPER_POWER_TOP;
	extern const float PLAYER_SLIME_CLIP_POWER_RATE;
	extern const float PLAYER_ANOTHER_DOUBLE_JUMP_PROBABILITY;	//! ςWvm
	extern const float PLAYER_ROLLING_DOUBLE_JUMP_PROBABILITY;	//! ςWv̂Ƃ
	extern const float ENEMY_AIR_MOVE_ACCEL_RATE;	//! 󒆂̈ړx{
	extern const float PLAYER_GRAVITY_DELTA;	//! vC[ɂ݂̂d͍
	extern const float THROW_VELOCITY_ANGLE_RATE;	//! Ƃ̑xiXB145xj
	extern const float SHOT_GUN_ERR;
	extern const float FUYU_DISAPPEAR_POSITION_Y;
	extern const float ROCK_NO_HIT_THRESHOLD;		//! ₪ȂȂXs[h
	extern const float GENERATOR_X_ERR;
	extern const float GENERATOR_VEL_X_ERR;
	extern const float GENERATOR_VEL_Y_MIN;
	extern const float GENERATOR_VEL_Y_MAX;
	extern const float ROCK_ROTATE_DEGREE_SPEED_MIN;
	extern const float ROCK_ROTATE_DEGREE_SPEED_MAX;
	extern const float EXPLOSION_DAMAGE_RAGE;			//! ExplosionuGvɗ^_[W䗦
	extern const float HOMING_TARGET_LENGTH_THRESHOLD;
	extern const float ITEM_CREATE_ERR_X;
	extern const float ITEM_CREATE_ERR_Y_MIN;
	extern const float ITEM_CREATE_ERR_Y_MAX;
	extern const int COINS_PER_BLUE;
	extern const float COINS_PER_HP_BASE;
	const int MAX_SHORTCUT_NUM = 9;
	extern const float ENEMY_SHOT_DISTANCE_THRESHOLD;	//! GUߋȖI臒l
	extern const float ITEM_DRAW_SCALE_RATE;
	extern const int BEE_SHOOT_INTERVAL;				//! ˊԊu
	static const char* SAVE_PATH_FORMAT = "drtanya%d.sav";
	extern const float IMMUNITIES_DAMAGE_RATE;
	extern const float WEAKNESS_DAMAGE_RATE;
	extern const int AFTER_BOSS_DEFAULT_WAIT_FRAME_NUM;	//! {Xjɑ҂t[
	extern const HPLRect TANK_HIT_RECT;
	extern const HPLRect VTOL_HIT_RECT;
	extern const HPLRect CAR_HIT_RECT;
	extern const HPLRect ROBOGEN_HIT_RECT;
	extern const int FIRE_EFFECT_CREATE_NUM;	//! GtFNg
	extern const int FIRE_EFFECT_CREATE_INTERVAL;
	extern const float ROTATE_STOP_VELOCITY_THRESHOLD;	//! ]~臒liȂǁj
	extern const int DARK_BUTTON_BRIGHT;	//! 炢Ԃ̃{^Bright(0`255)
	extern const int SOLID_DEFAULT_FRAME;	//! ł߂̕A
	extern const int EVIL_BEAM_SPEED;
	extern const int CHASER_ATTACK_1_ARM_DELTA_X;
	extern const int CHASER_ATTACK_1_ARM_DELTA_Y;
	extern const int CHASER_ATTACK_2_DELTA_X;
	extern const int CHASER_ATTACK_2_DELTA_Y;
	extern const float SLIDE_CLOUD_SPEED;		//! ChaserʂȂǂł̉o_
	extern const int FONT_WIDTH;	//! WIȃtHg̕
	extern const int FONT_HEIGHT;	//! WIȃtHg̍
	static const char TRUE_STR[] = "TRUE";
	extern const float CHASER_CHASE_ACCEL;
	extern const float CHASER_CHASE_MAX_SPEED;
	extern const int LAVA_UP_SPEED;	//! n₪オXs[h
	extern const int ENEMY_POINT_DEFAULT;
	extern const int SHOT_POINT_DEFAULT;
	extern const int CHASER_THUNDER_SHOT_ABOVE_DISTANCE;

	namespace LevelType {
		enum {
			YUTORI,
			EASY,
			NORMAL,
			HARD,
			NIGHTMAREEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE,
			MAX_NUM
		};
	}
	extern const float LEVELS[LevelType::MAX_NUM];

	namespace TileType {
		enum {
			NOSPECIAL,		//! ɉȂ
			SWIM,			//! j
			ON_THE_WATER,	//! 
			SLOW,			//! ݂Ȃ
		};
	}

	namespace PaletteType {
		enum {
			DEFAULT,
			ROCK,
			WATER,
			FIRE,
			FOREST,
			WIND,
			ELECTRIC,

		};
	}

	namespace StageType {
		enum StageType_ {
			EVIL_STAR,	//! 0:т鐯
			ROCK,		//! 1:
			WATER,		//! 2:
			FIRE,		//! 3:
			FOREST,		//! 4:X
			WIND,		//! 5:
			ELECTRIC,	//! 6:dC/@B
			MAX_STORY_STAR,
			TOZI_STAR = MAX_STORY_STAR,	//! 7:Ƃ
			REST_STAR,	//! 8:xe
			TOWER,		//! 9:
			MAX_NUM
		};
	}
	/** ẽC[WJ[BGACeɔf
	  */
	static const int STAR_COLOR[][3] = {
		{255,50,0},	//! 0:т鐯	Ԓ
		{100,100,0},		//! 1:	
		{0,0,255},		//! 2:	
		{255,0,0},		//! 3:	
		{0,255,0},		//! 4:X	
		{200,200,200},	//! 5:	
		{20,20,20},		//! 6:dC/@B	ij
		{200,180,0},	//! 7:Ƃ	
		{255,255,0},	//! 8:xe	
		{50,50,50},		//! 9:		
	};
	namespace SuperPowerType {
		enum SuperPowerType_ {
			QUEEN_AUTHORITY,		//! ̈ꐺF4ނ̒烉_Ŕ
									//! red		:XCij납痈đ̓
									//! blue	:Oɐ3̍~ė
									//! green	:΃XC炱ɌďoĂBGGƓŏԂɂȂĈ莞ԃ_[W
									//! yellow	:FXCvC[̌3̏oĂ45xŔ

			SEED,					//! A킥c
									//! ΂炭nʂɂĂƁAɉԂ炭B
									//! Ԃ炭ƉԕƗtςˏoiGɂ̂݃qbgj

			WIND_WIZARD,			//! `FCT[
									//! gpJnƋɁAړł
									//! UL[ƁA̐@𐶐ʂo
			//FIRE,
			//WATER,
			MAX_NUM
		};
	}
	namespace PlaceType {
		enum PlaceType_ {
			COMPLETED,
			CLEARED,
			REVEALED,
			SEALED,
			MAX_NUM
		};
	}
	namespace WeaponDirection {
		enum WeaponDirection_ {
			FRONT,
			FRONT_UP,
			FRONT_DOWN,
			
			// not yet
			UP,				//! ^
			DOWN,			//! ^

			MAX_NUM
		};
	}
	namespace WeaponDirType {
		enum {
			STATIC = 2,		//! FRONTŒ
			SIX = 6,		//! OA΂ߏA΂߉6
			EIGHT = 8,		//! ^A^܂
		};
	};
	/////////// neutral mover
	namespace MoverType {
		enum {
			NONE,				//! No Move
			LEFT_RIGHT,			//! HorizontalAEړ
			UP_DOWN,			//! VerticalA㉺ړ
			DISAPPEAR,			//! 
			ROTATE,				//! ]鑫
			ROTATE_REVERSE,		//! t]
			RIGHT_LEFT,			//! ܂E
			DOWN_UP,			//! ܂
			FALL,			//! shake a little and fall
			MAX_NUM	
		};
	}
	/** t@̕ݒ
	  * E1]
	  * 0=UP, 1=RIGHT, 2=DOWN, 3=LEFT
	  */
	namespace FanDirectionType {
		enum {
			UP,
			RIGHT,
			DOWN,
			LEFT,
			MAX_NUM
		};
	}

	namespace EnemyAttribute {
		enum {
			RETURN_AT_EDGE,			//! RɗԂ
			NO_RECOGNIZE,			//! vC[ɋCÂ/CÂȂ̏̈ႢȂ
			HAS_DEAD,				//! SAj[VBꂪI܂ł݂͑
			HAS_PALETTE,			//! J[pbg
			JUMP_OVER_COLLISION,	//! QɐGƁAWvŏz
									//! vC[ɋ߂Âꍇ͂̂܂܂ǂǂz
									//! ǂŔΌɂȂꍇ̓WvĔΌɂȂ
			RANDOM_FACE_DIRECTION,	//! ݒuɃ_
			INVINSIBLE,				//! Cxgp̖G
			MAX_NUM
		};
	}

	namespace WearStateType {
		enum {
			NORMAL,					//! ChX[c
			NAKED,					//! ڂ
		};
	}
	/** 𒅂Ă邩ǂŎ󂯂_[WقȂ
	  */
	const static float WEAR_DAMAGE_RAGE[] = {
		1.f,
		2.f,
	};

	namespace MountType {
		enum {
			NONE,			//! Ȃi蔻̗L̂݁j
			BLOCK,			//! ≺̔LAdȂȂBiׂj
			THROW,			//! ォ̂ݏBȊO̕AWvƂidy<0)̎̓X[
		};
	}

	/** GfBO̎
	  */
	namespace SaveEndingType {
		enum {
			NORMAL_GAME_OVER,
			SLIME_QUEEN_GAME_OVER,
			QBEE_GAME_OVER,
			ALRAUNE_GAME_OVER,
		};
		
	}
	namespace FlagType {
		enum FlagType_ {
			//   0
			STAR,			//! IĂ遙
			PLACE,			//! IĂXe[W
			START,			//! i
			MEET_TANYA,		//! tanyaɉ
			EVIL_ORB_NUM,	//! ̃I[u(0`)

			//   5
			EVIL_GAGE,		//! GrQ[Wi0`100j
			EVILED_EVIGEN,	//! т񂪂т鉻ixłj
							//! ݂ǂ̓GrQ[WŊmF
			EVILED_TANYA,	//! ɂႪт鉻iCxgŁHj
			TOZICO_MEET,	//! ƂƉĂ邩(1̐1)
			TOZICO_ALIVE,	//! Ƃ̏(StateType::)
			
			//  10
			TOZICO_REBEAL,	//! Ƃ球tO(2^StageType)
			TOZICO_DEATH_NUM,//! ƂꂵXe[W
			EVIL_ORB_MAX,	//! ݏ\ȃI[u
			ARYONA_MEAT,	//! A[i(2^StageType)
			DESTROY_BARRIER,	//! oAj󂵂H(2^StageType)

			//  15
			ONE_TALK,			//! Z[uʂĈ񂵂Ȃ
			DESTROY_BOSS,		//! {Xj(2^StageType)
			ENDING,				//! ǂENDING(2^EndingType)
			DESTROY_JAMMING,	//! xe̖WQdguj󂵂

			VTOL_JAMMING,		//! ݂1/3
								//! 0:VTOLo
								//! 1:W~O
								//! W~O
			//  20
			GET_ABILITY,		//! AreBQbg
			MERC_TALK,			//! }[Zi[̑䎌(2^StageType)
			
			// 󔠂^XJǂ́AACetOZ[uŊǗ

			// 

			MAX_NUM
		};
		namespace JammingFlagType {
			enum JammingFlagType_ {
				NO_VTOL,	//! ܂1fUĂȂ
				JAMMING,	//! 
				DESTROYED,	//! 
			};
		}
	}
	/** Q[Sʂ̃IvVݒ
	  */ 
	namespace OptionFlagType {
		enum OptionFlagType_ {
			NO_NEAR_DEAD_SPEAK,//! mZtOFF
			MUSIC_VOLUME,	//! 0`255 BGM
			SE_VOLUME,		//! 0`255 ̑SE
			VOICE_VOLUME,	//! 0`255 ̉
			MAX_SHORTCUT_NUM,	//! 1`9	// V[gJbgől
			INMO,			//! Aѕ\
			GURO,			//! O\
			MAX_NUM,
		};
	}
	/** Z[uʂ1񂾂sCxgʗp
	  * rbgǗ
	  */
	namespace OneTalkType {
		enum OneTalkType_ {
			EVILIZE,		//! т鉻x
			WEAPON_PALETTE,	//! o^pbg̐
			LOOP,			//! [v̐
			MISSILE,
			BATTERY,
			CLEAN_SLIMES,	//! ق̃XC̃A
			FIRST_BARRIER,	//! ŏ̃oAj

		};
	}
	namespace StartType {
		enum {
			OPENING,			//! I[vjO
			PRACTICE,			//! PRACTICEIĂȂ
			EVIL_HOUSE_BED,		//! xbhX^[g
			UNTIL_LOBBY,		//! r[o܂
			UNTIL_BAVEL,		//! ox֓B܂ł̊
			UNTIL_FUYU_EVIL,	//! Vт铞B܂ł̊ԁij
			STARS,				//! I(C)
			
		};
	}

	namespace AchievementType {
		enum {
			//  0
			BED_CRASHER,		//! 000 bed crasher 50
			EVIL_BASTER,
			EVIL_WARRIER,
			EVIL_TERMINATER,
			AWAKEN,

			//  5
			FAT,
			ALRAUNE_WATER,	
			RESPAWN_MASTER,
			GOLD_RUSH,
			APPLE_JUMPER,

			// 10
			MISSILE_JUMPER,
			MANY_SLIMES,
			ARMORY,
			CURE_A_LOT,
			PLAY_LONG,

			// 15
			CURE_WITHOUT_DEATH,
			SELF_KILLER,
			FIGHTING_MAID,
			MAGICIAN_GIRL,
			NO_VEHICLE,

			// 20

			MAX_NUM
		};
	}

	namespace SlimeQueenCounterType {
		enum {
			WAIT_FOR_START,		//! ŏ̑҂
			WAIT_FOR_NEXT,		//! UƍŮԂ̑҂
			SHOT_INTERVAL,		//! ˊԊu
			JUMP_COUNT,			//! Wv
			CREATE_INTERVAL,	//! NGCgԊu
		};
	}
	namespace AlrauneFlowerColorType {
		enum {
			RED,
			BLUE,
			YELLOW,
		};
	}
	namespace AlrauneAttackType {
		enum {
			TENTACLE,
			LEAF,
			KAHUN,
			BUG,
			LEAF_BACK,
			MAX_NUM
		};
	}
	namespace AryonaAttackType {
		namespace Forest {
			enum {
				SUMMON_SLIME,
				SUMMON_SKYTHE,
				MAX_NUM
			};
		}

		namespace Wind {
			enum Wind_ {
				SUMMON_SHABON,	// shabon & bird
				SUMMON_SUN,		// sun
				MAX_NUM
			};
		}

	}
	namespace MerakoAttackType {
	}
	namespace SlimeQueenColorType {
		enum {
			RED,
			BLUE,
			GREEN,
			YELLOW,
			MAX_NUM
		};
	}
	namespace SlimeQueenColors {
		static HPLColor COLORS[] = {
			HPLColor(255,0,0),
			HPLColor(0,0,255),
			HPLColor(0,255,0),
			HPLColor(255,255,0) 
		};
	}

	namespace EnemyClassType {
		enum {
			EVIL_ZAKO,	//! Gт
			EVIL_BOSS,	//! {Xт
			EVIL_HERO,	//! 
			ARM,		//! rƂ̕ti
			ARM_HEAD,	//! 
		};
	}

	/** FI
	  */
	namespace RGB {
		enum {
			RED = 0x0001,
			GREEN = 0x0002,
			BLUE = 0x0004,
			RED_AND_GREEN = RED | GREEN,
			RED_AND_BLUE = RED | BLUE,
			GREEN_AND_BLUE = GREEN | BLUE,
			ALL = RED | GREEN | BLUE

		};
	}

	namespace SpecialMapIndex {
		enum {
			PRACTICE			= 9,		//! vNeBX
			EVIL_HOUSE_FRONT	= 10,		//! тّO
			BAVEL				= 15,		//! 
			SLIME_QUEEN			= 16,	//! SLIME_QUEEN
			FOREST_START		= 18,		//! Forest start 
			RESORT_ISLAND		= 21,		//! ][g
			FOREST_FORCE_SCROLL = 25,
			BEE					= 26,		//! QBEE
			BEE_HOUSE			= 27,	//! after QBEE
			THREE_WAY			= 28,	//! 3 way
			ALRAUNE				= 29,	//! alraune
			WIND_ENTRANCE		= 33,		//! start at 1
			FOREST_ARYONA	= 34,	//! XXe[W̃A[i
			FOREST_POWER			= 35,	//! Forest Power orb
			WIND_FUU_RAI		= 37,
			WIND_RIDE_CLOUD		= 38,
			EVIL_HOUSE_LOBBY	= 39,		//! тPƂނɂނ
			WIND_SNIPER			= 41,
			FIRE_ENTRANCE		= 42,		//! i
			MERAKO				= 48,		//! ߂炱{XXe[W
			WIND_KAZE			= 56,
			LIBRARY				= 58,		//! }ӗp
			WIND_HIGH_SPEED		= 62,		//! XN[
			WIND_ARYONA			= 63,		//! ̃A[i
			WIND_BOSS_1			= 64,		//! {X1
			WIND_BOSS_2			= 65,		//! {X2
			SELECT_STAR			= 67,		//! Iʗp
			SUNNY_MEET			= 68,		//! ưƑ
			VTOL_BAD			= 69,		//! VTOL - bad1(eat evigen)
			CHASER_BAD			= 70,		//! Chaser - bad
			VTOL_GOOD			= 72,		//! VTOL - good
			VTOL_BAD2			= 73,		//! VTOL - bad2(eat tanya)
			TEST_CHEST			= 75,		//! item/chest test chumber
			SNOW01				= 77,		//! 
		};
	}
	namespace SpecialScenarioIndex {
		enum {
			EVIL_HOUSE_LOBBY_MORNING_EVIGEN =  3,
			CHONPA_TANSU					=  5,
			OPENING							= 14,	//! I[vjO
			TOZICO_AFTER_OPEN_EVILSTAR		= 26,
			GET_OUTTER_EVIL_HOUSE			= 21,	//! тقo
			ARYONA_EVIL_STAR				= 29,
			AFTER_SLIME_QUEEN				= 32,
			FIRST_BAVEL						= 33,
			AFTER_ALRAUNE					= 35,
			EVILIZE_CAUTION					= 39,	//! т鉻Ƃ̐

			WEAPON_PALETTE_EXPLAIN			= 40,	//! pbg
			LOOP_EXPLAIN					= 41,	//! [v̐
			MISSILE_EXPLAIN					= 42,	//! ~TC`[擾̐
			BATTERY_EXPLAIN					= 43,	//! obe[擾̐
			LETS_GO_FROM_BED				= 44,	//! xbhœƂ茾
			CLEAN_SLIMES					= 45,	//! 

			////// mercener
			MERC_EVIL						= 47,
			START_MERC						= MERC_EVIL,
			MERC_ROCK						= 49,
			MERC_WATER						= 50,
			MERC_FIRE						= 51,
			MERC_FORESET					= 52,
			MERC_WIND						= 53,
			MERC_ELECTRIC					= 54,
			MERC_TOZI						= 55,
			MERC_REST						= 56,
			END_MERC						= MERC_REST,
			///// end of mercener talk

			AFTER_CHASER					= 59,	//! chasered!
//			TOZICO_AFTER_OPEN_FRIENDLY		=,
//			TOZICO_AFTER_OPEN_ENEMY			=,
		};
	}
	namespace SpecialDeadEventID {	//! ͓ǂݍ񂾎̃CxgIDcƂŗǗ悤
		enum SpecialDeadEventID_ {
			SLIME_QUEEN,
			BEE,
			ALRAUNE,
			WORM,
			CHASER_BAD,
		};
	}
	namespace AfterFadeOutDXProcessType {
		enum {
			NONE,	//! ftHgBȂ
			RESPAWN,	//! vC[
		};

	}

	namespace ItemClassType {
		enum {
			USE_ITEM,						//! ACe
			STOCK_ITEM,						//! 邾̃ACe
			WEAPON,							//! 
			MAX_NUM
		};
	}

	/** GameScene̊ԂLȃtO
	  */
	namespace TempFlagType {
		enum {
			SWITCH_LOCK,
		};
	}

	/** m_nWeakness,m_nImmortali_ƑϐjɂĎgptO
	  * Immortalݒ肳Ă΁AWeakness͖
	  * ǂݒ肵ĂȂꍇ́Aʏ̃_[W
	  */
	namespace DamageType {
		enum DamageType_ {	// 0őB2̏搔Ȃ̂ŁA2^BULLET=1łB
			
			BULLET = 0,		//! e
			HIT,		//! Ō
			DRILL,		//! 
			CHAIN_SAW,	//!
			EXPLOSION,	//! n
			LAZER,		//! w
			FIRE,		//! 
			WATER,		//! 
			ICE,		//! X
			ELEC,		//! d
			SNIPER,		//! _
			
			MAX_NUM
		};
	}

	/** }bṽ^Cvʗp
	  */
	namespace MapType {
		enum {
			NORMAL,		//! 
			FORCE_SCROLL_X,	//! XN[Xe[W
			FORCE_SCROLL_Y,	//! cXN[Xe[W
			MID_BOSS,	//! {X
			BOSS,		//! {X
			FORCE_SCROLL_X_FASTER,	//! XN[nCXs[h

		};
	}

	namespace ForceType {
		enum {
			ALLY,		// ̒e
			ENEMY,		// G̒e
			ALL,		// 
		};
	}

	namespace AlrauneWeaponType {
		enum {
			TENTACLE,	//! G
			SCREAM,		//! 
		};
	}

	/** IXe[W̃Cxg
	  */
	namespace SelectStarSceneEffectType {
		enum {
			NONE = -1,
			BARRIER_EXPLOSION = 0,	//! f̃oAj󂳂ꂽ
		};

	}

	namespace BGType{
		// -1̏ꍇx^
		enum{
			EVIL_STAR,
			FOREST,
			SEA,
			VOLCANO,
			CLOUD,
		};
	}

	// ł߃^Cv
	namespace SolidType {
		enum {
			NONE = -1,		//! Ȃ
			CRYO = 0,		//! X
			STONE,			//! Ή
			MAX_NUM
		};
	}

	/** ̓
	  * ݂ɔw
	  */
	namespace WeaponClassType {
		enum {
			ONE_SHOT,
			LASER_SHOT,
			THROW,
			CHARGE,	// throw邪Aꉞ
			CON_SHOT,

		};
	}

	/** Vbg̃NX^Cv
	  */
	namespace ShotClassType {
		enum {
			DEFAULT,	//! eۂP̒e
			LASER,		//! גӂ蔻VbgB
		};
	}

	/** WeakHImmuneH
	  */
	namespace WeakImmuneType {
		enum {
			WEAKNESS,		//! ̍U͎_ł
			NONE,
			IMMUNITIES,		//! ̍Uɂ͑ϐL
		};
	}

	namespace StatusType {
		enum {
			NONE,
			POISON,		//! poison
			EROS,		//! eros!

		};
	}
	typedef struct GStatusData_ {
//	public:
		int m_nFrameNum;
		int m_nDamageInterval;
		int m_nDamage;
/*		GStatusData(int nFrameNum, int nInterval, int nDamage) {
			this->m_nFrameNum = nFrameNum;
			this->m_nDamageInterval = nInterval;
			this->m_nDamage = nDamage;
		}*/
	} GStatusData;

	static GStatusData STATUS_DATAS[] = {
//		GStatusData(0),
		{0,0,0},
		{30,1,1},
		{200,50,0},
	};

	namespace BrustType {	// ^Cv
		enum {
			NONE,		//! Ȃ
			REPULSE_X,	//! X˗
			ATTRACT_X,	//! X
			REPULSE,	//! SW(=m_rFanRect)̐˗
			ATTRACT,	//! SWւ̈
		};
	}
	//static const int NUM_WIDTH = 16;
	//static const int NUM_HEIGHT = 20;
	static const int NUM_POWER = 8;	//ʓIȌ
	static const HPLColor NUM_RED = HPLColor(255,0,0);
	static const HPLColor NUM_GREEN = HPLColor(0,255,0);
	static const HPLColor NUM_YELLOW = HPLColor(255,255,0 );

	static const HPLColor ZANZO_BLUE = HPLColor(0,0,255);
	static const HPLColor ZANZO_PURPLE = HPLColor( 255,0,255);
	static const HPLColor ZANZO_RED = HPLColor(255,0,0);

	// special scenario type
	namespace SpecialScenarioType {
		enum {
			NONE = -1,
			GET_ITEM = 0,
			HP,
			EVIL_GAGE,
			EVIL_ORB,
			MAX_NUM
		};
		static const char SPECIAL_SCENARIO_TYPE_LABEL[][20] = {
			"*GET_ITEM",
			"*HP",
			"*EVIL_GAGE",
			"*EVIL_ORB"
		};
		static const char SPECIAL_SEPARATOR[] = ":";
	}

	// special tile type
	namespace SpecialBlockID {
		enum SpecialBlockID_ {
			WATER_SURFACE = 15,
			WATER = 16,
			LAVA_SURFACE = 117,
			LAVA = 118,
		};
	}
	// game tile type
	namespace GameTileType {
		enum {
			NORMAL,	//! block łȂłAɃQ[ΉKv̂Ȃ^C
			WATER,	//! ԂɂȂ鐅
			LAVA,	
		};
	}
	// Q[̊^Cv(sɊւ镔)
	namespace EnvType {
		enum {
			NORMAL,	//! ʏ
			SWIM,	//! j
		};
	}

	namespace LayoutType {
		enum LayoutType_ {
			TOP_LEFT,
			TOP_RIGHT,
			BOTTOM_LEFT,
			BOTTOM_RIGHT,
		};
	}
}

//void drawUniverseSpace();
#endif
