#include "GGameScene.h"

#include "GStaticData.h"
#include <hpllib/general/HPLString.h>
//#include "GPlayerManager.h"
//#include <hpllib/system/HPLFile.h>

//#include <hpllib/action/HPLActionMoveTool.h>

//#include "GSpecialDeadScene.h"

#include <hpllib/math/HPLMath.h>

using namespace GEnum;
using namespace HPLMathConsts;
using namespace std;

void GGameScene::drawMenu(bool& bIsDrawInMenu) {
	// SpaceL[ĂԂ̓j[\ȂiPausej
	if( CheckHitKey( KEY_INPUT_SPACE ) ) {
		return;
	}

	
	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
	// wi
	HPLSequence* lpBackSeq = getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::MENU_BACK );
//	HPLRect rBackImageSrcRect = getStaticData()->getSequence(
//		SpriteType::COMMON, Sequence::Common::MENU_BACK )->getImageInformation(0);
	HPLRect rBackImageSrcRect = lpBackSeq->getImageInformation(0)->srcRect;

	//int nHandle = getStaticData()->getImageHandle(
	//	SpriteType::COMMON, Sequence::Common::MENU_BACK );

	int nX = (int)( getStaticData()->m_Setting.windowWidth / 2 - rBackImageSrcRect.getWidth() / 2 );
	int nY = (int)( getStaticData()->m_Setting.windowHeight / 2 - rBackImageSrcRect.getHeight() / 2 );

	// draw background
	SetDrawBlendMode( DX_BLENDMODE_ALPHA, 180 );
	getStaticData()->m_Basic.m_Graphics.draw(
		nX, nY, lpBackSeq );
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );

	// menu frame seq
	HPLSequence* lpFrameSeq = getStaticData()->getSequence(
		SpriteType::COMMON, Sequence::Common::MENU_FRAME );
	// draw menu frame
	getStaticData()->m_Basic.m_Graphics.draw(
		nX, nY, lpFrameSeq );

	// ύX\ȃIvVtO
	int SWITCH_FLAG_TYPES[] = {
		OptionFlagType::INMO,
		OptionFlagType::GURO,

	};
	int nSwitchFlagTypeMax = SIZEOF(SWITCH_FLAG_TYPES);

	// ACe̍s
	int nMaxItemRow = this->m_vecItemIndexes.size() / ITEMS_PER_ROW_IN_MENU;
	if( Sequence::Item::MAX_NUM % ITEMS_PER_ROW_IN_MENU != 0 ) {	//! ܂肪
		nMaxItemRow ++;
	}

	
	// ACe\
	for( int i = 0; i < this->m_vecItemIndexes.size(); i ++ ) {
		int nItemIndex = this->m_vecItemIndexes[i];

		int nItemNum = getStaticData()->m_Save.getItemNum(nItemIndex);
		if( nItemNum <= 0 ) {
			continue;
		}
		HPLSequence* lpItemSeq = getStaticData()->getSequence(
			SpriteType::ITEM, nItemIndex );

		// WvZ
		int nCoordX = i % ITEMS_PER_ROW_IN_MENU;
		int nCoordY = i / ITEMS_PER_ROW_IN_MENU;
		int nCenterX = ITEM_LEFT_IN_MENU + nCoordX * ( ITEM_WIDTH_IN_MENU + ITEM_INTERVAL_X_IN_MENU ) + ITEM_WIDTH_IN_MENU / 2;
		int nCenterY = ITEM_TOP_IN_MENU + nCoordY * (ITEM_HEIGHT_IN_MENU + ITEM_INTERVAL_Y_IN_MENU ) + ITEM_HEIGHT_IN_MENU / 2;

		getStaticData()->m_Basic.m_Graphics.draw(
			nCenterX, nCenterY, lpItemSeq, FaceDirection::LEFT,
			0, ITEM_DRAW_SCALE_RATE );

		DrawString( nCenterX - ITEM_WIDTH_IN_MENU / 2, nCenterY - ITEM_HEIGHT_IN_MENU / 2,
			HPLString::chrToStr( "x%d", nItemNum ).c_str() , GetColor(255,255,255),1  );
	}

	// ACeIg
	{
		if( this->m_nMenuY < nMaxItemRow ) {
			int nSelectLeft = 
				ITEM_LEFT_IN_MENU + this->m_nMenuX * ( ITEM_WIDTH_IN_MENU + ITEM_INTERVAL_X_IN_MENU );
			int nSelectTop = 
				ITEM_TOP_IN_MENU + this->m_nMenuY * ( ITEM_HEIGHT_IN_MENU + ITEM_INTERVAL_Y_IN_MENU );

			HPLSequence* lpSelectSeq = getStaticData()->getSequence(
				SpriteType::COMMON, Sequence::Common::MENU_SELECT_FRAME );

			DrawExtendGraph( nSelectLeft, nSelectTop, nSelectLeft + ITEM_WIDTH_IN_MENU, nSelectTop + ITEM_HEIGHT_IN_MENU,
				getStaticData()->getImageHandle( SpriteType::COMMON, Sequence::Common::MENU_SELECT_FRAME ), TRUE );
			//getStaticData()->m_Basic.m_Graphics.draw(
			//	nSelectLeft, nSelectTop, lpSelectSeq );
		}
	}

	// Eo{^
	bool bIsExitAvailable = true;	// Eo{^͎gp\H
	if( getStaticData()->m_Game.isCheat() == false ) {
		// gp
		if( getStaticData()->m_Save.getFlag( FlagType::START ) < StartType::UNTIL_FUYU_EVIL
			)
		{
			// Vт铞B܂ł͎gpłȂ
			// `[g͂ło
			bIsExitAvailable = false;
		}

		int nPlaceType = getStaticData()->m_Save.getPlaceState(
			getStaticData()->m_nSelectedStar,getStaticData()->m_nSelectedPlace );
		if( PlaceType::REVEALED == nPlaceType ||
			PlaceType::SEALED == nPlaceType ) 
		{
			// revealed sealed ͒Eos
			bIsExitAvailable = false;
		}
	}

	// J[\ړ
	{
		int nDX = 0;
		int nDY = 0;
		
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::LEFT ) ) {
			//if( this->m_nMenuY == nMaxItemRow ) {
			//	
			//	if( this->m_nMenuX > 0 ) {
					nDX = -1;
			//	}
			//}
		}
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::RIGHT ) ) {
//				if( this->m_nMenuX < ITEMS_PER_ROW_IN_MENU - 1 ) {
				nDX = 1;
			//} else if( this->m_nMenuX == ITEMS_PER_ROW_IN_MENU - 1 ) {
			//	// E[
			//	if( this->m_nMenuY < nMaxItemRow ) {
			//		// ̍s
			//	} else if( this->m_nMenuY == nMaxItemRow ) {
			//		a
			//	}
			//}
		}
		if( nDX == 0 ) {
			// ɂ͓Ȃ
			if( getStaticData()->getInputManager()->isPressedNow( KeyMap::UP ) ) {
//					if( this->m_nMenuY > 0 ) {
					nDY = -1;
//					}
			}
			if( getStaticData()->getInputManager()->isPressedNow( KeyMap::DOWN ) ) {
//					if( this->m_nMenuY < nMaxItemRow ) {
					// +1sSuperPower̂߂ɎĂ
					nDY = 1;
//					}
			}
		}
		if( nDX != 0 ) {
			this->m_nMenuX += nDX;
			if( this->m_nMenuX < 0 ) {
				// left
				if( this->m_nMenuY == 0 ) {
					// ԏ

					// back to stage select
					this->m_nMenuX = 0;
					this->m_nMenuY = nMaxItemRow + 2;
				} else if( this->m_nMenuY <= nMaxItemRow ) {	// items, super power
					// items
					this->m_nMenuX = ITEMS_PER_ROW_IN_MENU - 1;
					this->m_nMenuY --;

				} else if( this->m_nMenuY == nMaxItemRow + 1 ) {	// options
					// super power
					this->m_nMenuX = SuperPowerType::MAX_NUM - 1;
					this->m_nMenuY --;
				} else if( this->m_nMenuY == nMaxItemRow + 2 ) {	// back to stage select
					// options
					this->m_nMenuX = nSwitchFlagTypeMax - 1;
					this->m_nMenuY --;
				} else {
					HPLError::assertIt(false,
						"%s:%s(%d):Unknown menu y[%d]", __FILE__,__FUNCTION__, __LINE__,
						m_nMenuY);
				}
			} else {
				if( this->m_nMenuY < nMaxItemRow ) {	// ACe
					if( this->m_nMenuX >= ITEMS_PER_ROW_IN_MENU ) {
						//E[B
						this->m_nMenuY ++;
						this->m_nMenuX = 0;
						// ̍[ֈړ
					}
				} else if( this->m_nMenuY == nMaxItemRow ) {		// SuperPower
					if( this->m_nMenuX >= SuperPowerType::MAX_NUM ) {
						this->m_nMenuX = 0;
						this->m_nMenuY ++;
					}
				} else if( this->m_nMenuY == nMaxItemRow + 1 ) {	// options
					if( this->m_nMenuX >= nSwitchFlagTypeMax ) {
						this->m_nMenuX = 0;
						this->m_nMenuY ++;
					}
				} else if( this->m_nMenuY == nMaxItemRow + 2 ) {	// 
					//
					if( this->m_nMenuX >= SuperPowerType::MAX_NUM ) {
						// E[B
						this->m_nMenuY = 0;
						this->m_nMenuX = 0;
						// ԏ̍[ֈړ
					}
				} else {
					HPLError::assertIt(false,
						"%s:%s(%d):Unknown menu y[%d]", __FILE__,__FUNCTION__, __LINE__,
						m_nMenuY);
				}
			}
		}
		if( nDY != 0 ) {
			this->m_nMenuY += nDY;
			if( this->m_nMenuY < 0 ) {					// ԏz
				// ԉֈړ
				this->m_nMenuY = nMaxItemRow + 2;
			} else if( this->m_nMenuY > nMaxItemRow + 2) {	// ԉz
				// ԏֈړ
				this->m_nMenuY = 0;
			}

			if( this->m_nMenuY < nMaxItemRow ) {	// Item

				if( this->m_nMenuX >= ITEMS_PER_ROW_IN_MENU ) {	// ړŉE[zĂ
					this->m_nMenuX = ITEMS_PER_ROW_IN_MENU - 1;
				}
			} else if( this->m_nMenuY == nMaxItemRow + 1 ) {								// SuperPower
				if( this->m_nMenuX >= SuperPowerType::MAX_NUM ) {	// ړŉE[zĂ
					this->m_nMenuX = SuperPowerType::MAX_NUM - 1;
				}
			} else if( this->m_nMenuY == nMaxItemRow + 2 ) {	// switch flag
				if( this->m_nMenuX >= nSwitchFlagTypeMax ) {
					this->m_nMenuX = nSwitchFlagTypeMax - 1;
				}
			}
		}

		int nItemIndex = -1;
		int nNum = this->m_nMenuX + this->m_nMenuY * ITEMS_PER_ROW_IN_MENU;
		if( m_nMenuY < nMaxItemRow && nNum < Sequence::Item::MAX_NUM && nNum < (int)m_vecItemIndexes.size()) {
			nItemIndex = this->m_vecItemIndexes[ nNum ];
		}

		////////////////////////////////////////////////////////////////////////////////////////////////////
		if( nDX == 0 && nDY == 0 && getStaticData()->getInputManager()->isPressedNow( KeyMap::A ) ) {
			// I


			// SE(TODO ACẻ񕜉/擾ƂԂȂ悤ɂ邱)
			bool bIsPlayKettei = true;
			// 
			if( m_nMenuY == nMaxItemRow ) {	// Super Power
				if( getStaticData()->m_Save.m_arySuperPower[ this->m_nMenuX ] > 0 )
				{
					// ISuperPowerĂ

					// Super Power type
					int nSuperPowerType = this->m_nMenuX;

					// Ή镐
					int nWeaponType = getStaticData()->getWeaponTypeBySuperPower( nSuperPowerType );

					// GlM[
					Energy* lpEnergy = &lpPlayer->getWeapon( nWeaponType )->m_Energy;
					
					if( lpEnergy->getRemain() <= 0 ) {
						// c肪
						// ->I[uΕ[
						int nOrbNum = getStaticData()->m_Save.getFlag( FlagType::EVIL_ORB_NUM );
						if( nOrbNum > 0 ) {
							// I[u

							// gp
							getStaticData()->m_Save.setFlag( FlagType::EVIL_ORB_NUM, nOrbNum - 1 );
							getStaticData()->m_Save.save();

							// [
							lpEnergy->setRemain( lpEnergy->getMax() );

						} else {
							// buzz
							getStaticData()->m_MixerManager.play( SE::BUZZ, false );
							bIsPlayKettei = false;
							// IȂ
						}
					}
					if( bIsPlayKettei && lpEnergy->getRemain() > 0 ) {
						// I
						lpPlayer->startSuperPower( this->m_nMenuX );
						lpPlayer->setWeaponType( nWeaponType );
					}
				} else {
				}
			} else if( m_nMenuY == nMaxItemRow + 1 ) {
				// IvVύX

				getStaticData()->m_OptionData.setOptionFlag( SWITCH_FLAG_TYPES[this->m_nMenuX], 
					getStaticData()->m_OptionData.getOptionFlag( SWITCH_FLAG_TYPES[this->m_nMenuX] ) == 0 ?
					1:0 );
				getStaticData()->m_Save.save();

			} else if( m_nMenuY == nMaxItemRow + 2 ) {	// back to the select
				if( bIsExitAvailable ) {
					// back to the select 
					getStaticData()->m_Game.setMenu(false);
					getStaticData()->startFadeOutDX( SceneType::SELECT_PLACE, -1 );
				} else {
					// ܂oȂ
					// buzz
					getStaticData()->m_MixerManager.play( SE::BUZZ, false );
					bIsPlayKettei = false;
				}
			} else if( m_nMenuY < nMaxItemRow ) {
				// ACe
				if( nItemIndex >= 0 && nItemIndex < Sequence::Item::MAX_NUM ) {
					// ACeԍɕϊ\
					int nNum = getStaticData()->m_Save.getItemNum( nItemIndex );
					if( nNum > 0 ) {
						
						// Ă

						GItemSetting* lpSetting = getStaticData()->m_ObjectManager.m_ItemManager.getSetting( nItemIndex );

						if( //lpSetting->getFlagBit( ItemFlagType::UNIQUE ) ||
							lpSetting->getFlagBit( ItemFlagType::USABLE) )
						{
							// 񕜁igp\j
							// 
							getStaticData()->m_Save.setItemNum(
								nItemIndex, nNum - 1 );
						}
						// 
						//lpPlayer->getItem( nItemIndex , 1, false );

						// gpiACejorij
						lpPlayer->useOrEquipItem( nItemIndex );

					}
				}
			}
			if( bIsPlayKettei ) {
				// TODOACeȂɂɂĉς
				getStaticData()->m_MixerManager.play( SE::KETTEI, false );
			}
		}

		vector<int> vecKeyStates;
		int nMaxShortCuts = getStaticData()->m_OptionData.getOptionFlag( OptionFlagType::MAX_SHORTCUT_NUM );
/*		int ALTERNATIVE_SHORT_CUT_REGISTERY_KEYS[] = {
			KeyMap::A,
			KeyMap::B,
			KeyMap::C,
		};*/
		// shortcut
		for( int i = 0; i < nMaxShortCuts; i ++ ) {
			int nKeyIndex = KEY_INPUT_1 + i;
			int nKeyState = CheckHitKey( nKeyIndex );
			
			vecKeyStates.push_back( nKeyState );
		}
		for( int i = 0; i < nMaxShortCuts; i ++ ) {
			if( nDX == 0 && nDY == 0 && getStaticData()->m_ShortCutPaletteManager.isPressedNow( i, vecKeyStates[i]) ) {//getStaticData()->m_aryPrevShortCutKeyStates[i] == 0 ){
				if( m_nMenuY < nMaxItemRow ) {
					// item
					if( nItemIndex >= 0 && nItemIndex < Sequence::Item::MAX_NUM ) {
						if( getStaticData()->m_Save.getItemNum( nItemIndex ) > 0 ) {
							// V[gJbgɓo^
							getStaticData()->m_ShortCutPaletteManager.setValue( i, nItemIndex );
							getStaticData()->m_Save.save();

							// se
							getStaticData()->m_MixerManager.play( SE::KETTEI, false );
							// Aŏ̕Lɂ
							break;
						}
					}
				} else {
					// buzz
					getStaticData()->m_MixerManager.play( SE::BUZZ, false );
				}
			}

		
			//getStaticData()->m_aryPrevShortCutKeyStates[i] = nKeyState;
		}
		// update previous short cut key states
		getStaticData()->m_ShortCutPaletteManager.updatePreviousKeyStates( nMaxShortCuts, 
			vecKeyStates );
	}

	// SuperPower\
	int ITEM_BOTTOM = ITEM_TOP_IN_MENU + (nMaxItemRow ) * (ITEM_HEIGHT_IN_MENU + ITEM_INTERVAL_Y_IN_MENU ) ;
	{
		HPLSequence* lpSPBackSeq = getStaticData()->getSequence( SpriteType::COMMON,
			Sequence::Common::SUPER_POWER_BACK );
		int nWidth = (int)lpSPBackSeq->getImageInformation(0)->srcRect.getWidth();

		const int MENU_SUPER_POWER_TOP_DELTA = 5;


		int y = ITEM_BOTTOM + MENU_SUPER_POWER_TOP_DELTA;
		for( int i = 0; i < SuperPowerType::MAX_NUM; i ++ ) {
			if( getStaticData()->m_Save.m_arySuperPower[i] <= 0 ) {
				// ĂȂ
				continue;
			}
			int x = MENU_SUPER_POWER_LEFT + i * ( nWidth + MENU_SUPER_POWER_INTERVAL_X);
			// base
			getStaticData()->m_Basic.m_Graphics.draw(
				x, y, lpSPBackSeq );

			// icon
			getStaticData()->m_Basic.m_Graphics.draw(
				x, y, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::SUPER_POWER_00 + i ) );

//			int nFrameSequenceID = Sequence::Common::SUPER_POWER_FRAME;
		}

		// frame for super power
		if( this->m_nMenuY == nMaxItemRow ) {
			int x = MENU_SUPER_POWER_LEFT + this->m_nMenuX * ( nWidth + MENU_SUPER_POWER_INTERVAL_X);
			getStaticData()->m_Basic.m_Graphics.draw(
				x, y, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::SUPER_POWER_SELECT ) );
		}
	}

	const int ITEM_OPTION_DELTA_Y = 5;
	const int OPTION_TOP = ITEM_BOTTOM + ITEM_OPTION_DELTA_Y;// + (ITEM_HEIGHT_IN_MENU + ITEM_INTERVAL_Y_IN_MENU);

	// IvV\
	{
		char LABELS[][20] = {
			"Aѕ\",
			"O\"
		};
		const int INTERVAL_X = 120;
		const int BUTTON_DELTA_X = 80;
		const int OPTION_DELTA = 5;
		const int BUTTON_TOP = OPTION_TOP + OPTION_DELTA;

		const int MENU_SUPER_POWER_LEFT_DELTA = 300;

		for( int i = 0; i < nSwitchFlagTypeMax; i ++ ) {
			int nTextX = ITEM_LEFT_IN_MENU + MENU_SUPER_POWER_LEFT_DELTA + i * (INTERVAL_X );
			int nTextY = BUTTON_TOP;
			int nSeqID = getStaticData()->m_OptionData.getOptionFlag( SWITCH_FLAG_TYPES[i] ) != 0 ?
				Sequence::Common::MENU_ON : 
				Sequence::Common::MENU_OFF;
			// text
			DrawString(nTextX, nTextY,
				LABELS[i], GetColor(255,255,255) );

			int x = nTextX + BUTTON_DELTA_X;
			int y = BUTTON_TOP;
			getStaticData()->m_Basic.m_Graphics.draw(
				x, y, getStaticData()->getSequence( SpriteType::COMMON, nSeqID ) );
			
			// I
			if( this->m_nMenuY == nMaxItemRow + 1 ) {
				if( i == this->m_nMenuX ) {
					getStaticData()->m_Basic.m_Graphics.draw(
						x, y, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::MENU_SELECT_FRAME ) );
				}
			}
		}
	}

	// Place Select֖߂{^
	{


		HPLSequence* lpSeq = getStaticData()->getSequence(SpriteType::COMMON, Sequence::Common::BACK_TO_THE_STAGE_SELECT );
		int nWidth = (int)lpSeq->getImageInformation(0)->srcRect.getWidth();
		int x = getStaticData()->m_Setting.windowWidth / 2 - nWidth / 2;
		int y = 550;

		// selected
		bool bIsSelected = this->m_nMenuY == nMaxItemRow + 2;
		const int DARKER_BUTTON_BRIGHT = 30;
		int nBright = DARKER_BUTTON_BRIGHT;
		if( bIsExitAvailable ) {
			if( bIsSelected ) {
				nBright = getStaticData()->getButtonBright(
					lpSeq->getStepCounter(),
					lpSeq->getImageInformation(0)->waitFrame );
			} else {
				nBright = DARK_BUTTON_BRIGHT;
			}
		}
		//int nBright = getStaticData()->getButtonBright( lpSeq->getStepCounter(), lpSeq->getImageInformation(0)->waitFrame );
		//if( false == bIsExitAvailable ) {
		//	nBright = 100;
		//}
		SetDrawBright(nBright,nBright,nBright);
		getStaticData()->m_Basic.m_Graphics.draw(
			x, y, lpSeq );
		SetDrawBright( 255,255,255);

		if( bIsExitAvailable ) {
			if( bIsSelected ) {	// Aj[V͑Î
				lpSeq->step();

				// Aj[V
				lpSeq->step(BUTTON_BRINK_SPEEDUP_NUM);

			}
		} else {
			// 
			getStaticData()->m_Basic.m_Graphics.draw(
				x, y, getStaticData()->getSequence( SpriteType::COMMON,
				Sequence::Common::BACK_TO_THE_STAGE_SELECT_LOCK ) );
		}
	}
	// ɂĂ邦т\
	/*{

		//this->m_PausePlayer.m_nCurrentSequenceID = Sequence::Player::NERU;
		
		const int GLASS_LEFT = 400;
		const int GLASS_TOP = 200;

		// g
		getStaticData()->m_Basic.m_Graphics.draw(
			GLASS_LEFT, GLASS_TOP, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::MENU_EVIL_FRAME_BACK ) );

		// Gr\
		this->m_PausePlayer.draw();

		// \
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 180 );
		getStaticData()->m_Basic.m_Graphics.draw(
			GLASS_LEFT, GLASS_TOP, getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::MENU_EVIL_FRAME_GLASS ) );
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
		
	}*/

	const int HEAD_TOP = 500;
	// c@HeadxNŕ\
	{
		const int HEAD_LEFT = 600;

		HPLSequence* lpHeadSeq = getStaticData()->getSequence( SpriteType::COMMON, Sequence::Common::EVI_HEAD );
		getStaticData()->m_Basic.m_Graphics.draw(
			HEAD_LEFT, HEAD_TOP, lpHeadSeq );

		
		// \
		DrawString( 
			(int)( HEAD_LEFT + lpHeadSeq->getImageInformation(0)->srcRect.getWidth() + 10 ),
			HEAD_TOP + 12,
			HPLString::chrToStr( "x%d", lpPlayer->getRemainNum() ).c_str(), GetColor(0,0,0) );

	}

	// RC̐\
	{
		HPLSequence* lpCoinSeq = getStaticData()->getSequence( SpriteType::ITEM,
			Sequence::Item::COIN );

		const int COIN_LEFT = 500;
		const int COIN_TOP = 20;
		getStaticData()->m_Basic.m_Graphics.draw(
			COIN_LEFT, COIN_TOP, lpCoinSeq );

		DrawString( COIN_LEFT + lpCoinSeq->getImageInformation(0)->srcRect.getWidth() + 10,
			COIN_TOP, 
			HPLString::chrToStr( "x%d", getStaticData()->m_Save.getItemNum(
			Sequence::Item::COIN ) ).c_str(),
			GetColor(255,255,255));
	}

	// x\
	{
		const int LEVEL_LEFT = 380;
		DrawString(
			LEVEL_LEFT,
			HEAD_TOP + 12,
			HPLString::chrToStr( "Level:%s", LEVEL_LABELS[getStaticData()->m_OptionData.getLevelIndex()] ).c_str(),
			GetColor(0,0,0),1 );
	}

	// draw play time
	{
		// current elapse time
		GAchievementItem* lpItem = getStaticData()->m_AchievementSave.getAchievementItem( AchievementType::PLAY_LONG );
		// get elapse time ( with refresh )
		long lTime = lpItem->getCounter() + getStaticData()->m_TimeRecorder.getElapseTime( true);
		const int PLAY_TIME_LEFT = 200;
		long lHours = lTime / 3600;
		lTime -= lHours * 3600;
		long lMinutes = lTime / 60;
		lTime -= lMinutes * 60;
		long lSeconds = lTime;
		DrawString(
			PLAY_TIME_LEFT,
			HEAD_TOP + 12 ,
			HPLString::chrToStr( "Play time[%ld:%ld:%ld]",
			lHours, lMinutes, lSeconds ).c_str(), GetColor(100,100,255 ) );
	}

	bool bIsDrawDescriptionUpper = false;
	if( this->m_nMenuY == nMaxItemRow ) {
		if( getStaticData()->m_Save.m_arySuperPower[this->m_nMenuX ] > 0 ) {	// have a super power
			bIsDrawDescriptionUpper = true;
			this->drawShortCutPalette();
		}
	}

	// ĂĂJ[\̐
	if( this->m_nMenuY == nMaxItemRow ) {
		// SuperPower
		static const char DESCRIPTIONS[][1024] = {
			"̈ꐺFтXCW߂ďe甭˂܂B",
			"AEl̎FɂȂԂ炩܂B",
		};
		if( getStaticData()->m_Save.m_arySuperPower[this->m_nMenuX ] > 0 ) {	// have a super power
			// 3/2
//			getStaticData()->drawTalkFrame( false,  - getStaticData()->m_Setting.windowHeight * 1.f / 4.f);

			// HP艺ɕ\
			this->drawHP();
			bIsDrawInMenu = true;

			// ʏ㕔ɕ\
			getStaticData()->drawDescription( DESCRIPTIONS[this->m_nMenuX], false,
			- getStaticData()->m_Setting.windowHeight * 1.f / 4.f + 20 );

			//getStaticData()->drawDescription( DESCRIPTIONS[this->m_nMenuX],
			//	getStaticData()->m_Setting.windowHeight * 1 / 8);
		}
	} else if( this->m_nMenuY < nMaxItemRow ) {
		// ʏ̃ACe
		int nIndex = this->m_nMenuX + this->m_nMenuY * ITEMS_PER_ROW_IN_MENU;
		if( nIndex >= 0 && nIndex < (int)this->m_vecItemIndexes.size() ) {
			int nItem = this->m_vecItemIndexes[nIndex];
			if( getStaticData()->m_Save.getItemNum( nItem ) > 0 ) {
				// 
//				getStaticData()->drawTalkFrame(true, 0);

				// draw talk
				getStaticData()->drawDescription( getStaticData()->m_ObjectManager.m_ItemManager.getDescription(nItem).c_str(),
					true, 0 );
			}
		}
	}
	
	if( bIsDrawDescriptionUpper == false ) {
		this->drawShortCutPalette();
	}
}

void GGameScene::drawShortCutPalette() {
	GPlayer* lpPlayer = &getStaticData()->m_ObjectManager.m_Player;
	// short cuts
	{
		// ݑI𒆂̃V[gJbgCfbNX
		int nShortCutSelectIndex = getStaticData()->m_ShortCutPaletteManager.getSelectedIndex();//getShortCutIndex( lpPlayer->getWeaponType() );
		const int SHORT_CUT_LEFT = 300;
		const int SHORT_CUT_INTERVAL_X = 5;
		HPLSequence* lpSeq = getStaticData()->getSequence(SpriteType::COMMON,
			Sequence::Common::SHORT_CUT );
		HPLRect rShortCutSrcRect = lpSeq->getImageInformation(0)->srcRect;
		int nY = 50;
		const int SHORT_CUT_INDEX_DELTA_X = 5;
		const int SHORT_CUT_INDEX_DELTA_Y = 5;
		const int SHORT_CUT_ICON_DELTA_X = 30;
		const int SHORT_CUT_ICON_DELTA_Y = 30;
		for( int i = 0; i < getStaticData()->m_OptionData.getOptionFlag( OptionFlagType::MAX_SHORTCUT_NUM ); i ++ ) {
			int nX = (int)(SHORT_CUT_LEFT + i * ( rShortCutSrcRect.getWidth() + SHORT_CUT_INTERVAL_X ));
			// draw palette base
			if( i == nShortCutSelectIndex ) {
				// I𒆂̃V[gJbg
				SetDrawBright( 255,50,0);	// Ԃ
			}
			getStaticData()->m_Basic.m_Graphics.draw(
				nX, nY, lpSeq );
			if( i == nShortCutSelectIndex ) {
				// I𒆂̃V[gJbg
				SetDrawBright( 255,255,255);	// ɖ߂
			}
			// index
			DrawString( nX + SHORT_CUT_INDEX_DELTA_X, nY + SHORT_CUT_INDEX_DELTA_Y,
				HPLString::chrToStr( "%d", i+1 ).c_str(), GetColor(0,0,0) );

			// get item type from short cut
			int nItemType = getStaticData()->m_ShortCutPaletteManager.getValue(i);
			if( nItemType < 0 ) {	// no registered
				continue;
			}
			// icon
			//int nWeaponType = getStaticData()->getWeaponTypeFromItemType( nItemType );
			getStaticData()->m_Basic.m_Graphics.draw(
				nX + SHORT_CUT_ICON_DELTA_X, nY + SHORT_CUT_ICON_DELTA_Y,
				getStaticData()->getSequence( SpriteType::ITEM, 
				nItemType ), FaceDirection::LEFT, 0, ITEM_DRAW_SCALE_RATE );


		}
	}
}
