#ifndef _G_LIBRARY_SCENE_
#define _G_LIBRARY_SCENE_

#include <hpllib/scene/AbstractScene.h>
#include <hpllib/general/HPLCounter.h>


class GLibraryScene : public AbstractScene {
private:
	HPLCounter m_NextSequenceWaitCounter;	//! Aj[Vʂ̕ɂ
	int m_nObjectType;	//! IuWFNg^Cv
	int m_nType;		//! G
//	int m_nSequenceID;	//! ݂̃Aj[V^Cv

	int m_nObjectTypeCursor;	//! ObjectTypȇIʒuL
	int m_nTypeCursor;	//! ^Cv̈ʒuL(ObjectTypeύXɏ)
	int m_nTypePage;	//! y[Wԍ
	int m_nScreenType;	//! LibStateTypeiʃ^Cvj
	int m_nPage;		//! y[Wԍ
	int m_nMaxPage;		//! őy[W

	std::vector<std::string> m_vecEnemyLabels;
	std::vector<std::string> m_vecItemLabels;
	std::vector<std::string> m_vecNeutralLabels;

	HPLCounter m_cntWaitToStart;	//! n߂̃JE^
	HPLCounter m_cntWaitForNext;	//! Ă鎞
public:
	GLibraryScene();
	virtual ~GLibraryScene();
public:
	void init();
	void quit();
	void process();

private:
	void procMainObjectType();
	void procSelObjectType();

	void procMainType();
	void procSelType();

	void procMainShow();
	void procSelShow();

	int getMaxCursorY( );

	/** Gւ
	  */
	void changeEnemy();
	void clearEnemies();
	void addEnemy();

	void changeItem();
	void clearItems();
	void addItem();

	void resetPlayer();

	void startEvent();
};

#endif
