#ifndef _G_NEUTRAL_SETTING_
#define _G_NEUTRAL_SETTING_

#include <string>
#include <vector>
#include <HPLDXLib.h>

#include "GEnum.h"

class GNeutralSetting {
public:
	int m_nType;			//! Type=Sequnecen::Neutral::*
	std::string m_strName;	//! unused
	int m_aryHitRect[4];	//! pintŕێ
	bool m_bIsHitToShot;	//! hit to shot
	bool m_bIsInvinsible;	//! is invinsible
	bool m_bIsGravity;		//! is gravity
	int m_nMountType;
	std::vector<int>	m_vecExtraSequenceIDs;	//! extra!
public:
	GNeutralSetting() {
		this->m_nType = -1;
		for( int i = 0; i < SIZEOF(m_aryHitRect);i ++ ) {
			this->m_aryHitRect[i] = 0;
		}
		this->m_bIsGravity = true;
		this->m_bIsHitToShot = true;
		this->m_bIsInvinsible = false;
		this->m_nMountType = GEnum::MountType::BLOCK;
	}

	bool isHitRectEqualsSize() {
		return this->m_aryHitRect[2] == 0;
	}

};

#endif
