#ifndef _G_PLAYER_MANAGER_
#define _G_PLAYER_MANAGER_

#include "GPlayer.h"

//#include "GPlayerSetting.h"

#include <map>
#include <vector>

class GPlayerManager{
public:
	GPlayerManager();
	~GPlayerManager();
private:
	void standToWalk(GPlayer* player, HPLVector* velocityAngle);
	void walkToStand(GPlayer* player, HPLVector* velocityAngle);
	void jump(GPlayer* player, HPLVector* velocityAngle);
	void crouch(GPlayer* player, HPLVector* velocityAngle);

	void playerJump(GPlayer* player, HPLVector* velocityAngle);
public:
	void move(GPlayer* player, HPLVector* velocityAngle);
	void collisionCheck(GPlayer* player, HPLVector* center, HPLVector* velocityAngle);

	void attack(GPlayer* player, HPLVector* center, HPLVector* velocityAngle);

	/**
		AI
	*/
	void moveAI(GPlayer* player);

	/******
		ړiQΔщz)
	*/
	void moveOverObject(GPlayer* player, int direction);
	
	/**
		Gɑ΂s
	*/
	bool actionAgainstEnemy(GPlayer* player, HPLShootingObject* enemy);

	/**
		isCheckFarY㉺̍傫mF邩ǂ
	*/
	bool searchFarEnemy(GPlayer* player, bool isCheckOnlyNearY,
		bool isCheckMeleeThreshold);

	/** P̂̓Gɑ΂čUΏۂƂ邩ǂf
	  * @retval		true		
	  * @retval		false		Ȃ
	  */
	bool checkEnemy( GPlayer* player, bool isCheckOnlyNearY,
		bool isCheckMeleeThreshold, HPLShootingObject* lpEnemy );

	/**
	  */
//	void checkHitToPlayer( GPlayer* lpPlayer );

	/**
	  */
//	bool checkHitToOnePlayer( GPlayer* lpPlayer, GPlayer* lpTargetPlayer );

	/** GXLbvmF
	  */ 
	bool isSkipToSearch( GPlayer* lpPlayer, HPLShootingObject* lpTarget );

	void doAttackGun( GPlayer* lpPlayer );
	/** ̑́iˑÓj
	  */
	void doOther( GPlayer* lpPlayer, HPLVector* lpVelocityAngle );
};

#endif
