#include "GStaticData.h"

#include <hpllib/general/HPLString.h>

#include <vector>
#include <string>

using namespace std;

namespace GEnum {
	// ViIFCreateObject֘A
	namespace ScnarioCreateObject {
		namespace VelType {	// IvV
			enum {
				NONE,	//! w肵ʂ̓
				RANDOM,	//! _
			};
		}
	}
};
using namespace GEnum;

using namespace ScenarioItemConsts;

bool GStaticData::isEvent(int nEventStepType, bool bIsSceneMapChangable,
						  bool bIsEndByPlayerDeath){
	GPlayer* lpPlayer = &this->m_ObjectManager.m_Player;
	
	bool isSkip = 
		//this->m_Game.isTheWorld() ||
		//this->m_Game.isMenu() ||
		//this->m_Game.isScenario() ||
		lpPlayer->isAlive() == false;
	if(isSkip == false){
		if(this->m_lpEventPack == NULL){
			/////
			//
			HPLVector center = lpPlayer->getCenter();

			// CxgŏdȂ镔L邩mF
			HPLEventBox* box = this->m_EventBoxManager.testEventBox(center,
				this->getSetting()->tileSize);

			if(box != NULL){
				//////
				// YBOX
				//  >w肳ꂽCxgpbNs

				int index = box->getIndex();

				// vC[STANDɂ
				// ɖ߂

				lpPlayer->changeState(StateType::STAND);
				//lpPlayer->rollBackState();

				////
				// CxgpbN擾&Jn
				if(	getEventPackManager()->getEventPack(index)->test()->getType() ==
					ScenarioType::IMAGE)
				{
					this->startEvent(index, false);
					box->setActive(false);
				}


				if(this->m_lpEventPack != NULL && this->m_lpEventPack->isActive() == true){
					m_Game.setScenario(true);

					////
					// Cxgs
					this->doEventPack( nEventStepType, bIsSceneMapChangable, bIsEndByPlayerDeath);
					return true;
				}
			}else{
				return false;
			}

		}else{
			return true;

		}
	}
	return false;
}

void GStaticData::checkEvent(bool bIsSkip, int nEventStepType, bool bIsSceneMapChangable,
							 bool bIsEndByPlayerDeath)
{
	GPlayer* lpPlayer = &this->m_ObjectManager.m_Player;	// vC[nh
	
	
	if(bIsSkip == false){

		if(this->m_lpEventPack == NULL){
			HPLVector center = lpPlayer->getCenter();

			HPLEventBox* box = this->m_EventBoxManager.getEventBox(center,
				this->getSetting()->tileSize);

			if(box != NULL){
				//////
				// YBOX
				//  >w肳ꂽCxgpbNs

				int index = box->getIndex();

				////
				// CxgpbN擾&Jn
				this->startEvent(index, false);

			}
		}

		if(this->m_lpEventPack != NULL){

			if(this->m_lpEventPack->isActive() == true){
				m_Game.setScenario(true);

				////
				// Cxgs
				this->doEventPack(nEventStepType, bIsSceneMapChangable, bIsEndByPlayerDeath);
			}else {
				// ViII

				this->endScenario();
				
				// vC[̃Aj[Vɖ߂
				//lpPlayer->getSequence()->resetCounter();
				// vC[̏Ԃɖ߂
				//lpPlayer->rollBackState();
			}
			
		}else{
			m_Game.setScenario(false);
		}

		if( this->m_nEventFadeDirection > 0 && this->m_EventFadeCounter.getStepCounter() > 0 ||
			this->m_nEventFadeDirection < 0 && this->m_EventFadeCounter.getStepCounter() < 255 )
		{
 			// tF[hAEg`

			int nAlpha = (int)(255.f * this->m_EventFadeCounter.getStepCounter() / this->m_EventFadeCounter.getWaitFrame() );
			SetDrawBlendMode( DX_BLENDMODE_ALPHA,
				this->m_nEventFadeDirection > 0 ?  nAlpha : (255 - nAlpha) );
			// DrawBoxŃtF[h
			DrawBox(0,0,this->m_Setting.windowWidth, this->m_Setting.windowHeight,
				GetColor(this->m_EventFadeColor.r, this->m_EventFadeColor.g, this->m_EventFadeColor.b ), TRUE );
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
		}

		if( false == this->m_EventFadeCounter.getState().isFinishAnimation ) {
			// tF[h
			if( this->m_EventFadeCounter.step().isFinishAnimation ) {
				// tF[hXebvI
				if( this->m_lpEventPack != NULL ) {
					HPLScenarioItem* lpItem = this->m_lpEventPack->get();
					if( lpItem != NULL ) {
						if( lpItem->getType() == ScenarioType::FADE && lpItem->getFadeDirection() == this->m_nEventFadeDirection ) {
							// ()
							this->m_lpEventPack->next();
						}
					}
				}
			}
		}
	}


}

/**
	()Cxg𔭐
*/
void GStaticData::startEvent(int index, bool bIsAlwaysEnable){
//	int nFlagIndex= -1;
//	int nFlagType = -1;
//	int nAddFlag = 0;

	bool bIsSkip = false;

	if( this->m_SceneManager.getSceneType() == SceneType::GAME){// gameV[̃Cxg
		/* p^[
			-map index/flag
			-flag bit
			-flag

			ɃZ[u邩
		*/
		if( index == SpecialScenarioIndex::EVIL_HOUSE_LOBBY_MORNING_EVIGEN ) {	// house lobby good morning
			if( this->getMapIndex() == SpecialMapIndex::EVIL_HOUSE_LOBBY ) {	// house lobby
				if( this->m_Save.getFlag( GEnum::FlagType::START ) > StartType::UNTIL_LOBBY ) {	// already done
					// ͂skip
					bIsSkip = true;
					//return;
				}
			}
		} else if( index == SpecialScenarioIndex::CLEAN_SLIMES ) {	// clean slimes
			if( this->m_Save.getFlagBit( FlagType::ONE_TALK, OneTalkType::CLEAN_SLIMES ) ) {	// already done
				
				//return;
				bIsSkip = true;

			} else {	// not yet
				// done it
				this->m_Save.setFlagBit( FlagType::ONE_TALK, OneTalkType::CLEAN_SLIMES, true );
				// save
				this->m_Save.save();
			}
		} else if( index >= SpecialScenarioIndex::START_MERC &&
			index <= SpecialScenarioIndex::END_MERC )
		{
			int nStarIndex = index - SpecialScenarioIndex::START_MERC;
			if( this->m_Save.getFlagBit( FlagType::MERC_TALK, nStarIndex ) ) {	// already done
				bIsSkip = true;
			} else {	// not yet
				// done it
				this->m_Save.setFlagBit( FlagType::MERC_TALK, nStarIndex, true );
				// save
				this->m_Save.save();
			}
		} else if( index == SpecialScenarioIndex::ARYONA_EVIL_STAR ) {
			if( this->m_Save.getFlagBit(FlagType::ARYONA_MEAT, StageType::EVIL_STAR) )  {	// already talked
				// TODO aryona
				// skip
				bIsSkip = true;
			} else {
				this->m_Save.setFlagBit(FlagType::ARYONA_MEAT, StageType::EVIL_STAR, true);
				this->m_Save.save();
			}
		} else if( index == SpecialScenarioIndex::LETS_GO_FROM_BED ) {
			// xbhł̓Ƃ茾
			if( this->m_Save.getFlag( FlagType::START ) >= StartType::UNTIL_LOBBY ) {
				// r[ViIz
				// ->LZ
				bIsSkip = true;
			}
		} else if( index == SpecialScenarioIndex::TOZICO_AFTER_OPEN_EVILSTAR ) {
			// TODO ɏĂH
			// TODO korokoroĂH
			if( this->m_Save.getFlagBit(FlagType::TOZICO_MEET, StageType::EVIL_STAR)) 
			{
				// TODO tozico
				//skip
				bIsSkip = true;
			}
		} else if( index == SpecialScenarioIndex::GET_OUTTER_EVIL_HOUSE ) {	// тقo

			if( this->m_Save.getFlag( FlagType::START ) < StartType::UNTIL_BAVEL ) {	// 
				// oxO

				// EVIL_HOUSE_FRONT̏ꏊ𓾂Ȃ̂ŁAselected*͍lȂ
				//int nStar = this->m_nSelectedStar;
				//int nPlace = this->m_nSelectedPlace;
				int nStar = 0;
				int nPlace = 0;
				if( this->m_Setting.maps.getStarAndPlaceFromMapIndex( 
					SpecialMapIndex::EVIL_HOUSE_FRONT, nStar, nPlace ) == 0 ) // evil house frontnStar/nPlace擾ł
				{
					// tOXV
					this->m_Save.setFlag( FlagType::START, StartType::UNTIL_BAVEL );

					this->m_nSelectedPlace = 0;
					// Lɂ
					this->m_Save.setPlaceState( nStar, nPlace, PlaceType::REVEALED );
					// Place Select֖߂
					this->startFadeOutDX( SceneType::SELECT_PLACE, -1 );

					// save
					this->m_Save.save();

					// U߂
					bIsSkip = true;
				}
				
			}
		}
		
	}

	if( bIsSkip && bIsAlwaysEnable == false) {
		return;
	}

	// CxgX^[g
	this->m_lpEventPack = getEventPackManager()->getEventPack(index);

	if( bIsAlwaysEnable ) {
		this->m_lpEventPack->reset();
	}

	// vC[̈ړʂ0ɂ
	//this->m_ObjectManager.m_Player.setVelocityAngle(0,0);

	// VbgS
	// ȂBςɂȂBqbgȂ悤ɂ
	//this->m_ObjectManager.m_ShotManager.clear();

	// ICfbNX
	this->m_nSelectIndex = 0;

	if( this->m_SceneManager.getSceneType() == SceneType::GAME ) {
		// TODO tOViIłł悤ɂ
		if( index == SpecialScenarioIndex::EVIL_HOUSE_LOBBY_MORNING_EVIGEN ) {
			if( this->m_Save.getFlag( FlagType::START ) == StartType::EVIL_HOUSE_BED ) {
				// tOXV
				this->m_Save.setFlag( FlagType::START, StartType::UNTIL_LOBBY );
				this->m_Save.save();
			}
		}
		if( index == SpecialScenarioIndex::FIRST_BAVEL ) {
			if( this->m_Save.getFlag( FlagType::START ) == StartType::UNTIL_BAVEL  ) {
				this->m_Save.setFlag( FlagType::START, StartType::UNTIL_FUYU_EVIL );
				this->m_Save.save();
			}
		}
	}

	GPlayer* lpPlayer = &this->m_ObjectManager.m_Player;
	if( lpPlayer->getTrigger()->getTrigger( TriggerType::ON_THE_GROUND ) ) {
		// n
		// -> stand
		lpPlayer->changeState( StateType::STAND );
	} else {
		lpPlayer->changeState( StateType::FLYDOWN );
	}
	// ̏uԈړxNg0ɂ
	lpPlayer->setVelocityAngle(0,0);

}

void GStaticData::doEventPack(int nEventStepType, bool bIsSceneMapChangable,
							  bool bIsEndByPlayerDeath)
{
	HPLError::assertIt(this->m_lpEventPack != NULL && this->m_lpEventPack->isActive(),
		"G[FTTStaticData::doEventPack CxgpbNNULL܂͕ŝ܂܌Ă΂ꂽ");

	// 
	HPLScenarioItem* item = this->m_lpEventPack->get();

	if(item == NULL){
		// ACeSI

		//// fANeBx[g
		//this->m_lpEventPack->setActive(false);

		//// C[W\
		//m_EventImage.deactivate();

		this->endScenario();

	}else if(this->m_lpEventPack->isActive() == false){

		// fANeBׁ[gς
		// ViI~
//		m_Game.setScenario(false);
		this->endScenario();

	} else if( false == this->m_EventFadeCounter.getState().isFinishAnimation ) {
		// tF[hAEg܂IĂȂ
		return;
	}else if(item->getType() == ScenarioType::SE && item->getSEWaitCounter()->isAlive() == true){
		// SEł

		if(item->getSEWaitCounter()->getStepCounter() == 0){
			// ŏɖ炷
			this->m_MixerManager.play(item->getSEIndex() , false);
//			this->getMixerManager()->playSE(item->getSEIndex());
		}

		// Xebv
		item->getSEWaitCounter()->step();

		if(item->getSEWaitCounter()->isAlive() == false){
			// EGCgI

			// ̃ACe
			this->m_lpEventPack->next();
		}

	}else{
		m_Game.setScenario(true);
		

		switch( item->getType() ) {
		case ScenarioType::TALK:
		case ScenarioType::EMOTION:
		case ScenarioType::SELECT:
			break;
		case ScenarioType::MAP:
			
			//startFadeOut(item->getMapScene(), item->getMapMap());
			if( bIsSceneMapChangable ) {
				startFadeOutDX(item->getMapScene(), item->getMapMap());

				// vC[̓oʒu
				this->m_nPlayerPlaceIndex = item->getPlayerPositionIndex();
			}

			break;
		case ScenarioType::BG:
			/*
			this->bgR = item->getBGR();
			this->bgG = item->getBGG();
			this->bgB = item->getBGB();*/
			break;
		case ScenarioType::BG_IMAGE:
			//this->bgImageNormal = item->getBGImage();
			//this->bgImageMini = item->getBGImageMini();

			break;
		case ScenarioType::DARK:
//			this->darkAlpha = item->getDarkAlpha();

			break;
		case ScenarioType::FADE:
			this->m_EventFadeCounter.setWaitFrameNum( item->getFadeFrameNum() );
			this->m_EventFadeCounter.reset();
			this->m_EventFadeColor = item->getFadeColor();
			this->m_nEventFadeDirection = item->getFadeDirection();
			break;
		case ScenarioType::MUSIC:
			{
				//HPLError::msg("c", MB_OK, "%d", item->getMusicIndex());
				if(item->getMusicIndex() < 0){
					/// stop music
	//				this->getMixerManager()->fadeOutMusic(10);
				}else{
	//				this->getMixerManager()->playMusic(item->getMusicIndex());
				}
			}
			break;
		case ScenarioType::IMAGE:
			{
				// C[W\
				// C[Wo^
				if(item->getImageSpriteType() < 0 ||
					item->getImageSequenceType() < 0)
				{
					this->m_EventImage.deactivate();
				}else{
					this->m_EventImage.activate(
						item->getImageSpriteType(),
						item->getImageSequenceType(),
						(float)item->getImageLeft(),
						(float)item->getImageTop(),
						item->getImageRate(),
						item->getImageRate());
				}
			}
			break;
		case ScenarioType::UNLOCK:
			{
				// }bvAbN


				int nStar = 0;
				int nPlace = 0;
				// }bvj
				if( this->m_Setting.maps.getStarAndPlaceFromMapIndex( item->getUnlockMapIndex(), nStar, nPlace ) == 0 ) {
					if( this->m_Save.getPlaceState( nStar, nPlace ) == PlaceType::SEALED) {
						this->m_Save.setPlaceState( nStar, nPlace, PlaceType::REVEALED );
						this->m_Save.save();
					}
				} else {
					HPLError::assertIt(false,
						"%s:%s(%d):unlock target star(%d),place(%d) is not exist(unlock map index)",
						__FILE__,__FUNCTION__,__LINE__,
						nStar,nPlace,item->getUnlockMapIndex()
						);
				}
				//this->getSave()->set(GSaveListType::MAP, mapIndex, 1);

				// Ώۂ̃}bvIԂɂ
				//this->setMapSelectCursor(mapIndex);
			}
			break;
		case ScenarioType::CREATE:
			{
				//using namespace ScenarioCreateObjectConsts;
				HPLScenarioCreateObject* lpObj = item->getCreateObject();
				GPlayer* lpPlayer = &this->m_ObjectManager.m_Player;

				switch( lpObj->getObjectType() ) {
				case ObjectType::EFFECT:
					{
						HPLVector vCenter = lpObj->getCenter();
						bool bIsCancel = false;	//ς쐬ȂI
						// vC[̎ӂɍ
						switch( lpObj->m_nCenterOption ) {
						case CenterOptionType::PLAYER:
							if( lpObj->getType() >= Sequence::Effect::EI_START &&
								lpObj->getType() < Sequence::Effect::EI_MAX_NUM ) 
							{
								this->createPlayerEmotionIcon( lpObj->getType() );
								bIsCancel = true;
							} else {
								vCenter.add( lpPlayer->getCenter());
							}
							break;
						default:
							HPLError::assertIt(false,"");
						}
						if( false == bIsCancel ) {
							GEffect* lpEffect = this->m_ObjectManager.m_EffectManager.create(
								lpObj->getType(), vCenter, true );
							lpEffect->setVelocityAngle( lpObj->getVelocityAngle());
						}
					}

					break;
				default:
					HPLError::assertIt(false,"");
				}
			}
			break;
		default:
			// s

			HPLError::assertIt( false,
				"[%d]", item->getType() );
			break;
		}

		switch(item->getType() ) {
		case ScenarioType::MAP:
		case ScenarioType::MUSIC:
			//ScenarioType::SE:
		case ScenarioType::BG:
		case ScenarioType::BG_IMAGE:
		case ScenarioType::DARK:
		case ScenarioType::IMAGE:
		case ScenarioType::UNLOCK:
		case ScenarioType::CREATE:
			{
				// PR}h

				// ̃ACeցB
				this->m_lpEventPack->next();
	/*				if( == false){
						m_Game.setScenario(false);
					}*/

			}
			break;
		case ScenarioType::TALK:
		case ScenarioType::EMOTION:
		case ScenarioType::SELECT:
			{
				this->doTalkEventPack( item, nEventStepType, bIsEndByPlayerDeath );
			}
			break;
		}
	}
}

/** ViII
  */
void GStaticData::endScenario() {
	

	if( this->m_SceneManager.getSceneType() == SceneType::GAME ) {
		switch( this->m_lpEventPack->getType() ) {
		case SpecialScenarioIndex::OPENING:
			// ŏ̍ŏ
			// NAvNeBXJn
			this->m_Save.setFlag( FlagType::START, StartType::PRACTICE );
			this->m_Save.save();
			break;

		}
	}
	this->m_lpEventPack->setActive( false );
	this->m_lpEventPack = NULL;
	m_Game.setScenario(false);
	
	// C[W\
	//m_EventImage.deactivate();

}

class ImageOffset{
public:
	int x[2];
	int y[2];
	ImageOffset(){x[0] = y[0] = x[1] = y[1] = 0;}

	ImageOffset(int lx, int ly, int rx, int ry){
		x[0] = lx;
		y[0] = ly;
		x[1] = rx;
		y[1] = ry;
	}

};

/**
	G\
	@param standPos Eǂɗ邩ݒFFaceDirection::LEFT/RIGHT
*/
void GStaticData::drawStand(int standPos, int seqID){

	std::map<int, ImageOffset> offsetList;


	/*int tn[] = {
		GEnum::Neutral::TalkTanyaNormal,
		GEnum::Neutral::TalkTanyaFear,
		GEnum::Neutral::TalkTanyaHmm,
	};
	for(int i = 0; i < sizeof(tn) / sizeof(int); i ++){
		offsetList[tn[i]] =
			ImageOffset(0,0,340,0);
	}
	for(int i = GEnum::Neutral::TalkTanyaAngry; i <= GEnum::Neutral::TalkEvigenAngryCry; i ++){
		offsetList[i] =
			ImageOffset(0,0,340,0);
	}*/


	int index = seqID;
	int pos = (standPos == FaceDirection::LEFT) ? 0 : 1;
/*
	HPLSequence* seq = this->getSprite(GEnum::SpriteType::Neutral)->getPair(seqID)->right;
	
	if(pos == 1){
		seq = this->getSprite(GEnum::SpriteType::Neutral)->getPair(seqID)->left;
	}

	float rotate = 0;
	float left = static_cast<float>(offsetList[seqID].x[pos]);
	float top = static_cast<float>(offsetList[seqID].y[pos]);
	int alpha = 255;*/

	/*HPLSDLImageTool::blitRotozoomSpriteLeftTop(
		left, top, rotate,
		seq,
		this->getImageManager(),
		this->getGraphics()->getScreen(),
		alpha);*/
}

int GStaticData::drawTalkFrame( bool bIsDefault, int nTop ) {
	int nImageHandle = this->getImageHandle(
		SpriteType::COMMON, Sequence::Common::TALK_FRAME, 0 );

	// expand
	SetDrawBlendMode( DX_BLENDMODE_ALPHA, 180 );
	if( bIsDefault ) {
		nTop = this->m_Setting.windowHeight / 2;
	}
	DrawExtendGraph( 0, nTop,
		this->m_Setting.windowWidth, nTop + this->m_Setting.windowHeight / 2,
		nImageHandle, TRUE );
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );
	return nTop;
}

/**
  */
void GStaticData::drawEmotionIcon(int left, int top, int sequenceID, int emotionType,
								  int nWidth, int nHeight)
{
	float rotate = 0;
	int alpha = 255;

	int nImageHandle = this->getImageHandle( SpriteType::COMMON, 
		sequenceID );
	HPLImageInformation* info = this->getSequence(SpriteType::COMMON, sequenceID )->getImageInformation(0);
	nWidth = static_cast<int>( nWidth < 0 ? info->srcRect.getWidth() : nWidth );
	nHeight = static_cast<int>( nHeight < 0 ? info->srcRect.getHeight() : nHeight );

//	nWidth *= fRate;
//	nHeight *= fRate;
	//info->srcRect.setX(emotionType % 4 * info->srcRect.getWidth());
	//info->srcRect.setY(emotionType / 4 * info->srcRect.getHeight());

	DrawExtendGraph( left,top,
		left + nWidth, top + nHeight,
		nImageHandle, TRUE );
}


namespace HP_CMD {
	enum {
		TARGET = 1,
		OP,
		TYPE,
		MAX_NUM,
		AMOUNT = HP_CMD::MAX_NUM,
	};
	static char TYPE_MAX[] = "MAX";
	static char TYPE_RATE[] = "RATE";
	static char TYPE_ABS[] = "ABS";

	static char HP_UP[] = "オI";
	static char HP_DOWN[] = "cB";
	static char HP_SET[] = "ɂȂI";
}
namespace COMMON_OP_TYPE {
	enum {
		SET,
		ADD
	};
}
namespace COMMON_TYPE_TYPE {
	enum {
		MAX,
		RATE,
		ABS
	};
}
namespace GAGE_CMD {
	enum {
		TARGET = 1,
		OP,
		TYPE,
		AMOUNT,
	};
	static char TYPE_MAX[] = "MAX";
	static char TYPE_RATE[] = "RATE";
	static char UP[] = "I";
	static char DOWN[] = "I";
	static char SET[] = "ɂȂI";
}
namespace ORB_CMD {
	enum {
		TARGET = 1,
		ORB,
		MAX_NUM,
		OP = MAX_NUM,
		TYPE,
		AMOUNT,
	};
	static char ORB_HAVE[] = "HAVE";		//! ϓiől͒Ȃj
	static char ORB_MAX[] = "MAX";			//! őlϓi͑Bj
	static char ORB_MAX_FILL[] = "MAX_FILL";//! őlϓ{MAXï͏ȗ\j
	static char TYPE_MAX[] = "MAX";
	static char TYPE_ABS[] = "ABS";
	static char UP[] = "I";
	static char DOWN[] = "łI";
}
namespace COMMON_CMD {
	static char TARGET_PARTNER[] = "PARTNER";
	static char TARGET_PLAYER[] = "PLAYER";
	static char OP_SET[] = "SET";
	static char OP_ADD[] = "ADD";

}

GPlayer* getPlayer( string str ) {

	if( str.compare( COMMON_CMD::TARGET_PARTNER ) == 0 ) {
		// partner
		if( getStaticData()->isCOMPlayer() ) {
			// COMplayer
			return &getStaticData()->m_ObjectManager.m_COMPlayer;
		} else {
			// ȗ
			return NULL;
		}
	} else if(str.compare( COMMON_CMD::TARGET_PLAYER ) == 0 ) {
		// player
		return &getStaticData()->m_ObjectManager.m_Player;
	} else {
#ifdef _DEBUG
		HPLError::assertIt(false, "sTARGET:%s", str);
#endif
	}
#ifdef _DEBUG
	HPLError::assertIt(false, "sTARGET:%s", str);
#endif
	return NULL;
}

/** ʂ̑/ݒsƂ̕\bZ[Wpӂ
  */
void GStaticData::getAmountTalkString( const char* cszPrefix, int nOp, int nType,
									   int nAmount, int nDelta, 
		const char* cszSuffixSet, const char* cszSuffixUp, const char* cszSuffixDown,
									 string& strResult ) 
{
			// bZ[W̌̕
			string strMessageSuffix;
			if( nType == COMMON_TYPE_TYPE::MAX ) {	// MAX-UPSETŒ
				strMessageSuffix = HP_CMD::HP_SET;
			} else {
				switch( nOp ) {
				case COMMON_OP_TYPE::ADD:	// 
					strMessageSuffix = nDelta >= 0 ? cszSuffixUp : cszSuffixDown;//HP_CMD::HP_UP : HP_CMD::HP_DOWN;
					break;
				case COMMON_OP_TYPE::SET:	// ɂȂ
					strMessageSuffix = cszSuffixSet;//HP_CMD::HP_SET;
					break;
				default:
					ASSERT_IT_TYPE(nOp, "nOp");
				}
			}
			// \pl
			int nDisplayValue = 
				nOp == COMMON_OP_TYPE::SET ? nAmount : abs(nDelta);

			// l
			string strValue;
			switch( nType ) {
			case COMMON_TYPE_TYPE::MAX:
				strValue = string("ől");
				break;
			case COMMON_TYPE_TYPE::RATE:
				strValue = HPLString::chrToStr("[%d]%%", nDisplayValue);
				break;
			case COMMON_TYPE_TYPE::ABS:
				strValue = string("[%d]", nDisplayValue);
				break;
			}

			// ACeǉ͂ɕς
			strResult =
				HPLString::chrToStr( "%s%s%s",
				cszPrefix,
				strValue.c_str(),
				strMessageSuffix.c_str());
}

/** ꓮO
  */
void GStaticData::doSpecialEventBefore( int nSpecialScenarioType,
		vector<string>** lpVecMessageList,
		vector<string>& vecReplaceMessages,
		HPLScenarioItem* lpItem )
{
	if( this->m_SceneManager.getSceneType() != SceneType::GAME ) {	// not game scene
		// do nothing
		return;
	}
	switch( nSpecialScenarioType ) {
	case SpecialScenarioType::GET_ITEM:
		{
			// ACeǉpCxg


			// ACeǉ͂ɕς
			vecReplaceMessages.push_back(
				HPLString::chrToStr( "\"%s\"[%d]ɓꂽI",
				this->m_ObjectManager.m_ItemManager.getName( this->m_TakarabakoInfo.m_nItemType ).c_str(), this->m_TakarabakoInfo.m_nItemNum ) );

			*lpVecMessageList = &vecReplaceMessages;
		}
		break;
	case SpecialScenarioType::HP:
		{
			string str = lpItem->getMessageList()->at(0);
			vector<string> vecList = 
				HPLString::split(str, SpecialScenarioType::SPECIAL_SEPARATOR);
			// ","̌ɂǂꂾ邩Lq
			// Usage: *HP,TARGET,OP,^Cv,
			// -TARGET
			//  >PLAYER	FȂݖ{l
			//  >PARTNERFꏏɋlBꏏɋlLłȂꍇ͖
			// -OP
			//  >SET	Fݒ肷
			//  >ADD	FB0AMAXȏ͓ŏĂ邽ߋCɂȂėǂ
			// -^Cv
			//  >MAX	FőlwBʂ̎w͖ӖɂȂ
			//  >RATE	FőlMAX̊Ŏw
			//	>ABS	FΒlŎwBlԂ100MAXȂ̂ŊƕςȂ
			// -
			//  >l	Fł͂ȂBȗ\BȗMAX
			HPLError::assertIt( vecList.size() >= HP_CMD::MAX_NUM,
				"HPR}h̎wvfs[%s]",
				str.c_str());
			GPlayer* lpPlayer = getPlayer( vecList[HP_CMD::TARGET] );
			if( lpPlayer == NULL ) {
				return;
			}
			//HPLError::assertIt( lpPlayer != NULL, "HP:PlayerNULL[%s]",
			//	str.c_str());

			// amount
			int nAmount = lpPlayer->getHPMax();
			if( vecList.size() >= HP_CMD::AMOUNT + 1 ) {
				// amount 
				nAmount = atoi( vecList[HP_CMD::AMOUNT].c_str());
			} else {
				// Ȃ
				HPLError::assertIt( vecList[HP_CMD::TYPE].compare(HP_CMD::TYPE_MAX) == 0,
					"MAXȊO̎ɗʂȗ[%s]",
					str.c_str());
			}
			
			int nOldHP = lpPlayer->getHP();

			int nOp = COMMON_OP_TYPE::SET;
			int nType = COMMON_TYPE_TYPE::ABS;
			if( vecList[HP_CMD::TYPE].compare(HP_CMD::TYPE_MAX ) == 0 ) {	// max
				nType = COMMON_TYPE_TYPE::MAX;
			} else if( vecList[HP_CMD::TYPE].compare(HP_CMD::TYPE_RATE ) == 0 ) {	// rate
				nType = COMMON_TYPE_TYPE::RATE;
			} else if( vecList[HP_CMD::TYPE].compare(HP_CMD::TYPE_ABS ) == 0 ) {
				nType = COMMON_TYPE_TYPE::ABS;
			} else {
				HPLError::assertIt(false, "sTYPE:%s", vecList[HP_CMD::TYPE].c_str());
			}
			// op
			if( vecList[HP_CMD::OP].compare(COMMON_CMD::OP_SET ) == 0 ) {	// set
				switch( nType ) {
				case COMMON_TYPE_TYPE::MAX:
					lpPlayer->setHP( lpPlayer->getHPMax());
					break;
				case COMMON_TYPE_TYPE::RATE:
					lpPlayer->setHP( lpPlayer->getHPMax() * (float)nAmount / 100.f );
					break;
				case COMMON_TYPE_TYPE::ABS:
					lpPlayer->setHP( nAmount );
					break;
				}
			} else if( vecList[HP_CMD::OP].compare(COMMON_CMD::OP_ADD ) == 0 ) {	// add
				// add type
				nOp = COMMON_OP_TYPE::ADD;

				switch( nType ) {
				case COMMON_TYPE_TYPE::MAX:		// set max
					lpPlayer->setHP( lpPlayer->getHP() + lpPlayer->getHPMax());
					break;
				case COMMON_TYPE_TYPE::RATE:	// set rate
					lpPlayer->setHP( lpPlayer->getHP() + lpPlayer->getHPMax() * (float)nAmount / 100.f);
					break;
				case COMMON_TYPE_TYPE::ABS:		// set abs
					lpPlayer->setHP( lpPlayer->getHP() + nAmount );
					break;
				}
			} else {
				HPLError::assertIt(false, "sOP:%s", vecList[HP_CMD::OP].c_str());
			}

			// oFACe擾GrQ[WUP͕SEɂ
			if( nOldHP <= lpPlayer->getHP()) {
				// up or ̂܂
				// UP SE
			} else {
				// down or ̂܂
				// DOWN SE
			}
			
			int nDelta = lpPlayer->getHP() - nOldHP;

			/*// bZ[W̌̕
			string strMessageSuffix;
			if( nType == COMMON_TYPE_TYPE::MAX ) {	// MAX-UPSETŒ
				strMessageSuffix = HP_CMD::HP_SET;
			} else {
				switch( nOp ) {
				case COMMON_OP_TYPE::ADD:	// 
					strMessageSuffix = nDelta >= 0 ? HP_CMD::HP_UP : HP_CMD::HP_DOWN;
					break;
				case COMMON_OP_TYPE::SET:	// ɂȂ
					strMessageSuffix = HP_CMD::HP_SET;
					break;
				default:
					HPLError::assertIt(false);
				}
			}
			// \pl
			int nDisplayValue = 
				nOp == COMMON_OP_TYPE::SET ? nAmount : abs(nDelta);

			// l
			string strValue;
			switch( nType ) {
			case COMMON_TYPE_TYPE::MAX:
				strValue = string("ől");
				break;
			case COMMON_TYPE_TYPE::RATE:
				strValue = HPLString::chrToStr("[%d]%%", nDisplayValue);
				break;
			case COMMON_TYPE_TYPE::ABS:
				strValue = string("[%d]", nDisplayValue);
				break;
			}

			// ACeǉ͂ɕς
			vecReplaceMessages.push_back(
				HPLString::chrToStr( "HP%s%s",
				strValue.c_str(),
				strMessageSuffix.c_str()) );*/
			string strResult;
			this->getAmountTalkString(
				"HP", nOp, nType, nAmount, nDelta, 
				HP_CMD::HP_SET, HP_CMD::HP_UP, HP_CMD::HP_DOWN,
				strResult );

			// add
			vecReplaceMessages.push_back( strResult );

			*lpVecMessageList = &vecReplaceMessages;
		}
		break;
	case SpecialScenarioType::EVIL_GAGE:
		{
			string str = lpItem->getMessageList()->at(0);
			vector<string> vecList = 
				HPLString::split(str, SpecialScenarioType::SPECIAL_SEPARATOR);

			HPLError::assertIt( vecList.size() >= ORB_CMD::MAX_NUM, "OrbCmd̈s[%s]",
				str.c_str());
			///////
			// GrQ[Wϓ
			// Usage:*EVIL_GAGE,TARGET,OP,TYPE,AMOUNT
			// -TARGET
			//  >PLAYER
			//  >PARTNER
			// -OP
			//  >SET	ݒ
			//  >ADD	ǉ
			// -TYPE
			//  >MAX	őlwBAMOUNT͏ȗ\
			//  >RATE	wBǂ100Βlƕς񂯂ǁB
			// -AMOUNT
			//  >ʁF0<=AMOUNT<=MAX	TYPE=RATÊ݁B
			GPlayer* lpPlayer = getPlayer( vecList[GAGE_CMD::TARGET] );
			if( lpPlayer == NULL ) {
				return;
			}
			int nOldGage = (int)lpPlayer->getEvilGage();
			
			// default:max
			int nAmount = MAX_EVIL_GAGE;
			// amount
			if( vecList.size() >= GAGE_CMD::AMOUNT + 1 ) {
				nAmount = atoi(vecList[GAGE_CMD::AMOUNT].c_str() );

			} else {
				// amount̎w肪̂MAXȊO
				// ->error
				HPLError::assertIt( vecList[GAGE_CMD::TYPE].compare(GAGE_CMD::TYPE_MAX) != 0,
					"MAXȊO̎ɗʂȗ[%s]",
					str.c_str());
			}

			int nOp = COMMON_OP_TYPE::SET;
			if( vecList[GAGE_CMD::OP].compare(COMMON_CMD::OP_ADD ) == 0 ) {
				nOp = COMMON_OP_TYPE::ADD;
			} else if( vecList[GAGE_CMD::OP].compare(COMMON_CMD::OP_SET ) == 0 ) {
				nOp = COMMON_OP_TYPE::SET;
			}
			int nType = COMMON_TYPE_TYPE::ABS;
			if( vecList[GAGE_CMD::TYPE].compare(GAGE_CMD::TYPE_MAX ) == 0 ) {
				nType = COMMON_TYPE_TYPE::MAX;
			} else if( vecList[GAGE_CMD::TYPE].compare(GAGE_CMD::TYPE_RATE ) == 0 ) {
				nType = COMMON_TYPE_TYPE::RATE;
			} else {
				HPLError::assertIt(false, "sTYPE:%s", vecList[GAGE_CMD::TYPE].c_str());
			}

			// type/op
			switch( nOp ) {
			case COMMON_OP_TYPE::ADD:
				switch( nType ) {
				case COMMON_TYPE_TYPE::MAX:
					lpPlayer->setEvilGage( MAX_EVIL_GAGE );
					break;
				case COMMON_TYPE_TYPE::RATE:
					lpPlayer->setEvilGage( lpPlayer->getEvilGage() + nAmount );
					break;
				}
			case COMMON_OP_TYPE::SET:
				switch( nType ) {
				case COMMON_TYPE_TYPE::MAX:
					lpPlayer->setEvilGage( MAX_EVIL_GAGE );
					break;
				case COMMON_TYPE_TYPE::RATE:
					lpPlayer->setEvilGage( nAmount );
					break;
				}
				break;
			}

			// save?
			if( vecList[GAGE_CMD::TARGET].compare("PLAYER") == 0 ) {
				// player
				// save
				this->m_Save.setFlag( FlagType::EVIL_GAGE, (int)lpPlayer->getEvilGage() );
			}

			int nDelta = lpPlayer->getEvilGage()-nOldGage;
			/*
			// ACeǉ͂ɕς
			vecReplaceMessages.push_back(
				HPLString::chrToStr( "тQ[W[%d]%sI",
				abs( nDelta),
				nDelta >= 0 ? GAGE_CMD::UP : GAGE_CMD::DOWN) );*/
			string strResult;
			this->getAmountTalkString(
				"тQ[W", nOp, nType, nAmount, nDelta, 
				GAGE_CMD::SET, GAGE_CMD::UP, GAGE_CMD::DOWN,
				strResult );

			// add
			vecReplaceMessages.push_back( strResult );

			*lpVecMessageList = &vecReplaceMessages;
		}
		break;
	case SpecialScenarioType::EVIL_ORB:
		{
			string str = lpItem->getMessageList()->at(0);
			vector<string> vecList = 
				HPLString::split(str, SpecialScenarioType::SPECIAL_SEPARATOR);

			HPLError::assertIt( vecList.size() >= ORB_CMD::MAX_NUM, "OrbCmd̈s[%s]",
				str.c_str());
			///////
			// GrI[uϓ
			// Usage:*EVIL_ORB,TARGET,ORB,OP,TYPE,AMOUNT
			// -TARGET
			//  >PLAYER
			//  >PARTNER
			// -ORB
			//  >HAVE		̂݁BMAX͕ϓȂ
			//  >MAX		MAX̂݁B͑B
			//				́Aől<̎̂ݒ
			//  >MAX_FILL	MAX{MAX
			// -OP
			//  >SET	ݒ
			//  >ADD	ǉ
			// -TYPE
			//  >MAX	őlwBAMOUNT͏ȗ\
			//  >ABS	Βlw
			// -AMOUNT
			//  >ʁF0<=AMOUNT<=MAX	TYPE=RATÊ݁B
			GPlayer* lpPlayer = getPlayer( vecList[ORB_CMD::TARGET] );
			if( lpPlayer == NULL ) {
				return;
			}
			int nOldOrbMax = this->m_Save.getFlag( FlagType::EVIL_ORB_MAX );
			int nOldOrb = this->m_Save.getFlag( FlagType::EVIL_ORB_NUM );

			// amount
			const int INVALID_AMOUNT = -999;
			int nTempAmount = INVALID_AMOUNT;
			if( vecList.size() > ORB_CMD::AMOUNT ) {
				nTempAmount = atoi(vecList[ORB_CMD::AMOUNT].c_str());
			}
			// current amount
			int nCurrentAmount = this->m_Save.getFlag( FlagType::EVIL_ORB_NUM );
			int nCurrentMax = this->m_Save.getFlag( FlagType::EVIL_ORB_MAX );

			bool bIsInvalid = false;
			// op and type
			if( vecList[ORB_CMD::OP].compare(COMMON_CMD::OP_ADD ) == 0 ) {
				if( vecList[ORB_CMD::TYPE].compare(ORB_CMD::TYPE_MAX ) == 0 ) {
					// MAX
					if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_HAVE) == 0 ) {
						// MAXɂ
						this->m_Save.setFlag( FlagType::EVIL_ORB_NUM, 
							this->m_Save.getFlag( FlagType::EVIL_ORB_MAX ) );
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX) == 0 ) {
						// sȑgݍ킹
						bIsInvalid = true;
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX_FILL) == 0 ) {
						// sȑgݍ킹
						bIsInvalid = true;
					} else {
						bIsInvalid = true;
					}
				} else if( vecList[ORB_CMD::TYPE].compare(ORB_CMD::TYPE_ABS ) == 0 ) {
					// Βl
					if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_HAVE) == 0 ) {
						// ̂ݑ

						if( nTempAmount == INVALID_AMOUNT ) {
							// error
							bIsInvalid = true;
						} else {
							this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
								nTempAmount );
						}
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX) == 0 ) {
						// ől𑝌
						if( nTempAmount == INVALID_AMOUNT ) {
							bIsInvalid = true;
						} else {
							this->m_Save.setFlag( FlagType::EVIL_ORB_MAX,
								nCurrentMax + nTempAmount );
							if( nTempAmount > 0 ) {
								// I
								// NUM₷
								this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
									nCurrentAmount + nTempAmount );
							}
						}
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX_FILL) == 0 ) {
						// ől𑝌BNUMMAXɂ
						if( nTempAmount == INVALID_AMOUNT ) {
							bIsInvalid = true;
						} else {
							this->m_Save.setFlag( FlagType::EVIL_ORB_MAX,
								nCurrentMax + nTempAmount );
							this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
								this->m_Save.getFlag( FlagType::EVIL_ORB_MAX ) );
						}
					} else {
						bIsInvalid = true;
					}
				} else {
					HPLError::assertIt(false, "sTYPE:%s", vecList[ORB_CMD::TYPE].c_str());
				}
			} else if( vecList[ORB_CMD::OP].compare(COMMON_CMD::OP_SET ) == 0 ) {
				// set
				if( vecList[ORB_CMD::TYPE].compare(ORB_CMD::TYPE_MAX ) == 0 ) {
					// MAXw
					if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_HAVE) == 0 ) {
						// ݒ
						this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
							nCurrentMax );
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX) == 0 ) {
						// s
						bIsInvalid = true;
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX_FILL) == 0 ) {
						// s
						bIsInvalid = true;
					} else {
						bIsInvalid = true;
					}
				} else if( vecList[ORB_CMD::TYPE].compare(ORB_CMD::TYPE_ABS ) == 0 ) {
					if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_HAVE) == 0 ) {
						// ݒ
						if( nTempAmount == INVALID_AMOUNT ) {
							bIsInvalid = true;
						} else {
							this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
								nCurrentAmount + nTempAmount );
						}
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX) == 0 ) {
						// ő吔ݒ
						if( nTempAmount == INVALID_AMOUNT ) {
							bIsInvalid = true;
						} else {
							this->m_Save.setFlag( FlagType::EVIL_ORB_MAX,
								nCurrentMax + nTempAmount );
						}
					} else if( vecList[ORB_CMD::ORB].compare(ORB_CMD::ORB_MAX_FILL) == 0 ) {
						// ő吔ݒ{FULL`[W
						if( nTempAmount == INVALID_AMOUNT ) {
							bIsInvalid = true;
						} else {
							// őݒ
							this->m_Save.setFlag( FlagType::EVIL_ORB_MAX,
								nTempAmount );
							this->m_Save.setFlag( FlagType::EVIL_ORB_NUM,
								nTempAmount );
						}
					} else {
						bIsInvalid = true;
					}
				} else {
					HPLError::assertIt(false, "sTYPE:%s", vecList[ORB_CMD::TYPE].c_str());
				}
			} else {
				HPLError::assertIt(false, "sOP:%s", vecList[ORB_CMD::OP].c_str());
			}
			if( bIsInvalid ) {
				HPLError::assertIt(false, "sȑgݍ킹:%s", str.c_str());
			}

			int nDeltaMax = this->m_Save.getFlag( FlagType::EVIL_ORB_MAX) - nCurrentMax;
			int nDelta = this->m_Save.getFlag( FlagType::EVIL_ORB_NUM) - nCurrentAmount;

			// ACeǉ͂ɕς
			if( nDeltaMax != 0 ) {
				vecReplaceMessages.push_back(
					HPLString::chrToStr( "тI[uő吔[%d]%sI",
					abs( nDeltaMax),
					nDeltaMax >= 0 ? ORB_CMD::UP : ORB_CMD::DOWN) );
			}
			if( nDelta != 0 ) {
				vecReplaceMessages.push_back(
					HPLString::chrToStr( "тI[u[%d]%sI",
					abs( nDelta),
					nDelta >= 0 ? ORB_CMD::UP : ORB_CMD::DOWN) );
			}

			*lpVecMessageList = &vecReplaceMessages;
		}
		break;
	default:
		ASSERT_IT_TYPE( nSpecialScenarioType, "Special event id");
//		HPLError::assertIt(false);
	}
}
/** ꓮ㏈
  */
void GStaticData::doSpecialEventAfter( int nSpecialScenarioType ) {
	if( this->m_SceneManager.getSceneType() != SceneType::GAME ) {
		return;
	}
	switch( nSpecialScenarioType ) {
	case SpecialScenarioType::GET_ITEM:
		{
			// ACe擾bZ[W

			// ʒu(Center)
			HPLVector vCenter( this->m_Setting.windowWidth * 0.8f, this->m_Setting.windowHeight * 0.8f);

			// ACeg\
			this->m_Basic.m_Graphics.draw( (int)vCenter.getX(), (int)vCenter.getY(),
				this->getSequence( SpriteType::COMMON, Sequence::Common::TALK_ITEM ), FaceDirection::LEFT, 0, 1 );
			// ACe\
			this->m_Basic.m_Graphics.draw( (int)vCenter.getX(), (int)vCenter.getY(),
				this->getSequence( SpriteType::ITEM, this->m_TakarabakoInfo.m_nItemType ), FaceDirection::LEFT, 0, 1 );
		}
		break;
	case SpecialScenarioType::HP:
	case SpecialScenarioType::EVIL_GAGE:
	case SpecialScenarioType::EVIL_ORB:
		break;
	}
}

/** łɎsς݂`FbNAsĂȂ΃Cxgs
  * @retval	true	sĂȂ̂ŁAs

  */
bool GStaticData::checkAndStartEvent( int nFlagType, int nFlagBit, int nEventIndex ) {

	if( this->m_Save.getFlagBit( nFlagType, nFlagBit) )	// already done
	{
		//
		return false;
	} else {
		// E
		// ߂Ă̕
		// ->pbg̎gJn

		// ς݂ɂ
		this->m_Save.setFlagBit( nFlagType, nFlagBit , true );
		this->m_Save.save();
		// Jn
		this->startEvent( nEventIndex, false );
		return true;
	}
}

