#ifndef _G_SETTING_
#define _G_SETTING_


#include <hpllib/general/HPLSetting.h>
#include <hpllib/system/HPLError.h>

class PlayerSetting{
public:
	float walkMaxSpeed;
	float walkAccel;
	float airMaxSpeed;
	float airAccel;

	/**
		Wvő呬x
	*/
	float jumpSpeed;

	/**
		Wvxi=xj
	*/
	float jumpAccel;
};

class GMapSetting{
private:
	std::vector<std::vector<int> > stageList;		//! Xe[WXg
public:
	/** Xgǉ
	  */
	void addStages( std::vector<int>& lst ) {
		this->stageList.push_back(lst );
	}
	/** w肵̃Xe[W擾
	  */
	int getPlaceNum( int nStar ) {
#ifdef _DEBUG
//		HPLError::assertIt( nStar >= 0 && nStar < (int)this->stageList.size() );
		ASSERT_IT_INDEX( nStar, 0, this->stageList.size() );
#endif
		return (int)this->stageList[nStar].size();
	}
	int getMapIndexFromStarAndPlace( int nStar, int nPlace );

	/**
	  * @retval		0		I
	  * @retval		-1		݂Ȃ
	  */
	int getStarAndPlaceFromMapIndex( int nMapIndex, int& nStar, int& nPlace );

	int stageLine;
	std::vector<std::string> stageDescriptionList;	//! Xe[W
};

class GSetting: public HPLSetting{
public:
	PlayerSetting player;

	// Z蔻p臒l
	// ǂ̃LN^[̕ĂƂŁB
	float zHitRange;

	// CÂ͈
	float recognizeThreshold;

	float koguDeltaX;

	GMapSetting maps;
	
//	int maxItemNum[ItemType::MAX_NUM];
public:
	GSetting();
	virtual ~GSetting();
};

#endif
